#include <bits/stdc++.h>

using namespace std;

const int maxn = 2048;
long long c[maxn], t[maxn], p[maxn], n;
vector<int> v[maxn];
int u[maxn], used[maxn][maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> c[i];
    }
    for(int i = 1;i <= n;i++){
        cin >> t[i];
    }
    for(int i = 1;i <= n - 1;i++){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}

void bfs(int ver){
    memset(u, 0, sizeof(u));
    queue<int> q;
    q.push(ver);
    u[ver] = 1;
    used[ver][ver] = 1;
    while(!q.empty()){
        int t = q.front();
        q.pop();
        for(int x : v[t]){
            if(!u[x]){
                u[x] = u[t] + 1;
                used[ver][x] = u[t] + 1;
                q.push(x);
            }
        }
    }
}

void preCompute(){
    for(int i = 1;i <= n;i++){
        bfs(i);
    }
}

int ans = 1e9;
void check(){
    memset(u, 0, sizeof(u));
    int curr = 0;
    for(int i = 1;i <= n;i++){
        curr += c[p[i]];
        for(int j = 1;j <= n;j++){
            if(used[i][j] <= p[i]){
                u[j] = 1;
            }
        }
    }
    int cnt = 0;
    for(int i = 1;i <= n;i++){
        cnt += u[i];
    }
    if(cnt == n){
        ans = min(ans, curr);
    }
}

void brute(int pos){
    if(pos == n + 1){
        check();
        return;
    }
    for(int i = 0;i <= t[pos];i++){
        p[pos] = i;
        brute(pos + 1);
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    preCompute();
    brute(1);
    if(ans == 1e9) ans = -1;
    cout << ans << endl;
    return 0;
}
