#include <bits/stdc++.h>

using namespace std;

const long long maxn = 2048;
const long long inf = 1e18;
long long dp[maxn][maxn], c[maxn], t[maxn], cnt1[maxn], cnt2[maxn], n;
vector<long long> v[maxn];
long long used[maxn];

void read(){
    cin >> n;
    for(long long i = 1;i <= n;i++){
        cin >> c[i];
    }
    for(long long i = 1;i <= n;i++){
        cin >> t[i];
    }
    for(long long i = 1;i <= n - 1;i++){
        long long x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    long long stv = 0, finv = 0;
    for(long long i = 1;i <= n;i++){
        if(v[i].size() == 1 && stv == 0) stv = i;
        else if(v[i].size() == 1) finv = i;
    }
    long long idx = stv, curr = 1;
    used[stv] = 1;
    while(curr <= n){
        swap(t[idx], t[curr]);
        curr++;
        for(long long x : v[idx]){
            if(!used[x]){
                idx = x;
                used[x] = 1;
                break;
            }
        }
    }
}

void solve(){
    for(long long i = 1;i <= n;i++){
        for(long long j = 0;j <= n;j++){
            dp[i][j] = inf;
        }
    }
    dp[1][0] = 0;
    for(long long i = 1;i <= t[1];i++){
        dp[1][i] = c[i];
    }
    for(long long i = 2;i <= n;i++){
        for(long long j = 1;j < i;j++){
            long long dist = i - j + 1;
            if(dist <= t[j]){
                dp[i][0] = min(dp[i][0], dp[j][dist]);
            }
        }
        for(long long k = 0;k < i;k++){
            for(long long dist1 = 0;dist1 <= t[k];dist1++){
                for(long long dist2 = 1;dist2 <= t[i];dist2++){
                    if(dist1 == 0){
                        if(i - (dist2 - 1) <= k){
                            dp[i][dist2] = min(dp[i][dist2], dp[k][dist1] + c[dist2]);
                        }
                    }
                    else{
                        if(i - (dist2 - 1) <= k + dist1 - 1 || i - (dist2 - 1) - 1 == k + dist1 - 1){
                            dp[i][dist2] = min(dp[i][dist2], dp[k][dist1] + c[dist2]);
                        }
                    }
                }

            }
        }
    }/**
    for(long long i = 1;i <= n;i++, cout << endl){
        for(long long j= 0;j <= n;j++){
            cout << dp[i][j] << " ";
        }
        cout << endl;
    }*/
    long long ans = 1e9;
    for(long long i = 0;i <= n;i++){
        ans = min(ans, dp[n][i]);
    }
    if(ans == inf) ans = -1;
    cout << ans << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
