#include "coins.h"
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <chrono>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll MOD = 1e9 + 7;
const ll N = 1e5 + 7;
ll n, m, k;

pair<bool, int>elems(int l, int r) {
	if (l == r)return { true,0 };
	int len = r - l + 1;
	int mid = (l + r) / 2;
	auto lft = elems(l, mid);
	auto rgh = elems(mid + 1, r);
	vector<int>vl, vr;
	for (int i = l; i <= mid; i++) {
		vl.push_back(i);
	}
	for (int i = mid + 1; i <= r; i++) {
		vr.push_back(i);
	}
	if (!lft.ff && !rgh.ff) {
		return { false,lft.ss + rgh.ss };
	}
	int res = weigh(vl, vr);
	if (res == 0) {
		if (lft.ff && rgh.ff) {
			return { true,0 };
		}
		else if (lft.ff) {
			if (rgh.ss == 0) {
				return { false,0 };
			}
			else return { false,len };
		}
		else {
			if (lft.ss == 0) {
				return { false,0 };
			}
			else return { false,len };
		}
	}
	else if (res == -1) {
		if (lft.ff && rgh.ff) {
			return { false,len / 2 };
		}
		else if (lft.ff) {
			return { false,rgh.ss };
		}
		else {
			return { false,lft.ss + len / 2 };
		}
	}
	else {
		if (lft.ff && rgh.ff) {
			return { false,len / 2 };
		}
		else if (lft.ff) {
			return { false,rgh.ss + len / 2 };
		}
		else {
			return { false,lft.ss };
		}
	}
}

int find_heavy(int l, int r) {
	if (l == r) {
		return l;
	}
	int mid = (l + r) / 2;
	vector<int>vl, vr;
	for (int i = l; i <= mid; i++) {
		vl.push_back(i);
	}
	for (int i = mid + 1; i <= r; i++) {
		vr.push_back(i);
	}
	if (weigh(vl, vr) == -1) {
		return find_heavy(mid + 1, r);
	}
	return find_heavy(l, mid);
}

pair<int, int> count_heavy(int k) {
	n = (1ll << k);
	int ans = elems(0, n - 1).ss;
	int ind = find_heavy(0, n - 1);
	return { ans,ind };
}