#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <chrono>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e16;
const ll MOD = 1e9 + 7;
const ll N = 2007;
ll n, m;
ll c[N];
ll t[N];
vector<int>g[N];
int nxt[N];
ll dp[N][N];

void def_nxt(int v, int par = -1) {
	for (int i = 0; i < g[v].size(); i++) {
		int to = g[v][i];
		if (to != par) {
			nxt[v] = to;
			def_nxt(to, v);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> c[i];
	}
	for (int i = 1; i <= n; i++) {
		cin >> t[i];
	}
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> v >> u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	int l = -1;
	int r = -1;
	for (int i = 0; i < n; i++) {
		if (g[i].size() == 1) {
			if (l == -1)l = i;
			else r = i;
		}
	}
	def_nxt(l);
	int cur = l;
	fill(dp[0] + 1, dp[0] + n + 1, INF);
	for (int i = 1; i <= n; i++, cur = nxt[cur]) {
		for (int j = 0; j <= n; j++) {
			if (i > j) {
				dp[i][j] = dp[i - 1][j];
			}
			else {
				ll len = j - i;
				if (t[cur] < len) {
					dp[i][j] = dp[i - 1][j];
				}
				else {
					ll mn = INF;
					for (int k = max(0ll, i - len); k <= j; k++) {
						mn = min(mn, dp[i - 1][k]);
					}
					dp[i][j] = min(mn + c[len], dp[i - 1][j]);
				}
			}
		}
	}
	cout << dp[n][n] << endl;
}