#include "coins.h"
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <iomanip>
#include <string>
#include <assert.h>
using namespace std;

#define ll long long
#define ull unsigned long long
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int, int>
#define yes cout<<"YES\n"

pii count_heavy(int k) {
	int n = 1 << k;
	int l = 0, r = (1 << k) - 1;
	if (k == 1) {
		int num = weigh({ 0 }, { 1 });
		if (num == 1) {
			return make_pair(1, 0);
		}
		else {
			return make_pair(1, 1);
		}
	}
	while (1) {
		if (l == r) {
			return make_pair(1, l);
		}
		if (l == r - 1) {
			int num = weigh({ l }, { r });
			if (num == 1) {
				return make_pair(1, l);
			}
			else if (num == -1) {
				return make_pair(1, r);
			}
			else {
				return make_pair(n - 1, r);
			}
		}
		vi u1, u2;
		if ((l + r) % 2 == 0) {
			int m = (l + r) / 2;
			for (int i = l; i < m; ++i) {
				u1.push_back(i);
				u2.push_back(i + m - l);
			}
			int num = weigh(u1, u2);
			if (num == 1) {
				r = m - 1;
			}
			else if(num == -1) {
				l = m;
				--r;
			}
			else {
				u1[0] = r;
				num = weigh(u1, u2);
				if (num == 0) {
					return make_pair(n - 1, l);
				}
				else if (num == 1) {
					++l;
					r = m - 1;
				}
				else {
					l = m;
				}
			}
		}
		else {
			int m = (l + r + 1) / 2;
			for (int i = l; i < m; ++i) {
				u1.push_back(i);
				u2.push_back(i + m - l);
			}
			int num = weigh(u1, u2);
			if (num == 1) {
				r = m - 1;
			}
			else if (num == -1) {
				l = m;
			}
			else {
				return make_pair(n - 1, l);
			}
		}
	}
}