#include <iostream>
#include <vector>
using ll = long long;
using namespace std;	
vector<int> v[2005], hert;
ll gin[2005], s[10000];
int  jam[2005];
void dfs(int g, int p)
{
	hert.push_back(g);
	for (auto to : v[g])
	{
		if (to != p)
		{
			dfs(to, g);
		}
	}
}

ll inf = 1000000000000000000ll;

void build(int p, int lp, int rp)
{
	if (lp == rp)
	{
		s[p] = inf;
		return;
	}
	int m = (lp + rp) >> 1;
	build(p * 2, lp, m);
	build(p * 2 + 1, m + 1, rp);
	s[p] = min(s[p * 2], s[p * 2 + 1]);
}

void update(int p, int lp, int rp, int ind, ll x)
{
	if (lp == rp)
	{
		s[p] = min(s[p], x);
		return;
	}
	int m = (lp + rp) >> 1;
	if (ind <= m)
	{
		update(p * 2, lp, m, ind, x);
	}
	else
	{
		update(p * 2 + 1, m + 1, rp, ind, x);
	}
	s[p] = min(s[p * 2], s[p * 2 + 1]);
}

ll get_min(int p, int lp, int rp, int l, int r)
{
	if (l > r)
		return inf;
	if (l == lp && r == rp)
		return s[p];
	int m = (lp + rp) >> 1;
	return min(get_min(p * 2, lp, m, l, min(m, r)), get_min(p * 2 + 1, m + 1, rp, max(m + 1, l), r));
}

int stug[20];
int ans = 1000000000;

void Dfse(int g, int p, int erk, int hima)
{
	if (hima > erk)
		return;
	stug[g] = 1;
	for (auto to : v[g])
	{
		if(to != p)
			Dfse(to, g, erk, hima + 1);
	}
}

vector<int> pereb;
void rec(int ind, int n)
{
	if (ind > n)
	{
		int gum = 0;
		for (int i = 0; i < n; i++)
		{
			gum += gin[pereb[i]];
		}
		if (ans <= gum)
			return;
		for (int  i = 1; i <= n; i++)
		{
			stug[i] = 0;
		}
		for (int i = 1; i <= n; i++)
		{
			Dfse(i, -1, pereb[i - 1], 1);
		}
		int st = 1;
		for (int i = 1; i <= n; i++)
		{
			if (stug[i] == 0)
				st = 0;
		}
		if (st)
		{
			ans = min(ans, gum);
		}
		return;
	}
	for (int i = 0; i <= jam[ind]; i++)
	{
		pereb.push_back(i);
		rec(ind + 1, n);
		pereb.pop_back();
	}
}

void solve()
{
	int n, i, j, x, y;
	cin >> n;
	if (n <= 8)
	{
		for (i = 1; i <= n; i++)
		{
			cin >> gin[i];
		}
		for (i = 1; i <= n; i++)
		{
			cin >> jam[i];
		}
		for (i = 0; i < n - 1; i++)
		{
			cin >> x >> y;
			v[x].push_back(y);
			v[y].push_back(x);
		}
		rec(1, n);
		if (ans == 1000000000)
			cout << -1;
		else
			cout << ans;
	}
	else
	{
		for (i = 1; i <= n; i++)
		{
			cin >> gin[i];
		}
		for (i = 1; i <= n; i++)
		{
			cin >> jam[i];
		}
		for (i = 0; i < n - 1; i++)
		{
			cin >> x >> y;
			v[x].push_back(y);
			v[y].push_back(x);
		}
		for (i = 1; i <= n; i++)
		{
			if (v[i].size() == 1)
			{
				dfs(i, -1);
				break;
			}
		}
		build(1, 0, n - 1);
		for (i = 0; i < n; i++)
		{
			for (j = 1; j <= min(n, jam[hert[i]]); j++)
			{
				if (i - j < 0)
					update(1, 0, n - 1, i + j - 1, gin[j]);
				else
					update(1, 0, n - 1, i + j - 1, get_min(1, 0, n - 1, i - j, n - 1) + gin[j]);
			}
		}
		ll ans = get_min(1, 0, n - 1, n - 1, n - 1);
		if (ans == inf)
		{
			cout << -1;
		}
		else
		{
			cout << ans;
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie();
	int tt = 1;
	//cin >> tt;
	while (tt--)
	{
		solve();
	}
	return 0;
}