#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
#include "coins.h"
using namespace std;

#define ff first
#define ss second
#define mpr make_pair
#define pb push_back

pair<int, int> rec(int l, int r, bool t)
{
	int i, j;

	vector<int> va, vb;

	int m = (l + r) / 2;

	for (i = l; i <= r; i++) {
		if (i <= m) va.pb(i);
		else vb.pb(i);
	}

	int ans = weigh(va, vb);

	if (l + 1 == r) {
		if (ans == -1) return { 1, (t == 1 ? l : r) };
		if (ans == 1) return { 1, (t == 1 ? r : l) };

		return { 2, l};
	}

	pair<int, int> p, q;

	if (ans == -1) {
		p = rec(l, m, 1);
		q = rec(m + 1, r, 0);

		int h = (m - l + 1) - p.ff + q.ff;
		if (t == 0) return { h, q.ss };
		return { (r - l + 1) - h, p.ss };
	}

	if (ans == 1) {
		p = rec(l, m, 0);
		q = rec(m + 1, r, 1);

		int h = p.ff + (r - m) - q.ff;
		if (t == 0) return { h, p.ss };
		return { (r - l + 1) - h, q.ss };
	}

	p = rec(l, m, t);
	return { p.ff * 2, p.ss };
}

pair<int, int> count_heavy(int k)
{
	int i, j;

	vector<int> v;

	for (i = 1; i <= (1 << k); i++) {
		v.pb(i);
	}

	return rec(0, (1 << k) - 1, 0);

	return { 0, 0 };
}