#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
using namespace std;

#define ff first
#define ss second
#define mpr make_pair
#define pb push_back

//---------------------------------------------//

const int N = 2005;
long long c[N];
int t[N];
vector<int> g[N];
int n;

vector<int> h;

long long dp[N][N];

void dfs(int u, int p)
{
	int i, j;
	int v;

	h.pb(u);

	for (i = 0; i < g[u].size(); i++) {
		v = g[u][i];

		if (v != p) {
			dfs(v, u);
		}
	}

	return;
}

int main()
{
	int i, j;

	cin >> n;
	for (i = 1; i <= n; i++) {
		cin >> c[i];
	}
	for (i = 1; i <= n; i++) {
		cin >> t[i];
	}

	for (i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;

		g[u].pb(v);
		g[v].pb(u);
	}

	h.pb(0);

	for (i = 1; i <= n; i++) {
		if (g[i].size() == 1) {
			dfs(i, i);
			break;
		}
	}

	for (i = 0; i <= n + 1; i++) {
		for (j = 0; j <= n + 1; j++) {
			dp[i][j] = 1000000000000000005;
		}
	}

	int l, r;

	for (i = 1; i <= n; i++) {
		for (j = 1; j <= t[h[i]]; j++) {
			l = max(1, i - j + 1);
			r = min(n, i + j - 1);

			dp[l][r] = min(dp[l][r], c[j]);
		}
	}

	int k;

	for (i = 2; i <= n; i++) {
		for (l = 1; l <= n - i + 1; l++) {
			r = l + i - 1;

			for (j = l; j <= r; j++) {
				for (k = l; k <= j + 1; k++) {
					dp[l][r] = min(dp[l][r], dp[l][j] + dp[k][r]);
				}
			}
		}
	}

	/*for (i = 1; i <= n; i++) {
		for (j = i; j <= n; j++) {
			cout << i << ' ' << j << ' ' << dp[i][j] << "\n";
		}
	}*/

	if (dp[1][n] == 1000000000000000005) cout << "-1\n";
	else cout << dp[1][n] << "\n";

	return 0;
}