#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
using namespace std;

#define ff first
#define ss second
#define mpr make_pair
#define pb push_back

long long binpow(long long a, int b)
{
	long long ans = 1;
	while (b) {
		if (b & 1) ans *= a;

		a *= a;
		b >>= 1;
	}

	return ans;
}

//---------------------------------------------//

long long s[100005];

vector<pair<int, int>> v;

long long sigma(int t)
{
	int i, j;

	v.clear();

	int p, q;

	for (i = 2; i * i <= t; i++) {
		if (t % i == 0) {
			p = i;
			q = 0;
			while(t % i == 0) {
				t /= i;
				q++;
			}

			v.pb(mpr(p, q));
		}
	}

	if (t > 1) {
		v.pb(mpr(t, 1));
	}

	long long ans = 1;

	int x, y;

	for (i = 0; i < v.size(); i++) {
		x = v[i].ff;
		y = v[i].ss;

		ans *= ((binpow(x, y + 1) - 1) / (x - 1));
	}

	return ans;
}

void precalc()
{
	int i, j;

	for (i = 2; i <= 100000; i++) {
		s[i] = sigma(i) - i;
	}

	return;
}

int main()
{
	int i, j;

	precalc();

	int q, l, r, x;
	int ans;

	cin >> q;

	for (j = 1; j <= q; j++) {
		cin >> l >> r >> x;

		ans = 0;

		for (i = l; i <= r; i++) {
			if (s[i] > x) ans++;
		}

		cout << ans << "\n";
	}

	return 0;
}