// IATI_2022_Day_1.cpp : This file contains the 'main' function. Program execution begins and ends there.
/* -------------------- Includes -------------------- */
#include <algorithm>
#include <cmath>
#include <cstring>
#include <deque>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <list>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <stack>
#include <string>
#include<unordered_map>
using namespace std;
/* -------------------- Defines and Typedefs -------------------- */
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef float fl;
typedef double db;
#define fr(i,k, n) for (int i = k; i < n; i++)
#define fi for (int i=0;i<n;i++)
#define run ll t = 1; cin >> t; while(t--){solve();cout<<endl;}
#define run0 ll t = 1;  while(t--){solve();cout<<endl;}
#define yes cout<<"YES\n";
#define no cout<<"NO\n";
#define imp cout<<"IMPOSSIBLE\n";
#define br break;
#define nah cout<<-1<<endl;
#define Doctor_Strange_ ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define pb push_back
#define umap unordered_map
/* -------------------- Constants -------------------- */
const int MAX = int(1e9 + 5);
const int MIN = -1 * MAX;
const ll MAXL = ll(1e18 + 5);
const ll MOD = ll(1e9 + 7);
const ll MOD2 = ll(998244353);
const ll N = 100005;
bool ch = false;
/* -------------------- Functions -------------------- */
string fix(ll x, int p) {
	ostringstream strout;
	strout << fixed << setprecision(p) << x;
	string str = strout.str();
	return str;
}
bool isprime(long long int p) {
	for (long long int i = 2; i * i <= p; i++)
		if (p % i == 0) return false;
	return true;
}
ld max(ld a, ld b) {
	if (a < b) return b;
	else return a;
}
ld min(ld a, ld b) {
	if (a < b) return a;
	else return b;
}
ld man(ll x, ll y, ll x1, ll y1) {
	return (abs(x - x1) + abs(y - y1));
}
char cmin(char a, char b) {
	if (a > b) return b;
	else return a;
}
bool comp(pair<ll, ll> a, pair<ll, ll> b) {
	return (a.second < b.second);
}
int gcd(int a, int b) {
	return b ? gcd(b, a % b) : a;
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}
/* -------------------- Solution -------------------- */
void solve()
{
	map <ll, ll> a;
	ll l, r, v;
	cin >> l >> r >> v;
	ll q = 0;
	for (int i = 2; i <= r/2; i++)
	{
		ll x = ceil(db(l) / db(i)) * i;
		if (x == i)
		{
			a[x] -= x;
		}
		//cout <<i<<": "<< x << endl;
		for (int j = x; j <= r; j += i)
		{
			a[j] += i;
		}
	}
	for (int i=l;i<=r;i++)
	{
		//cout <<i<<": "<< a[i] << endl;
		if (a[i] >= v)
		{
			//cout << i << endl;
			q++;
		}
	 }
	cout << q << endl;
}
int main()
{
	ll q;
	cin >> q;
	while (q--)
	{
		solve();
	}
}
