#include <iostream>
#include <cmath>
#include <algorithm>
using namespace std;

const int N = 1e5 + 7;
int pref[N];

void solve() {
	int l, r, v;
	cin >> l >> r >> v;
	int m = v / 2;
	m *= m;
	int ans = 0;
	if (l < 9 && r>9 && v >= 4) {
		ans--;
	}
	if (l < 25 && r>25 && v >= 6) {
		ans--;
	}
	if (l < 49 && r>49 && v >= 8) {
		ans--;
	}
	if (l > m) {
		ans += r - l + 1 - (pref[r] - pref[l-1]);
	}
	else if (r < m && l<m) {
		for (int i = 1; i <= r; i++) {
			int x = 0;
			for (int j = 2; j <= sqrt(i); j++) {
				if (i % j == 0) {
					x += i / j;
					x += j;
				}
			}
			if (x > v) {
				ans++;
			}
		}
	}
	else {
		ans += r - m + 1 - (pref[r] - pref[l-1]);
		for (int i = l; i <= m; i++) {
			int cnt = 0;
			for (int j = 2; j <= sqrt(i); j++) {
				if (i % j == 0) {
					cnt += j;
					cnt += i / j;
				}
			}
			if (cnt > v) {
				ans++;
			}
		}
	}
	cout << ans << endl;
	/*for (int i = 1; i <= r; i++) {
		cout << pref[i] << ' ';
	}*/
}

int main() {
	for (int i = 1; i <= 1e5; i++) {
		bool f = true;
		for (int j = 2; j <= sqrt(i); j++) {
			if (i % j == 0) {
				f = false;
			}
		}
		if (f) {
			pref[i]++;
		}
		pref[i] += pref[i - 1];
	}
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}