#include <iostream>
#include <cmath>
#include <algorithm>
using namespace std;

void fastio() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}
const int N = 1e5 + 7;
int pref[N];

void solve() {
	int l, r, v;
	cin >> l >> r >> v;
	int ans = 0;
	int x = 0;
	if (r <= 49) {
		for (int i = 1; i <= r; i++) {
			ans = 0;
			for (int j = 1; j <= sqrt(i); j++) {
				if (i % j == 0) {
					ans += j;
					if (i / j != j) {
						ans += i / j;
					}
				}
			}
			if (ans-i > v) {
				x++;
			}
		}
		cout << x << '\n';
		return;
	}
	else {
		for (int i = l; i <= 49; i++) {
			ans = 0;
			for (int j = 1; j <= sqrt(i); j++) {
				if (i % j == 0) {
					ans += j;
					if (i / j != j) {
						ans += i / j;
					}
				}
			}
			if (ans-i > v) {
				x++;
			}
		}
		x += r - l - (pref[r] -pref[l-1]);
		cout << x << '\n'; return;
	}
}

int main() {
	fastio();
	for (int i = 1; i <= 1e5; i++) {
		bool f = true;
		for (int j = 2; j <= sqrt(i); j++) {
			if (i % j == 0) {
				f = false;
			}
		}
		if (f) {
			pref[i]++;
		}
		pref[i] += pref[i - 1];
	}
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}