#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAX = 1e5 + 5;
vector<int> lp(MAX);

void precomp(){
	for(int i=2 ; i<MAX ; i++){
		if(lp[i] == 0){
			lp[i] = i;
			for(int j=i*i ; j<MAX ; j+=i){
				lp[j] = i;
			}
		}
	}
}

int binpow(int a , int b){
	if(b == 0){
		return 1;
	}
	int res = binpow(a , b/2);
	if(b & 1){
		return res * res * a;
	}
	else{
		return res * res;
	}
}

void solve(){
	int l , r , need , ans = 0;
	cin >> l >> r >> need;
	for(int i=l ; i<=r ; i++){
		int number = i , sum = 1;
		map<int , int> cnt;
		while(number > 1){
			cnt[lp[number]]++;
			number /= lp[number];
		}
		for(auto j=cnt.begin() ; j!=cnt.end() ; j++){
			//cout << j->first << " " << j->second+1 << '\n'; 
			int deyer = binpow(j->first , j->second + 1);
			deyer--;
			deyer = deyer / (j->first - 1);
			sum *= deyer;
			//cout << deyer << '\n';
		}
		sum -= i;
		//cout << sum << '\n';
		if(sum > need){
			ans++;
		}
	}
	cout << ans << '\n';
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	precomp();
	int test;
	cin >> test;
	while(test--){
		solve();
	}
}