#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAX = 1e4 + 5;
vector<int> lp(MAX);
vector<int> ans(MAX);

int l , r , need;

int binpow(int a , int b){
	if(b == 0){
		return 1;
	}
	int res = binpow(a , b/2);
	if(b & 1){
		return res * res * a;
	}
	else{
		return res * res;
	}
}

void precomp(){
	for(int i=2 ; i<MAX ; i++){
		if(lp[i] == 0){
			lp[i] = i;
			for(int j=i*i ; j<MAX ; j+=i){
				lp[j] = i;
			}
		}
	}
}


void answers(){
	for(int i=2 ; i<=MAX-5 ; i++){
		int number = i;
		map<int , int> cnt;
		while(number > 1){
			cnt[lp[number]]++;
			number /= lp[number];
		}
		int answer = 1;
		for(auto j=cnt.begin() ; j!=cnt.end() ; j++){
			int deyer = (binpow(j->first , j->second+1) - 1) / (j->first - 1);
			answer *= deyer;
		}
		answer -= i;
		ans[i] = answer;
	}
}

void solve(){
	cin >> l >> r >> need;
	int cnt = 0;
	for(int i=l ; i<=r ; i++){
		if(ans[i] > need){
			cnt++;
		}
	}
	cout << cnt << '\n';
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	precomp();
	answers();
	int test;
	cin >> test;
	while(test--){
		solve();
	}
}