#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAX = 1e5 + 5;
const int sMAX = sqrt(MAX);
vector<int> lp(MAX) , answ(MAX);

void precomp(){
    int d = sqrt(sMAX);
    for(int i=2 ; i<d ; i++){
        if(lp[i] == 0){
            lp[i] = i;
            for(int j=i*i ; j<sMAX ; j+=i){
                lp[j] = i;
            }
        }
    }
}

int binpow(int a , int b){
    if(b == 0){
        return 1;
    }
    int res = binpow(a , b/2);
    if(b & 1){
        return res * res * a;
    }
    else{
        return res * res;
    }
}

void precomp1(){
    for(int i=1 ; i<=MAX ; i++){
        int ans = 1;
        map<int , int> cnt;
        int num = i;
        while(num > 1){
            if(lp[num] == 0){
                cnt[num]++;
                num = 1;
            }
            else{
                cnt[lp[num]]++;
                num /= lp[num];
            }
        }
        for(auto j=cnt.begin() ; j!=cnt.end() ; j++){
            ans *= (binpow(j->first , j->second + 1) - 1) / (j->first - 1);
        }
        answ[i] = ans - i;
    }
}

void solve(){
    int l , r , need , cnt = 0; 
    cin >> l >> r >> need;
    for(int i=l ; i<=r ; i++){
        if(answ[i] > need){
            cnt++;
        }
    }
    cout << cnt << '\n';
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    precomp();
    precomp1();
    int test;
    cin >> test;
    while(test--){
        solve();
    }
}