#include "coins.h"
typedef long long ll;
typedef unsigned long long ull;
const ll INFL = 0x3f3f3f3f3f3f3f3f;
const ull INFUL = INFL;
const int MAX = (1LL << 4);
#define WH while
#define WHI(t) WH(t--)
#define FOR(typ,i,a,b,c) for(typ i = a; i<b; i+=c)
#define FORR(typ,i,a,b,c) for(typ i = a; i>b; i-=c)
#define FORA(a,x) for(auto &x : a)
#define RET return
#define V vector
#define pii pair<int,int>
using namespace std;

pii divconq(int l, int r)
{
    if (r - l == 1)
    {
        int res = weigh({ l }, { r });
        if (!res)return { 2, l };
        else if (res == 1)return { 1,l };
        else return { 1,r };
    }
    ll m = (l + r) >> 1;
    pii lp = divconq(l, m);
    int res = 0, cnt = res, hi = -1; V<int> lpv, rpv;
    FOR(int, i, l, m + 1, 1)lpv.emplace_back(i);
    FOR(int, i, m + 1, r + 1, 1)rpv.emplace_back(i);
    res = weigh(lpv, rpv);
    if (!res)
        cnt = 2 * lp.first, hi = lp.second;
    else
    {
        pii rp = divconq(m + 1, r);
        if (lp.first == (m - l + 1) && res == -1)
            cnt = rp.first, hi = rp.second;
        else if (rp.first == (r - m) && res == 1)
            cnt = lp.first, hi = lp.second;
        else
            cnt = lp.first + rp.first, hi = lp.second;
    }
    return { cnt,hi };

}
int divconq2(int l, int r)
{
    if (l == r)return l;
    ll m = (l + r) >> 1;
    //if (0 <= l && r <= 3)return -1;
   
    if (r - l <= MAX - 1)
    {

        V<int> lpv, rpv;
        FOR(int, i, l, m + 1, 1)lpv.emplace_back(i);
        FOR(int, i, m + 1, r + 1, 1)rpv.emplace_back(i);
        ll res = weigh(lpv, rpv);
        if (!res)return -1;
        if (res == 1)return divconq2(l, m);
        return divconq2(m + 1, r);
    }
    int lr = divconq2(l, m);
    if (lr != -1)return lr;
    int rr = divconq2(m + 1, r);
    if (rr != -1) return rr;
    return -1;
}
std::pair<int, int> count_heavy(int k)
{
    ll n = (1LL << k);
    if (n == 2)
    {
        ll r = weigh({ 0 }, { 1 });
        if (r == 1)return { 1,0 };
        return { 1,1 };
    }
    ll i = divconq2(0, n - 1);
    if (i != -1)return { 1,i };
    pii mode = divconq(0, 3);
    return { n - 1, mode.second };
    
}
//4
//0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0
//o