#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(a) a.begin(),a.end()
#define alr(a) a.rbegin(),a.rend()
#define endl '\n'

vector < int> sav;
vector < int > prime(1e5 + 2), pre(1e5 + 5);
void sieve(){
    for(int i = 2 ; i < 100000+5 ; i++){
        if(!prime[i]){
            pre[i] = 1;
            for(int j = i ; j <= 100000 ; j += i) prime[j] = i; 
            sav.push_back(i);
        }
    }
    for(int i = 2; i <= 100000 ; i++){
        pre[i] += pre[i - 1];
    }
}
struct segtree{
    int sz;
    vector < vector < int > > tree;
    void resz(int n){
        sz = 1;
        while(sz < n) sz *= 2 ;
        tree = vector < vector < int > > (sz * 2);
        return;
    }
    vector < int > merge(vector < int > a , vector < int > b){
        vector < int > c = a;
        for(auto i : b) c.push_back(i);
        sort(all(c));
        return c;
    }
    void build(vector < int > &a, int x, int lx, int rx){
        if(rx - lx == 0){
            tree[x].push_back(a[lx]);
            return;
        }
        int mid = (lx + rx) >> 1;
        build(a, 2 * x, lx, mid);
        build(a, 2 * x + 1, mid + 1, rx);
        tree[x] = merge(tree[x * 2], tree[x * 2 + 1]);
    }
    void build(vector < int > &a){build(a,1,0,sz-1);}

    int get(int l , int r , int x , int lx , int rx, int val){
        if(lx > r || l > rx) return 0;
        if(lx >= l && rx <= r){
            return tree[x].size() - (lower_bound(all(tree[x]), val+1) - tree[x].begin());
        }
        int mid = (lx + rx) >> 1;
        int a = get(l, r, x * 2, lx, mid, val);
        int b = get(l, r, x * 2 + 1, mid + 1, rx, val);
        return a + b;
    }
    int get(int l, int r , int val){return get(l,r,1,0,sz-1,val);}
};
signed main(){
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    sieve();
    vector < int > sm, idx(100003);
    for(int i = 4 ; i <= 100000;i ++ ){
        int summ = 1, lol = 1, mak = 1, ll = i, div;
        while(ll > 1){
            div = prime[ll];
            while(ll % div == 0){
                ll /= div;
                lol += (mak *= div);
            }
            summ *= lol;
            lol = mak =1;
        }
        if(summ - i == 1) continue;
        idx[i] = sm.size();
        sm.push_back(summ - i);
    }
    // cout << idx[4] << endl;/
    int val = idx[100000];
    for(int i = 100000-1 ; i >= 0 ; i--) 
    {if(idx[i]||i==4)val=idx[i];idx[i] = val;}; 
    segtree s;
    s.resz(sm.size());
    s.build(sm);
    // for(int i = 0 ; i < 20 ; i ++) cout << sm[i] << ' ';
    // cout << endl;
    // for(int i = 0 ; i < 20 ; i ++) cout << idx[i] << ' ';
    // cout << endl;
    int t;
    cin >> t;
    while(t--){
        int l , r , v;
        cin >> l >> r >> v;
        // cout << idx[l] << ' ' << idx[r] << ' ';
        // cout << v << endl;
        cout << s.get(idx[l],idx[r],v) << endl;
    }
    return 0;
}