#include "coins.h"
#include <map>
using namespace std;

int really_heavy = -1;
map<pair<int, int>, int> anses;

int really_count_heavy(int l, int r) {
	int res;
	if (anses.find({ l, r }) != anses.end()) {
		res = anses[{l, r}];
	}
	else {
		int mg = (r + l) / 2;
		vector<int> a, b;
		for (int i = l; i < mg; ++i) {
			a.push_back(i);
		}
		for (int i = mg; i < r; ++i) {
			b.push_back(i);
		}
		res = weigh(a, b);
		anses[{l, r}] = res;
	}
	if (l + 2 == r) {
		if (res == 0) {
			if (l + 1 == really_heavy || l == really_heavy) {
				return 2;
			}
			int niceres = weigh({ really_heavy }, { l });
			if (niceres == 0)
				return 2;
			else
				return 0;
		} else {
			return 1;
		}
	}
	int mg = (r + l) / 2;
	if (res == 0) {
		return really_count_heavy(l, mg) * 2;
	}
	else {
		return really_count_heavy(l, mg) + really_count_heavy(mg, r);
	}
}

pair<int, int> count_heavy(int k) {
	int n = 1;
	for (int i = 0; i < k; ++i)
		n *= 2;
	int l = 0, r = n;
	while (r - l > 1) {
		int mg = (r + l) / 2;
		vector<int> a, b;
		for (int i = l; i < mg; ++i) {
			a.push_back(i);
		}
		for (int i = mg; i < r; ++i) {
			b.push_back(i);
		}
		int res = weigh(a, b);
		anses[{l, r}] = res;
		if (res >= 0)
			r = mg;
		else {
			l = mg;
		}
	}
	really_heavy = l;
	return { really_count_heavy(0, n), really_heavy };
}