#include "coins.h"
#include <map>
#include <iostream>
using namespace std;

int really_heavy = -1;
int _k, n;
map<pair<int, int>, int> anses;

int ask(int l, int r) {
	if (r > n)
		return -2;
	if (anses.find({ l, r }) != anses.end()) {
		return anses[{l, r}];
	}
	int mg = (r + l) / 2;
	vector<int> a, b;
	for (int i = l; i < mg; ++i) {
		a.push_back(i);
	}
	for (int i = mg; i < r; ++i) {
		b.push_back(i);
	}
	int res = weigh(a, b);
	anses[{l, r}] = res;
	return res;
}

int ask(int i) {
	if (i == really_heavy)
		return 1;
	return weigh({ i }, { really_heavy }) == 0;
}

pair<int, int> really_count_heavy(int s, int _max) {
	int heavys = 0;
	int fres = ask(s, s + 2);
	if (fres == 1 || fres == -1)
		heavys = 1;
	else {
		heavys = 2 * ask(s);
	}
	int sz = 2;
	while (s + sz < _max) {
		if (ask(s, s + 2 * sz) == 0) {
			heavys *= 2;
			sz *= 2;
		}
		else {
			auto [nheavys, next] = really_count_heavy(s + sz, s + 2 * sz);
			sz = next - s;
			heavys += nheavys;
		}
	}
	return { heavys, s + sz };
}

int try_to_count(int s, int k) {
	int sz = 1 << k;
	if (k <= 4)
		return really_count_heavy(s, s + sz).first;
	else {
		return try_to_count(s, k - 1) + try_to_count(s + sz / 2, k - 1);
	}
}

pair<int, int> count_heavy(int k) {
	_k = k;
	n = 1;
	for (int i = 0; i < k; ++i)
		n *= 2;
	int l = 0, r = n;
	while (r - l > 1) {
		int mg = (r + l) / 2;
		int res = ask(l, r);
		if (res >= 0)
			r = mg;
		else {
			l = mg;
		}
	}
	really_heavy = l;
	return { try_to_count(0, k), really_heavy};
}