#include "bits/stdc++.h"
#pragma GCC optimize("O3,unroll-loops")
#pragma target("avx,avx2,sse,sse2,sse3,ssse")
using namespace std;

//const int N = 100000;
//const int sz = 131072;
//constexpr long long s[N + 1];
//vector<long long> tree[2 * sz];
//
//void build(int x, int lx, int rx) {
//    if (rx - lx == 1) {
//        if (lx < (int)size(s)) {
//            tree[x].push_back(s[lx]);
//        }
//    } else {
//        int m = (lx + rx) / 2;
//        build(2 * x + 1, lx, m);
//        build(2 * x + 2, m, rx);
//        tree[x].resize(rx - lx);
//        merge(
//                tree[2 * x + 1].begin(),
//                tree[2 * x + 1].end(),
//                tree[2 * x + 2].begin(),
//                tree[2 * x + 2].end(),
//                tree[x].begin()
//        );
//    }
//}
//
//int get(int l, int r, int k, int x, int lx, int rx) {
//    if (r <= lx || rx <= l) {
//        return 0;
//    } else if (l <= lx && rx <= r) {
//        int res = (int)(tree[x].end() - upper_bound(tree[x].begin(), tree[x].end(), k));
//        return res;
//    } else {
//        int m = (lx + rx) / 2;
//        int s1 = get(l, r, k, 2 * x + 1, lx, m);
//        int s2 = get(l, r, k, 2 * x + 2, m, rx);
//        return s1 + s2;
//    }
//}
//
//inline int get(int l, int r, int k) {
//    return get(l, r, k, 0, 0, sz);
//}

struct sigma {
    static const int N = 100000;
    long long s[N + 1];

    constexpr void build_s() {
        for (int i = 0; i <= N; i++) {
            s[i] = 0;
        }
        for (int i = 1; i <= N; i++) {
            for (int j = 2 * i; j <= N; j += i) {
                s[j] = s[j] + i;
            }
        }
    }

    long long operator[](size_t i) {
        return s[i];
    }

    constexpr sigma() {
        build_s();
    }
};

void solve() {
    sigma s;

    int q;
    cin >> q;
    while (q--) {
        int l, r, v;
        cin >> l >> r >> v;

        int ans = 0;
        for (int i = l; i <= r; i++) {
            if (v < s[i]) {
                ans++;
            }
        }

        cout << ans << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef local
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}