#include <iostream>
#include <bits/stdc++.h>
//#include "coins.h"
#define ll long long
using namespace std;
int weigh(const vector<int> &a, const vector<int> &b);
pair<int, int> count_heavy(int k) {
    ll n = (1 << k);
    if (k <= 5) {
        ll num = 0, ans = 1;
        ll qwe = 0;
        vector <int > wnum = {num};
        bool c = 0;
        ll c1, c2, c3 = c2 = c1 = 0;
        for (ll i = 1; i < n; i++) {
            vector <int > h = {i};
            ll o = weigh(wnum, h);
            if (o == 1) {
                c1++;
            } else if (o == 0) {
                c2++;
            } else {
                c3++;
                qwe = i;
            }
        }
        if (c1) {
            ans = c1 + c2;
            num = 0;
        } else {
            ans = c3;
            num = qwe;
        }
        return {ans, num};
    }
    ll num = -1, ans = 1;
    queue <pair <ll, ll > > q;
    // 1
    q.push({0ll, n});
    while (!q.empty()) {
        auto [l, r] = q.front();
        q.pop();
        vector <int > a;
        ll md = (r + l) >> 1;
        for (ll i = l; i < md; i++) {
            a.push_back(i);
        }
        vector <int > b;
        for (ll i = md; i < r; i++) {
            b.push_back(i);
        }
        if (r - l == 2) {
            ll ask = weigh(a, b);
            if (ask == -1) {
                num = l + 1;
            } else {
                num = l;
            }
        } else {
            ll ask = weigh(a, b);
            if (ask == -1) {
                q.push({md, r});
            } else if (ask == 1) {
                q.push({l, md});
            } else {
                q.push({md, r});
                q.push({l, md});
            }
        }
    }
    vector <int > wnum = {num};
    vector <int > qqq = {(num + 1) % n};
    ll o = weigh(wnum, qqq);
    if (o == 1) {
        return {1, num};
    } else {
        return {n - 1, num};
    }
}

const int _MAX_CALLS = 10000;
vector<bool> _heavyOrLight, _used;
int _cnt_calls = 0;

int weigh(const vector<int> &a, const vector<int> &b)
{
    if (++_cnt_calls > _MAX_CALLS)
    {
        cerr << "Maximum number of calls exceeded!" << endl;
        exit(0);
    }

    cerr << "Weigh called with:" << endl;
    cerr << "A = {";
    for (int i = 0; i < a.size(); ++ i)
    {
        cerr << a[i];
        if (i + 1 != a.size()) cerr << ", ";
    }
    cerr << "}" << endl;
    cerr << "B = {";
    for (int i = 0; i < b.size(); ++ i)
    {
        cerr << b[i];
        if (i + 1 != b.size()) cerr << ", ";
    }
    cerr << "}" << endl;

    if (a.size() != b.size())
    {
        cerr << "Different set sizes!" << endl;
        cerr << "A contains " << a.size() << "coins while B contains " << b.size() << "coins." << endl;
        exit(0);
    }

    int heavyA = 0, heavyB = 0;
    for (int i = 0; i < a.size(); ++ i)
    {
        if (a[i] < 0 or a[i] >= _heavyOrLight.size())
        {
            cerr << "Invalid coin index!" << endl;
            cerr << a[i] << " is not a valid index of a coin." << endl;
            exit(0);
        }
        if (_used[a[i]])
        {
            cerr << "Repeated use of a coin!" << endl;
            cerr << "The coins with index " << a[i] << " is present more than once in the sets." << endl;
            exit(0);
        }
        _used[a[i]] = true;
        if (_heavyOrLight[a[i]]) heavyA++;
    }
    for (int i = 0; i < b.size(); ++ i)
    {
        if (b[i] < 0 or b[i] >= _heavyOrLight.size())
        {
            cerr << "Invalid coin index!" << endl;
            cerr << b[i] << " is not a valid index of a coin." << endl;
            exit(0);
        }
        if (_used[b[i]])
        {
            cerr << "Repeated use of a coin!" << endl;
            cerr << "The coins with index " << b[i] << " is present more than once in the sets." << endl;
            exit(0);
        }
        _used[b[i]] = true;
        if (_heavyOrLight[b[i]]) heavyB++;
    }

    for (int i = 0; i < a.size(); ++ i)
    {
        _used[a[i]] = false;
    }
    for (int i = 0; i < b.size(); ++ i)
    {
        _used[b[i]] = false;
    }

    if (heavyA < heavyB)
    {
        cerr << "B is heavier than A" << endl;
        return -1;
    }
    if (heavyA > heavyB)
    {
        cerr << "A is heavier than B" << endl;
        return +1;
    }
    cerr << "A and B are equally heavy" << endl;
    return 0;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);cerr.tie(0);
    int k, n, cnt = 0;
    cin >> k;
    n = 1 << k;
    for (int i = 0; i < n; ++ i)
    {
        int x;
        cin >> x;
        _heavyOrLight.push_back(x);
        cnt += x;
    }
    _used.resize(n);

    auto ans = count_heavy(k);

    cerr << "Your function called weigh() " << _cnt_calls << " times" << endl;
    cerr << "According to your function:" << endl;
    cerr << "1) The number of heavy coins is " << ans.first << "." << endl;
    cerr << "2) The coin with index " << ans.second << " is heavy." << endl;

    bool correct = true;
    if (ans.first != cnt)
    {
        cerr << "The true count of heavy coins is " << cnt << endl;
        correct = false;
    }
    if (ans.second < 0 or ans.second >= n)
    {
        cerr << ans.second << " is not a valid index of a coin!" << endl;
        correct = false;
    }
    else if (!_heavyOrLight[ans.second])
    {
        cerr << "The coin with index " << ans.second << " is not heavy!" << endl;
        correct = false;
    }

    if (correct) cerr << "Correct answer!" << endl;
    else cerr << "Wrong answer!" << endl;

    return 0;
}
