#include "coins.h"
#include<bits/stdc++.h>

using namespace std;

typedef int ll;

const ll INF = 2000000000;

mt19937 rnd(time(0));

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

pair<int, int> count_heavy(int kk) {
	ll n = (1 << kk);
	if (kk <= 5) {
    vector<int> a, b;
    int num = -1, col = 0;
    int last = -1;
    vector<int> lasts(1, 0);
    for (ll i = 1; i < n; i++) {
        a.push_back(i - 1);
        b.push_back(i);
        ll check = weigh(a, b);
        if (check == 0) {
            if (last == -1) {
                lasts.push_back(i);
            } else {
                col += last == 1;
            }
        }
        if (check == -1) {
            last = 1;
            col++;
            num = i;
            lasts.clear();
        }
        if (check == 1) {
            col += lasts.size();
            if (!lasts.empty()) {
                num = lasts.back();
            }
            lasts.clear();
            last = 0;
        }
        a.pop_back();
        b.pop_back();
    }
    return make_pair(col, num);
	}
	ll k = min(n, max(2, (1 << (kk / 2 + 1))));
	ll sb = n / k;
	vector<vector<int>> block(k);
	vector<int> a(n);
	for (ll i = 0; i < n; i++) {
		a[i] = i;
	}
	shuffle(a.begin(), a.end(), rnd);
	for (ll i = 0; i < n; i++) {
		block[i / sb].push_back(a[i]);
	}
	ll check = weigh(block[0], block[1]);
	ll maxb = 0, minb = 1;
	if (check == -1) {
		swap(maxb, minb);
	}
	for (ll i = 2; i < k; i++) {
		ll check = weigh(block[maxb], block[i]);
		if (check == -1) {
			maxb = i;
		}
		if (check == 1) {
			check = weigh(block[minb], block[i]);
			if (check == 1) {
				minb = i;
			}
		}
	}
	vector<ll> at, al;
	ll last = -1;
	vector<ll> all(1, block[minb][0]);
	ll cm = 0;
	for (ll i = 1; i < sb; i++) {
		vector<ll> a, b;
		a.push_back(block[minb][i]);
		b.push_back(block[minb][i - 1]);
		ll check = weigh(b, a);
		if (check == 0) {
			if (last == -1) {
				all.push_back(block[minb][i]);
			} else {
				if (last == 1) {
					cm++;
					at.push_back(block[minb][i]);
				} else {
					al.push_back(block[minb][i]);
				}
			}
		}
		if (check == -1) {
			for (auto i : all) {
				al.push_back(i);
			}
			all.clear();
			last = 1;
			cm++;
			at.push_back(block[minb][i]);
		}
		if (check == 1) {
			for (auto i : all) {
				at.push_back(i);
				cm++;
				cerr << i << endl;
			}
			all.clear();
			last = 0;
			al.push_back(block[minb][i]);
		}
	}
	for (auto i : all) {
		al.push_back(i);
	}
	all.clear();
	all.resize(1, block[maxb][0]);
	ll cb = 0;
	last = -1;
	for (ll i = 1; i < sb; i++) {
		vector<ll> a, b;
		a.push_back(block[maxb][i]);
		b.push_back(block[maxb][i - 1]);
		ll check = weigh(b, a);
		if (check == 0) {
			if (last == -1) {
				all.push_back(block[maxb][i]);
			} else {
				if (last == 1) {
					cb++;
					at.push_back(block[maxb][i]);
				} else {
					al.push_back(block[maxb][i]);
				}
			}
		}
		if (check == -1) {
			for (auto i : all) {
				al.push_back(i);
			}
			all.clear();
			last = 1;
			cb++;
			at.push_back(block[maxb][i]);
		}
		if (check == 1) {
			for (auto i : all) {
				at.push_back(i);
				cb++;
			}
			all.clear();
			last = 0;
			al.push_back(block[maxb][i]);
		}
	}
	for (auto i : all) {
		at.push_back(i);
		cb++;
	}
	ll ans = cm + cb;
	for (ll i = 0; i < k; i++) {
		if (i != minb && i != maxb) {
			ll l = cm, r = cb + 1;
			while (r - l > 1) {
				ll mid = (l + r) / 2;
				vector<ll> now;
				for (ll j = 0; j < mid; j++) {
					now.push_back(at[j]);
				}
				for (ll j = 0; j < (sb - mid); j++) {
					now.push_back(al[j]);
				}
				ll check = weigh(block[i], now);
				if (check == 0) {
					l = mid;
					break;
				}
				if (check == -1) {
					r = mid;
				} else {
					l = mid + 1;
				}
			}
			ans += l;
		}
	}
	return make_pair(ans, at[0]);
}
