#include <bits/stdc++.h>
//#include "coins.h"

using namespace std;

/*pair<int,int> count_heavy(int k)
{
    int n = (1<<k);
    if(k == 1)
    {
        const vector<int> a = {0};
        const vector<int> b = {1};
        int u = weigh(a,b);
        if(u == 1)
        {
            return {1,0};
        }
        else
            return {1,1};
    }
    vector<int> ans(n);
    vector<int> eq(n);
    for(int l = 2;l <= n;l*=2)
    {
        for(int i = 0;i < n-l+1;i+=l)
        {
            if(eq[i] != 0 && eq[i+l/2] != 0)
            {
                continue;
            }
            else if(eq[i] == 0 && eq[i+l/2] != 0)
            {
                vector<int> a;
                vector<int> b;
                for(int j = i;j <= i+l/2-1;++j)
                {
                    a.push_back(j);
                }
                for(int j = i+l/2;j <= i+l-1;++j)
                {
                    b.push_back(j);
                }
                int u = weigh(a,b);
                if(u == 1)
                {
                    eq[i] = 1;
                    for(int o = i;o < i+l/2;++o)
                    {
                        ans[o] = 1;
                    }
                }
                else if(u == -1)
                {
                    eq[i] = 1;
                    for(int o = i;o < i+l/2;++o)
                    {
                        ans[o] = 0;
                    }
                }
            }
            else if(eq[i] != 0 && eq[i+l/2] == 0)
            {
                vector<int> a;
                vector<int> b;
                for(int j = i;j <= i+l/2-1;++j)
                {
                    a.push_back(j);
                }
                for(int j = i+l/2;j <= i+l-1;++j)
                {
                    b.push_back(j);
                }
                int u = weigh(a,b);
                if(u == 1)
                {
                    eq[i+l/2] = 1;
                    for(int o = i+l/2;o < i+l;++o)
                    {
                        ans[o] = 0;
                    }
                }
                else if(u == -1)
                {
                    eq[i+l/2] = 1;
                    for(int o = i+l/2;o < i+l;++o)
                    {
                        ans[o] = 1;
                    }
                }
            }
            else
            {
                vector<int> a;
                vector<int> b;
                for(int j = i;j <= i+l/2-1;++j)
                {
                    a.push_back(j);
                }
                for(int j = i+l/2;j <= i+l-1;++j)
                {
                    b.push_back(j);
                }
                int u = weigh(a,b);
                if(u == 1)
                {
                    eq[i] = 1;
                    for(int o = i;o < i+l/2;++o)
                    {
                        ans[o] = 1;
                    }
                    eq[i+l/2] = 1;
                    for(int o = i+l/2;o < i+l;++o)
                    {
                        ans[o] = 0;
                    }
                }
                else if(u == -1)
                {
                    eq[i] = 1;
                    for(int o = i;o < i+l/2;++o)
                    {
                        ans[o] = 0;
                    }
                    eq[i+l/2] = 1;
                    for(int o = i+l/2;o < i+l;++o)
                    {
                        ans[o] = 1;
                    }
                }
                else
                {
                    eq[i] = 0;
                }
            }
        }
    }
    int64_t t = 0,in = -1;
    for(int i =0 ;i < n;++i)
    {
        if(ans[i])
        {
            in = i;
            t++;
        }

    }
    return {t,in};

}*/
const int maxn = 100005;

vector<int> dp(maxn);
vector<pair<pair<int,int>,pair<int,int>>> que;
vector<int> segTree;

void modify(int i,int x,int l,int r,int indV)
{
    if(l > i || r < i)
        return ;
    else if(l == r)
    {
        segTree[indV] = x;
        return ;
    }
    int m = (l+r)/2;
    modify(i,x,l,m,indV*2+1);
    modify(i,x,m+1,r,indV*2+2);
    segTree[indV] = segTree[indV*2+1] + segTree[indV*2+2];
    return ;
}
int get(int lx,int rx,int l,int r,int indV)
{
    if(l > rx || r < lx)
        return 0;
    else if(l >= lx && r <= rx)
        return segTree[indV];
    int m = (l+r)/2;
    int sl = get(lx,rx,l,m,indV*2+1);
    int sr=  get(lx,rx,m+1,r,indV*2+2);
    return sl+sr;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int q;
    cin >> q;
    segTree.resize(4*maxn);
    for(int j = 1;j < maxn;++j)
    {
        for(int k = 2*j;k < maxn;k+=j)
        {
            dp[k] += j;
        }
    }
    for(int i = 0;i < q;++i)
    {
        int l,r,v;
        cin >> l >> r >> v;
        que.push_back({{v,i},{l,r}});
    }
    for(int j = 1;j < maxn;++j)
    {
        que.push_back({{dp[j],-j-1},{maxn+1,maxn+1}});
    }
    vector<int> ans(q);
    sort(que.rbegin(),que.rend());
    for(int j = 0;j < que.size();++j)
    {
        if(que[j].first.second < 0)
        {
          //  cout << que[j].first.first << ' ' << -que[j].first.second-1 << "\n";
            modify(-que[j].first.second-1,1,0,maxn-1,0);

        }
        else
        {
            ans[que[j].first.second] = get(que[j].second.first,que[j].second.second,0,maxn-1,0);
        }
    }
    for(auto c:ans)
        cout << c << "\n";
    return 0;

}
