#include "coins.h"
#include "bits/stdc++.h"
using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(), x.end()

set<int> pos;
int n, k;


pair<int, int> last() {
    vector<int> light = {0};
    int ptr = 1;
    bool is_heavy = 0;
    int cnt = 0;
    bool ok = 1;
    while (ptr < n) {
        if (cnt >= k) {
            ok = 0;
            break;
        }
        int l = 0, r = min(n - ptr + 1, (int)light.size() + 1);
        while (r - l > 1) {
            int mid = (l + r) >> 1;
            vector<int> ql, qr;
            for (int i = 0; i < mid; ++i) ql.push_back(light[i]);
            for (int i = 0; i < mid; ++i) qr.push_back(i + ptr);
            int q = weigh(ql, qr);
            if (q == 0) l = mid;
            else {
                r = mid;
                if (q == 1) is_heavy = 1;
            }
        }
        for (int i = 0; i < l; ++i) light.push_back(ptr++);
        if (l == 0) {
            ++cnt;
            ptr++;
        }
//            cout << ptr << '\n';
//            for (auto i : light) cout << i << ' ';
//            cout << '\n';
    }
//        cout << "ABOBA\n";
//        cout << is_heavy << '\n';

    if (ok) {
        if (is_heavy) {
            return {light.size(), light[0]};
        } else {
            set<int> st(all(light));
            int ptr = 0;
            while (st.count(ptr)) ++ptr;
            return {n - light.size(), ptr};
        }
    } else {
        set<int> st(all(light));
        int ptr = 0;
        while (st.count(ptr)) ++ptr;
        vector<int> light = {ptr};
        ++ptr;
        bool is_heavy = 0;
        int cnt = 0;
        bool ok = 1;
        while (ptr < n) {
            if (cnt >= k) {
                ok = 0;
                break;
            }
            int l = 0, r = min(n - ptr + 1, (int)light.size() + 1);
            while (r - l > 1) {
                int mid = (l + r) >> 1;
                vector<int> ql, qr;
                for (int i = 0; i < mid; ++i) ql.push_back(light[i]);
                for (int i = 0; i < mid; ++i) qr.push_back(i + ptr);
                int q = weigh(ql, qr);
                if (q == 0) l = mid;
                else {
                    r = mid;
                    if (q == 1) is_heavy = 1;
                }
            }
            for (int i = 0; i < l; ++i) light.push_back(ptr++);
            if (l == 0) {
                ++cnt;
                ptr++;
            }
        }
        if (weigh({0}, {light[0]}) == -1) {
            return {light.size(), light[0]};
        } else {
            set<int> st(all(light));
            int ptr = 0;
            while (st.count(ptr)) ++ptr;
            return {n - light.size(), ptr};
        }
    }
}

pair<int, int> tryww(int c) {
    pair<int, int> seg = {0, n - 1};
    while (seg.ss != seg.ff) {
        int mid = (seg.ss + seg.ff) / 2;
        vector<int> l, r;
        for (int i = seg.ff; i <= mid; ++i) {
            l.push_back(i);
        }
        for (int i = mid + 1; i <= seg.ss; ++i) {
            r.push_back(i);
        }
        int q = weigh(l, r);
        if (q == 0) return {-1, -1};
        if (q == c) {
            seg = {seg.ff, mid};
        } else {
            seg = {mid + 1, seg.ss};
        }
    }
    return {1, seg.ff};
}

pair<int, int> count_heavy(int _k) {
    k = _k;
    n = (1 << k);
    if (k <= 10) {
        pair<int, int> res = {0, -1};
        int ccc = 0;
        for (int i = 1; i < n; ++i) {
            int cc = weigh({0}, {i});
            if (cc == -1) {
                res.first++;
                res.second = i;
            }
            if (cc == 1) ccc++;
        }
        if (res.second == -1) {
            res.first = n - ccc;
            res.second = 0;
        }
        return res;
    } else {
        auto res = tryww(1);
        if (res == make_pair(-1, -1)) {
            res = tryww(-1);
            if (res == make_pair(-1, -1)) {
                return last();
            } else {
                res.first = n - res.first;
                res.ss = 0;
                while (pos.count(res.ss)) ++res.ss;
            }
        }
        return res;
    }
}
