#include "coins.h"
#include "bits/stdc++.h"
using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(), x.end()

int n, k;

vector<int> light, heavy;

bool go(int l, int r, bool small = 1) {
    if (l == r) {
        if (small) {
            light.push_back(l);
            return 0;
        } else {
            heavy.push_back(r);
            return 1;
        }
    }
    if (light.size() >= r - l + 1) {
        vector<int> ql, qr;
        for (int i = l; i <= r; ++i) ql.push_back(i);
        for (int i = 0; i < r - l + 1; ++i) qr.push_back(light[i]);
        if (!weigh(ql, qr)) {
            for (int i = l; i <= r; ++i) light.push_back(i);
            return 0;
        }
    }
    int mid = (l + r) / 2;
    vector<int> ql, qr;
    for (int i = l; i <= mid; ++i) ql.push_back(i);
    for (int i = mid + 1; i <= r; ++i) qr.push_back(i);
    int q = weigh(ql, qr);
    bool ok = 1;
    if (q == 0) {
        if (go(l, mid)) {
            go(mid + 1, r);
            return 1;
        }
        else {
            for (int i = mid + 1; i <= r; ++i) light.push_back(i);
            return 0;
        }
    } else if (q == 1) {
        if (go(l, mid)) {
            go(mid + 1, r);
            return 1;
        }
        else {
            for (int i = mid + 1; i <= r; ++i) light.push_back(i);
            return 0;
        }
    } else {
        if (go(mid + 1, r)) {
            go(l, mid);
            return 1;
        }
        else {
            for (int i = l; i <= mid; ++i) light.push_back(i);
            return 0;
        }
    }
}

pair<int, int> count_heavy(int _k) {
    k = _k;
    n = (1 << k);
    if (k <= 10) {
        pair<int, int> res = {0, -1};
        int ccc = 0;
        for (int i = 1; i < n; ++i) {
            int cc = weigh({0}, {i});
            if (cc == -1) {
                res.first++;
                res.second = i;
            }
            if (cc == 1) ccc++;
        }
        if (res.second == -1) {
            res.first = n - ccc;
            res.second = 0;
        }
        return res;
    } else {
        go(0, n - 1);
        set<int> st(all(light));
        int pos = 0;
        while (st.contains(pos)) ++pos;
        return {n - st.size(), pos};
    }
}
