#include "bits/stdc++.h"
using namespace std;

#define all(x) x.begin(), x.end()
#define ff first
#define ss second

#define int ll

using ll = long long;

const ll INF = 1e10;
const int N = 4001;

int n;
ll dp[N][N]; //dp[vert][balance]
ll ans[N]; //answer for subtree
ll sm[N][N]; // sum[u][d] = sum over ansu : dist(u, v) = d
ll c[N], t[N], cost[N][N];
vector<int> g[N];

void dfs(int u, int p = -1) {
    for (auto to : g[u]) {
        if (to == p) continue;
        dfs(to, u);
    }
    for (auto to : g[u]) {
        if (to == p) continue;
        for (int i = 0; i < n; ++i) {
            sm[u][i + 1] += sm[to][i];
        }
    }
    for (int i = 0; i < n; ++i) dp[u][i] = INF;
    for (auto to : g[u]) {
        if (to == p) continue;
        for (int i = 0; i < n; ++i) {
            sm[u][i + 1] -= sm[to][i];
        }
        ll mn = INF;
        for (int j = 1; j < n; ++j) {
            mn = min(mn, sm[u][j]);
            assert(mn == sm[u][j]);
            dp[u][j - 1] = min(dp[u][j - 1], dp[to][j] + mn);
        }
        for (int i = 0; i < n; ++i) {
            sm[u][i + 1] += sm[to][i];
        }
    }
    for (int bal = 0; bal < n; ++bal) {
        dp[u][bal] = min(dp[u][bal], cost[u][bal] + sm[u][bal + 1]);
    }
    for (int bal = n - 2; bal >= 0; --bal) {
        dp[u][bal] = min(dp[u][bal], dp[u][bal + 1]);
    }
    ans[u] = dp[u][0];
    sm[u][0] = ans[u];
    for (int bal = 1; bal < n; ++bal) {
        sm[u][bal] = min(sm[u][bal], sm[u][bal - 1]);
    }
//    cout << u << '\n';
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;
    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> t[i];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) cost[i][j] = INF;
        for (int j = t[i] - 1; j >= 0; --j) cost[i][j] = min(c[j], cost[i][j + 1]);
    }
//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < n; ++j) cout << cost[i][j] << ' ';
//        cout << '\n';
//    }
//    cout << '\n';
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0);
//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < n; ++j) cout << dp[i][j] << ' ';
//        cout << '\n';
//    }
//    cout << '\n';
//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < n; ++j) cout << sm[i][j] << ' ';
//        cout << '\n';
//    }
//    cout << '\n';
    cout << ans[0];
}