#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<ll> prime;
vector<ll> p;

ll get(ll l, ll r) {
    return p[r] - p[l - 1];
}

void solve() {
    ll l, r, v;
    cin >> l >> r >> v;
    if (v <= 10) {
        ll ans = r - l + 1;
        ans -= get(l, r);
        if (l <= 1 && 1 <= r) {
            ans--;
        }
        if (l <= 14 && 14 <= r && v >= 10) {
            ans--;
        }
        if (l <= 49 && 49 <= r && v >= 8) {
            ans--;
        }
        if (l <= 10 && 10 <= r && v >= 8) {
            ans--;
        }
        if (l <= 15 && 15 <= r && v >= 9) {
            ans--;
        }
        if (l <= 25 && 25 <= r && v >= 6) {
            ans--;
        }
        if (l <= 9 && 9 <= r && v >= 4) {
            ans--;
        }
        if (l <= 6 && 6 <= r && v >= 6) {
            ans--;
        }
        if (l <= 4 && 4 <= r && v >= 3) {
            ans--;
        }
        if (l <= 8 && 8 <= r && v >= 7) {
            ans--;
        }
        cout << ans << '\n';
    } else {
        ll ans = 0;

        for (ll i = l; i <= r; i++) {
            ll i1 = i;
            unordered_map<ll, ll> mp;
            while (i1 != 1) {
                mp[prime[i1]]++;
                i1 /= prime[i1];
            }
            ll x = 1;
            for (auto &j: mp) {
                ll s = 1;
                ll g = 1;
                for (ll k = 0; k < j.second; k++) {
                    g *= j.first;
                    s += g;
                }
                x *= s;
            }
            if (x - i > v) {
                ans++;
            }
        }

        cout << ans << '\n';
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll q;
    cin >> q;

    prime.assign(1e5 + 1, 0);

    for (ll i = 0; i <= 1e5; i++) {
        prime[i] = i;
    }
    prime[0] = prime[1] = -1;
    for (ll i = 2; i <= 1e5; i++) {
        if (prime[i] == i) {
            for (ll j = i * i; j <= 1e5; j += i) {
                prime[j] = i;
            }
        }
    }

    p.assign(1e5 + 1, 0);
    for (ll i = 2; i <= 1e5; i++) {
        if (prime[i] == i) {
            p[i] = p[i - 1] + 1;
        } else {
            p[i] = p[i - 1];
        }
    }

    while (q--) {
        solve();
    }
}