#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
ll inf = 1e15, mod = 1e9 + 7;
#define all(a) a.begin(), a.end()
vector<ll> a;
vector<vector<ll>> tr;

void build(ll v, ll l, ll r) {
    if (l == r) {
        tr[v].push_back(a[l]);
        return;
    }
    ll md = (l + r) / 2;
    build(v + v, l, md);
    build(v + v + 1, md + 1, r);
    ll i = 0, j = 0;
    while (i < (r - l + 1) / 2 || j < (r - l + 1) / 2) {
        if (j >= (r - l + 1) / 2 || i < (r - l + 1) / 2 && tr[v + v][i] < tr[v + v + 1][j]) {
            tr[v].push_back(tr[v + v][i]);
            i++;
        } else {
            tr[v].push_back(tr[v + v + 1][j]);
            j++;
        }
    }
}

ll ans(ll v, ll l, ll r, ll la, ll ra, ll x) {
    if (l > ra || r < la)
        return 0;
    if (l >= la && r <= ra)
        return tr[v].size() - (upper_bound(all(tr[v]), x) - tr[v].begin());
    ll md = (l + r) / 2;
    return ans(v + v, l, md, la, ra, x) + ans(v + v + 1, md + 1, r, la, ra, x);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll v = 1;
    while (v < 1e5)
        v *= 2;
    tr.resize(v * 2 + 1);
    a.resize(v);
    for (ll i = 1; i <= 1e5; i++)
        for (ll j = i * 2; j <= 1e5; j += i)
            a[j - 1] += i;
    build(1, 0, v - 1);
    ll q;
    cin >> q;
    while (q--) {
        ll l, r, x;
        cin >> l >> r >> x;
        cout << ans(1, 0, v - 1, l - 1, r - 1, x) << '\n';
    }
}