#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 510;
int t[N], c[N], dp[N][N];
vector<int> g[N], d;

void dfs(int v, int p) {
    d.emplace_back(v);
    for (auto u: g[v]) {
        if (u == p)
            continue;
        dfs(u, v);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    c[0] = 0;
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 0; i < n; i++)
        cin >> t[i];
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].emplace_back(v - 1);
        g[v - 1].emplace_back(u - 1);
    }
    for (int i = 0; i < n; i++)
        if (g[i].size() == 1) {
            dfs(i, -1);
            break;
        }
    int mn = int(1e9);
    for (int i = 1; i <= n; i++)
        mn = min(mn, c[i]);
    dp[0][0] = mn;
    for (int j = 1; j < N; j++)
        dp[0][j] = 0;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < N; j++)
            dp[i][j] = int(1e9);
    }
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < N; j++) {
            if (j > 0) {
                for (int k = 0; k <= t[d[i]]; k++) {
                    if (k == 0) {
                        dp[i][j] = min(dp[i][j], dp[i - 1][j - 1]);
                    } else {
                        dp[i][j] = min(dp[i][j], dp[i - 1][max(j - 1, k - 1)] + c[k]);
                    }
                }
            } else {
                for (int k = 1; k <= t[d[i]]; k++) {
                    dp[i][j] = min(dp[i][j], dp[i - 1][max(0, k - 1)] + c[k]);
                }
                for (int r = i - 1; r >= 1; r--) {
                    int dist = i - r;
                    if (dist + 1 <= t[d[r]])
                        dp[i][j] = min(dp[i][j], dp[r - 1][dist] + c[dist + 1]);
                }
                if (i + 1 <= t[d[0]])
                    dp[i][j] = min(dp[i][j], c[i + 1]);
            }
        }
    }
    if (dp[n - 1][0] == int(1e9))
        cout << -1;
    else
        cout << dp[n - 1][0];
    return 0;
}