#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int ll

const int N = int(1e5) + 10;

struct tree {
    vector<int> a;
    vector<vector<int>> t;

    static vector<int> Merge(vector<int> &a, vector<int> &b) {
        vector<int> c;
        int i = 0, j = 0;
        while (i < int(a.size()) || j < int(b.size())) {
            if (i == int(a.size())) {
                c.emplace_back(b[j++]);
            } else if (j == int(b.size())) {
                c.emplace_back(a[i++]);
            } else if (a[i] < b[j]) {
                c.emplace_back(a[i++]);
            } else {
                c.emplace_back(b[j++]);
            }
        }
        return c;
    }

    void build(int v, int l, int r) {
        if (l == r) {
            t[v].emplace_back(a[l]);
            return;
        }
        build(v * 2, l, (l + r) / 2);
        build(v * 2 + 1, (l + r) / 2 + 1, r);
        t[v] = Merge(t[v * 2], t[v * 2 + 1]);
    }

    explicit tree(int m) {
        a.resize(N);
        for (int i = 1; i < N; i++) {
            int j = i * 2;
            while (j < N)
                a[j] += i, j += i;
        }
        t.resize(4 * N);
        build(1, 0, N - 1);
    }

    int find(vector<int> &b, int v) {
        int l = 0, r = int(b.size()) - 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (b[m] <= v)
                l = m;
            else
                r = m;
        }
        if (b[r] <= v)
            return 0;
        if(b[l] <= v)
            return (int(b.size()) - r);
        return int(b.size()) - l;
    }

    int get_k(int v, int l, int r, int tl, int tr, int val) {
        if (l == tl && r == tr)
            return find(t[v], val);
        int mid = (l + r) / 2;
        if (tr <= mid)
            return get_k(v * 2, l, mid, tl, tr, val);
        if (tl > mid)
            return get_k(v * 2 + 1, mid + 1, r, tl, tr, val);
        return get_k(v * 2, l, mid, tl, mid, val) + get_k(v * 2 + 1, mid + 1, r, mid + 1, tr, val);
    }
};

tree st(N);

int rich_num(int l, int r, int val){
    return st.get_k(1, 0, N - 1, l, r, val);
}