#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int ll

const int N = int(4e5) + 1;
const int M = int(1e5) + 1;

int t[4 * N], a[M];
vector<int> b[M];
map<int, int> c[M];

void update(int v, int l, int r, int pos) {
    if (l == r) {
        t[v]++;
        return;
    }
    if (pos <= (l + r) / 2)
        update(v * 2, l, (l + r) / 2, pos);
    else
        update(v * 2 + 1, (l + r) / 2 + 1, r, pos);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int get(int v, int l, int r, int tl, int tr) {
    if (l == tl && r == tr)
        return t[v];
    int mid = (l + r) / 2;
    if (tr <= mid)
        return get(v * 2, l, mid, tl, tr);
    if (tl > mid)
        return get(v * 2 + 1, mid + 1, r, tl, tr);
    return get(v * 2, l, mid, tl, mid) + get(v * 2 + 1, mid + 1, r, mid + 1, tr);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    for(int i = 1; i < M; i++){
        int j = 2 * i;
        while(j < N)
            a[j] += i, j += i;
    }
    vector<vector<int>> q;
    int n;
    cin >> n;
    while(n--){
        int l, r, v;
        cin >> l >> r >> v;
        q.push_back({l, r, v});
        b[l - 1].emplace_back(v);
        b[r].emplace_back(v);
    }
    for(int i = 1; i < M; i++){
        update(1, 0, N - 1, a[i]);
        for(auto e : b[i]){
            int s1 = get(1, 0, N - 1, 0, N - 1) - get(1, 0, N - 1, 0, e);
            c[i][e] = s1;
        }
    }
    for(auto e : b[0])
        c[0][e] = 0;
    for(int i = 0; i < int(q.size()); i++){
        int l = q[i][0], r = q[i][1], v = q[i][2];
        cout << c[r][v] - c[l - 1][v] << "\n";
    }
    return 0;
}