#include<bits/stdc++.h>
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define F first
#define S second
#define pb push_back


typedef long long ll;
using namespace std;
const int N = 1e5+100, MX=1e5+10;
int sum[N], ans[N];
pair< int , int > a[N];

struct node{
    int l,r,v,nom;
    bool operator<(const node &b){
        return v>b.v;
    };
} Q[N];


ll t[4*N],dop[4*N];

void push(int v , int l , int r)
{
    if(dop[v]!=0 && l!=r)
    {
        int mid=(l+r)/2;
        t[v*2]+=dop[v]*(mid-l+1);
        t[v*2+1]+=dop[v]*(r-(mid+1)+1);
        dop[v*2]+=dop[v];
        dop[v*2+1]+=dop[v];
    }
    dop[v]=0;
}
void upd(int v , int vl , int vr , int l , int r)
{
    push(v,vl,vr);
    if(vr<vl || vr<l || vl>r) return;
    if(vl>=l && vr<=r)
    {
        t[v]+=(vr-vl+1);
        ++dop[v];
        return ;
    }

    int mid=(vl+vr)/2;
    upd(v*2,vl,mid,l,r);
    upd(v*2+1,mid+1,vr,l,r);
    t[v]=t[v*2]+t[v*2+1];
}
ll get(int v, int vl , int vr , int l , int r)
{
    push(v,vl,vr);
    if(vl>r || vr<vl || vr<l || r<l) return 0;
    if(vl>=l && vr<=r) return t[v];

    int mid=(vl+vr)/2;
    ll s1=get(v*2,vl,mid,l,r);
    ll s2=get(v*2+1,mid+1,vr,l,r);
    return (s1+s2);
}
int main()
{
    #ifdef ROADTOBELEGEND
        freopen("input.txt" , "r" , stdin);
        freopen("output.txt" , "w" , stdout);
    #endif // ROADTOBELEGEND

    fast_io;

    for(int i=1;i<N;++i)
        for(int j=i;j<N;j+=i)
            sum[j]+=i;
    for(int i=1;i<N;++i)
        sum[i]-=i;


    int k=0;
    for(int i=1;i<=MX;++i)
        a[i-1]={sum[i],i};
    sort(a,a+MX);

    int t;
    cin>>t;
    for(int i=0;i<t;++i)
    {
        cin>>Q[i].l>>Q[i].r>>Q[i].v;
        Q[i].nom=i;
    }

    sort(Q,Q+t);
    int id=MX-1;

    for(int i=0;i<t;++i)
    {
        while(a[id].F>Q[i].v && id>=0)
        {
            upd(1,1,MX,a[id].S,a[id].S);
            --id;
        }
        ll s=get(1,1,MX,1,Q[i].r);
        s-=get(1,1,MX,1,Q[i].l-1);

        ans[Q[i].nom]=s;
    }


    for(int i=0;i<t;++i)
        cout<<ans[i]<<'\n';
    return 0;
}
