#pragma GCC optimize("O3,unroll-loops")
#include "coins.h"
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define vec vector
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)x.size()
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
//int k;
//vec<int> coins;
//
//int weigh(const vector<int> &a, const vector<int> &b)
//{
//    int wa = 0, wb = 0;
//    for (int i : a) wa += coins[i];
//    for (int i : b) wb += coins[i];
//    if (wa == wb) return 0;
//    if (wa < wb) return -1;
//    return 1;
//}

pii count_heavy(int k)
{
    pii res = {1, 0};
    int l = 0, r = (1 << k) - 1;
    while (l < r)
    {
        int m = (l + r) / 2;
        assert(m - l + 1 == r - m);
        vec<int> a, b;
        for (int i = l; i <= m; i++) a.pb(i);
        for (int i = m + 1; i <= r; i++) b.pb(i);
        int w = weigh(a, b);
        if (w >= 0) r = m;
        else l = m + 1;
    }
    res.s = l;
    vec<int> b = {l};
    if (k <= 5)
    {
        for (int i = 0; i < (1 << k); i++)
        {
            if (i == l) continue;
            vec<int> a = {i};
            int w = weigh(a, b);
            if (w == 0) res.f++;
        }
    }
    else
    {
        vec<int> a = {l - 1};
        if (l - 1 == -1) a[0] = 1;
        if (weigh(b, a) == 0) res.f = (1 << k) - 1;
        else res.f = 1;
    }
    return res;
}

//int32_t main()
//{
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cin >> k;
//    for (int i = 0; i < (1 << k); i++)
//    {
//        int a;
//        cin >> a;
//        coins.pb(a);
//    }
//    pii res = count_heavy(k);
//    cout << res.f << " " << res.s;
//    return 0;
//}
