#include "coins.h"
#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++ i)
#define rf(i, a, b) for (int i = (a); i >= (b); -- i)
#define fe(x, a) for (auto& x : a)

#define fi first
#define se second

#define pb push_back

using namespace std;

using ll = long long;
queue <pair <pair <ll, ll>, pair <int, bool>>> q;

vector <int> a, b;

const int N = 1e6 + 5;
int t[4*N];
int pos;
void dfs (int v, int tl, int tr, bool w) {
    if (tl == tr - 1) {
        a.clear(); b.clear();
        a.pb (tl - 1);
        b.pb (tr - 1);

        int wes = weigh(a, b);

        if (!wes) {t[v] = 2*w; if(w)pos = tl - 1;}
        else if (wes == 1) {
            t[v] = 1;

            pos = tl - 1;
        } else {
            t[v] = 1;

            pos = tr - 1;
        }


        return;
    }
//    cout << v << " " << tl << " " << tr << " " << w << endl;
    int tm = (tl + tr) >> 1;
    a.clear();
    b.clear();
    fr (i, tl, tm) a.pb (i - 1);
    fr (i, tm + 1, tr) b.pb (i - 1);
    int wes = weigh(a, b);

    if (!wes) {
        if (w) {
            dfs (v << 1, tl, tm, w);
            dfs (v << 1 | 1, tm + 1, tr, w);
        }
    } else if (wes == -1) {
        dfs (v << 1 | 1, tm + 1, tr, 1);
        dfs (v << 1, tl, tm, 0);
    } else {
        dfs (v << 1 | 1, tm + 1, tr, 0);
        dfs (v << 1, tl, tm, 1);
    }
        t[v] = t[v << 1 | 1] + t[v << 1];

}

int kols = 0;

void frop (int kols) {
    assert (kols <= 10000);
}


void dfs1 (int l, int r) {
    if (l == r) {
        pos = l - 1;
        return;
    }

    int mid = (l + r) >> 1;
    a.clear(); b.clear();

    fr (i, l, mid) a.pb (i - 1);
    fr (i, mid + 1, r) b.pb (i - 1);

    int wes = weigh(a, b);
    ++ kols;

    frop (kols);

    if (wes == -1) dfs1 (mid + 1, r);
    else dfs1 (l, mid);
}

pair<int, int> count_heavy(int k) {
    ll n = 1;
    while (k --) n *= 2;

    if (k <= 5) {
        dfs (1, 1, n, 0);
        return {t[1], pos};
    } else {
        dfs1 (1, n);
        a.clear(); b.clear();

        a.resize(1); b.resize(1);
        a[0] = pos;
        int res = 0;
        if (pos == 0) {
            b[0] = pos + 1;
            int wes = weigh(a, b);
            kols ++;
            frop(kols);
            res += !wes;

            b[0] = pos + 2;
            wes = weigh(a, b);
            kols ++;
            frop(kols);
            res += !wes;
        } else {

            b[0] = pos - 1;
            int wes = weigh(a, b);
            kols ++;
            frop(kols);
            res += !wes;

            b[0] = pos - 2;
            wes = weigh(a, b);
            kols ++;
            frop(kols);
            res += !wes;
        }

        if (!res) return {1, pos};
        else return {n - 1, pos};

    }
}
