#include "coins.h"
#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++ i)
#define rf(i, a, b) for (int i = (a); i >= (b); -- i)
#define fe(x, a) for (auto& x : a)

#define fi first
#define se second

#define pb push_back

using namespace std;

using ll = long long;
queue <pair <pair <ll, ll>, pair <int, bool>>> q;

vector <int> a, b;

const int N = 1e6 + 5;
int t[4*N];
int pos;
bool f[N];

void dfs (int v, int l, int r, bool w) {
    if (f[v]) return;

    if (l == r) {
        t[v] = w;
        if(w)pos = l - 1;
        return;
    }

    int mid = (l + r) >> 1;

    a.clear(); b.clear();
    fr (i, l, mid) a.pb (i - 1);
    fr (i, mid + 1, r) b.pb (i - 1);
    int wes = weigh(a, b);

    if (!wes) {
        dfs (v << 1, l, mid, w);
        dfs (v << 1 | 1, mid + 1, r, w);
//        t[v << 1 | 1] = t[v << 1];
    } else {
        if (wes == -1) {
            dfs (v << 1 | 1, mid + 1, r, 1);
            dfs (v << 1, l, mid, 0);
        } else {
            dfs (v << 1 | 1, mid + 1, r, 0);
            dfs (v << 1, l, mid, 1);
        }
    }
    t[v] = max(t[v], t[v << 1] + t[v << 1 | 1]);
}

pair<int, int> count_heavy(int k) {
    ll n = 1;
    while (k --) n *= 2;

    dfs (1, 1, n, 0);
//    cout << t[1] << " " << pos << endl;
    return {t[1], pos};
}
