#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
using namespace std;

int n = 1e3 + 10;
int t = 1 << 10;

vector<int> merge(vector<int>& a, vector<int>& b) {
	vector<int> v;
	int i = 0, j = 0;
	for (int k = 0; k < 2 * a.size(); ++k) {
		if (i == a.size()) {
			v.push_back(b[j]);
			j++;
			continue;
		}
		if (j == b.size()) {
			v.push_back(a[i]);
			i++;
			continue;
		}
		if (a[i] < b[j]) {
			v.push_back(a[i]);
			i++;
		}
		else {
			v.push_back(b[j]);
			j++;
		}
	}
	return v;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	vector<int> P;
	for (int i = 2; i <= n; ++i) {
		bool lol = true;
		for (int j = 0; j < P.size(); ++j) {
			if (i % P[j] == 0) {
				lol = false; break;
			}
		}
		if (lol) P.push_back({ i });
	}
	
	vector<int> h(n, 1);
	for (int i = 2; i < n; ++i) {
		int j = i;
		int k = 0;
		while (j != 1) {
			if (j % P[k]) k++;
			else {
				int p = 1;
				int g = P[k];
				while (j % g == 0) { 
					p += g;
					g *= P[k];
				}
				j *= P[k];
				j /= g;
				h[i] *= p;
			}
		}
		h[i] -= i;
	}
	
	vector<vector<int>> v(2 * t);
	for (int i = t; i < t + n - 1; ++i) {
		v[i] = { h[i - t + 1] };
	}
	for (int i = t - 1; i > 0; --i) {
		if (v[2 * i + 1].size()) v[i] = merge(v[2 * i], v[2 * i + 1]);
	}
	int Q; cin >> Q;
	while (Q--) {
		int l, r, x;
		cin >> l >> r >> x;
		int ans = 0;
		l += t - 1;
		r += t - 1;
		while (l <= r) {
			if (l & 1) {
				ans += v[l].size() - distance(v[l].begin(), upper_bound(v[l].begin(), v[l].end(), x));
				l++;
				l >>= 1;
			}
			else l >>= 1;
			if (r & 1) r >>= 1;
			else {
				ans += v[r].size() - distance(v[r].begin(), upper_bound(v[r].begin(), v[r].end(), x));
				r--;
				r >>= 1;
			}
			//cout << ans << ' ' << l << ' ' << r << '\n';
		}
		//if (l == r) ans += v[l].size() - distance(v[l].begin(), upper_bound(v[l].begin(), v[l].end(), x));
		cout << ans << '\n';
	}
}