#include <iostream>
#include <cmath>
#include <vector>
using namespace std;

int n = 1e5 + 10;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int Q; cin >> Q;
	vector<int> h(n);
	h[1] = 1;
	h[2] = 1;
	h[3] = 1;
	h[4] = 3;
	h[5] = 1;
	h[6] = 5;
	h[7] = 1;
	h[8] = 7;
	h[9] = 4;
	h[10] = 8;
	for (int i = 1; i < n; ++i) {
		int s = 0;
		for (int j = 2; j < sqrt(i); ++j) {
			if (s >= 10) break;
			if (i % j == 0) { s += j; }
		}
		h[i] = min(s, 10);
	}
	vector<vector<int>> v(11, vector<int>(n + 1));
	for (int j = 1; j < 11; ++j) {
		for (int i = 1; i < n; ++i) {
			v[j][i] = v[j][i - 1];
			if (h[i] > j) v[j][i]++;
			//cout << v[j][i] << ' ';
		}
		//cout << endl;
	}
	while (Q--) {
		int l, r, x;
		cin >> l >> r >> x;
		cout << v[x - 1][r] - v[x - 1][l - 1];
	}
}