#include "coins.h"
#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vll vector<ll>
#define vvll vector<vll>

#define cout if (false) cout

vll order;
mt19937_64 rng;

int mweigh(vll &a, vll &b, ll n = 1e18, bool check = false)
{
// #ifndef EVAL
//     if (check)
//     {
//         assert(a.size() == b.size());
//     }
// #endif
    n = min({n, (ll)a.size(), (ll)b.size()});
    vector<int> X(n), Y(n);
    for (ll i = 0; i < n; i++)
    {
        X[i] = order[a[i]];
        Y[i] = order[b[i]];
    }
    return weigh(X, Y);
}

std::pair<int, int> count_heavy(int k)
{
    ll n = 1 << k;
    order.resize(n);
    iota(order.begin(), order.end(), 0);
    shuffle(order.begin(), order.end(), rng);
    ll zw = 0;
    vll vals{0};
    vll vals3;
    ll cp = 1;
    while (cp < n)
    {
        if (vals.size() < vals3.size())
            swap(vals, vals3), zw *= -1;
        vll vals2(min((ll)vals.size(), n - cp));
        iota(vals2.begin(), vals2.end(), cp);
        ll a = mweigh(vals, vals2);
        if (a == 0)
        {
            vals.insert(vals.end(), vals2.begin(), vals2.end());
            cp = vals.back() + 1;
        }
        else
        {
            ll l = 1;
            ll r = vals2.size();
            ll ans = -1; // minimum size answering a
            zw = a;
            while (l <= r)
            {
                // cout << l << ' ' << r << endl;
                ll m = (l + r) / 2;
                ll a2 = mweigh(vals, vals2, m);
                if (a2 == a)
                {
                    ans = m;
                    r = m - 1;
                }
                else
                {
                    l = m + 1;
                }
            }
            // cout << "Done " << ans << endl;
            vals.insert(vals.end(), vals2.begin(), vals2.begin() + ans - 1);
            vals3.push_back(vals2[ans - 1]);
            cp = vals2[ans - 1] + 1;
        }
    }
    if (zw == -1)
        swap(vals3, vals);
    if (cp == n)
    {
        return {vals.size(), order[vals[0]]};
    }
    ll gans = vals.size();
    ll gans2 = order[vals[0]];
    ll sz = 2;
    vvll segments;
    vll segmentsvals;
    for (ll i = 0; i < 4; i++)
        segments.push_back({vals[i]}), segments.push_back({vals3[i]}), segmentsvals.push_back(1), segmentsvals.push_back(0);
    vector<bitset<100>> dpsz(sz + 1);
    vector<bitset<100>> dpsz2(sz * 2 + 1);
    for (ll i = 0; i <= sz; i++)
        for (ll j = 0; j < sz; j++)
            dpsz[i][2 * j + (j >= i)] = 1;
    for (ll i = 0; i <= sz * 2; i++)
        for (ll j = 0; j < sz*2; j++)
            dpsz2[i][2 * j + (j >= i)] = 1;
    ll u = vals.size();
    ll v = vals3.size();
    cout << "MAIN!" << endl;
    while (cp < n)
    {
        vll subvals;
        ll ind = segments.size();
        for (ll j = 0; j < 4; j++)
        {
            vll vals2(min(sz, n - cp));
            iota(vals2.begin(), vals2.end(), cp);
            if (vals2.size() != sz)
            {
                cout << "sp" << endl;
                sz = vals2.size();
                vector<bitset<100>> cdp(sz+1);
                bool c = true;
                for (ll x = 0; x < 20; x++) {
                    if (sz & (1 << x)) {
                        vector<bitset<100>> ncdp(sz+1);
                        ll n2 = 1 << x;
                        for (ll k = sz; k >= 0; k--) {
                            for (ll i = 0; i < segments.size(); i++) {
                                if (segments[i].size() == n2 && k >= segmentsvals[i] && ((c && k == segmentsvals[i]) || cdp[k-segmentsvals[i]].any())) {
                                    ncdp[k] = cdp[k-segmentsvals[i]];
                                    ncdp[k][i] = 1;
                                }
                            }
                        }
                        cdp = move(ncdp);
                        c = false;
                    }
                }
                ll l = 0;
                ll r = sz;
                ll ans = -1;
                while (l <= r)
                {
                    if (l == r) {
                        ans = l;
                        break;
                    }
                    ll m = (u * l + v * r) / (u + v);
                    vll segm;
                    if (m < v*sz/(u+v))
                    while (cdp[m].none()) m++;
                    else
                    while (cdp[m].none()) m--;
                    for (ll s = 0; s < 100; s++)
                    {
                        if (cdp[m][s]) {
                            cout << s << ' ';
                            segm.insert(segm.end(), segments[s].begin(), segments[s].end());
                        }
                    }
                    cout << endl;
                    for (ll v : segm) cout << v << ' ';
                    cout << endl;
                    cout << segm.size() << ' ' << sz << endl;
                    ll a = mweigh(segm, vals2, 1e18, true);
                    if (a == -1)
                    {
                        l = m + 1;
                    }
                    else if (a == 0)
                    {
                        ans = m;
                        break;
                    }
                    else
                    {
                        r = m - 1;
                    }
                }
                gans += ans;
                return {gans, gans2};
            }
            else
            {
                ll l = 0;
                ll r = sz;
                ll ans = -1;
                while (l <= r)
                {
                    if (l == r) {
                        ans = l;
                        break;
                    }
                    ll m = (u * l + v * r) / (u + v);
                    vll segm;
                    if (m < v*sz/(u+v))
                    while (dpsz[m].none()) m++;
                    else
                    while (dpsz[m].none()) m--;
                    for (ll s = 0; s < 100; s++)
                    {
                        if (dpsz[m][s]) {
                            cout << s << ' ';
                            segm.insert(segm.end(), segments[s].begin(), segments[s].end());
                        }
                    }
                    cout << endl;
                    for (ll v : segm) cout << v << ' ';
                    cout << endl;
                    ll a = mweigh(segm, vals2, 1e18, true);
                    if (a == -1)
                    {
                        l = m + 1;
                    }
                    else if (a == 0)
                    {
                        ans = m;
                        break;
                    }
                    else
                    {
                        r = m - 1;
                    }
                }
                gans += ans;
                subvals.push_back(ans);
                segments.push_back(vals2);
                segmentsvals.push_back(ans);
                u += ans;
                v += sz - ans;
            }
            cp += vals2.size();
        }
        // cout << "d1" << endl;
        vector<bitset<100>> dpsz4(sz * 4 + 1);
        ll v1 = accumulate(subvals.begin(), subvals.end(), 0ll);
        // cout << v1 << endl;
        for (ll i = ind; i < ind + 4; i++)
            dpsz4[v1][i] = 1;
        // cout << "d2" << endl;
        for (ll r = 0; r < 4; r++)
        {
            for (ll i = v1 - subvals[r]; i <= sz + (v1 - subvals[r]); i++)
            {
                // cout << i << ' ' << ind << ' ' << v1-subvals[r] << endl;
                if (dpsz[i - (v1 - subvals[r])].none())
                    continue;
                // cout << 2 << endl;
                dpsz4[i] = dpsz[i - (v1 - subvals[r])];
                // cout << 3 << endl;
                for (ll j = ind; j < ind + 4; j++)
                    dpsz4[i][j] = 1;
                // cout << 4 << endl;
                dpsz4[i][ind + r] = 0;
            }
            // cout << "d22" << endl;
            for (ll r2 = 0; r2 < r; r2++)
            {
                for (ll i = v1 - subvals[r] - subvals[r2]; i <= 2*sz + v1 - subvals[r] - subvals[r2]; i++)
                {
                    if (dpsz2[i - (v1 - subvals[r] - subvals[r2])].none())
                        continue;
                    dpsz4[i] = dpsz2[i - (v1 - subvals[r] - subvals[r2])];
                    for (ll j = ind; j < ind + 4; j++)
                        dpsz4[i][j] = 1;
                    dpsz4[i][ind + r] = 0;
                    dpsz4[i][ind + r2] = 0;
                }
            }
            // cout << "d23" << endl;
        }
        // cout << "d3" << endl;
        for (ll r = 0; r < 4; r++)
        {
            for (ll i = subvals[r]; i <= sz + subvals[r]; i++)
            {
                if (dpsz[i - subvals[r]].none()) continue;
                dpsz2[i] = dpsz[i - subvals[r]];
                dpsz2[i][ind + r] = 1;
            }
        }   
        cout << "d4" << endl;
        dpsz = move(dpsz2);
        dpsz2 = move(dpsz4);
        for (auto& y : {dpsz, dpsz2}) {
            for (auto x : y) {
                ll s = 0;
                for (ll i = 0; i < 100; i++) {
                    if (x[i]) s += segments[i].size();
                }
                cout << s << ' ';
            }
            cout << endl;
        }
        sz *= 2;
    }
}