#include <iostream>
#include <vector>
#include "coins.h"
using namespace std;


int weigh(const vector<int> &a, const vector<int> &b);

int heavy = -1;

pair<int, int> solve(int a, int b, bool h){
    if (a+1 == b){
        int r = weigh({a}, {b});
        pair<int, int> ans;
        if (r==1 || r==-1) {
            ans.first = 1; ans.second = 1; heavy = (r==1)?a:b; return ans;
        } else {
            ans.first = 2; ans.second = 0; heavy = h?a:heavy; return ans;
        }
    }
    if (a+3 == b){
        int r1= weigh({a} , {a+1});
        int r = weigh({a, a+1}, {a+2, a+3});
        if (r1==1 || r1==-1){
            pair<int, int> ans;
            if (r==1){
                ans.first = 1; ans.second = 1; return ans;
            } else if (r==-1){
                ans.first = 3; ans.second = 3; return ans;
            } else {
                ans.first = 2; ans.second = 2; return ans;
            }
        }else {
            int r2 = weigh({a+2} , {a+3});
            if (r2==0){
                pair<int, int> ans;
                if (r == 1 || r == -1) {ans.first =2; ans.second = 2; return ans;}
                else {ans.first = 0; ans.second = 4; return ans;}
            } else {
                pair<int, int> ans;
                if (r==1) {ans.first=3; ans.second =3 ;return ans;}
                else {ans.first=1; ans.second =1 ;return ans;}
            }
        }
    }
    vector<int> fi((b-a+1)/2, 0);
    vector<int> si((b-a+1)/2, 0);
    for (int i=a; i<(b+a+1)/2; i++) fi[i-a] = i;
    for (int i=(b+a+1)/2; i<=b; i++) si[i-(b+a+1)/2] = i;
    int res = weigh(fi, si);
    bool s;
    if (res==1) s = true; else if (res==0) s = h; else {s=false;}
    pair<int, int> fhalf = solve(a , (a+b+1)/2-1, s);
    if (!res) {
        pair<int, int> ans;
        ans.first = 2*fhalf.first;
        ans.second = 2*fhalf.second;
        return ans;
    } else {

        pair<int, int> ans;
        if (res==-1) s = true; else if (res==0) s = h; else {s=false;}

        pair<int, int> shalf = solve((a+b+1)/2, b, s);
        if (res == 1){
            if (fhalf.first > shalf.first) {ans.first = fhalf.first+shalf.first;ans.second = fhalf.first+shalf.first;}
            if (fhalf.second > shalf.second) {ans.first = fhalf.second+shalf.second;ans.second = fhalf.second+shalf.second;}
            if (fhalf.first > shalf.second) {ans.first = fhalf.first+shalf.second;ans.second = fhalf.first+shalf.second;}
            if (fhalf.second > shalf.first) {ans.first = fhalf.second+shalf.first;ans.second = fhalf.second+shalf.first;}
            return ans;
        } else {
            if (fhalf.first < shalf.first) {ans.first = fhalf.first+shalf.first;ans.second = fhalf.first+shalf.first;}
            if (fhalf.second < shalf.second) {ans.first = fhalf.second+shalf.second;ans.second = fhalf.second+shalf.second;}
            if (fhalf.first < shalf.second) {ans.first = fhalf.first+shalf.second;ans.second = fhalf.first+shalf.second;}
            if (fhalf.second < shalf.first) {ans.first = fhalf.second+shalf.first;ans.second = fhalf.second+shalf.first;}
            return ans;
        }
    }


}

pair<int, int> count_heavy(int k){

    pair<int, int> res = solve(0, (int)(1<<k)-1, false);
    res.second = heavy;
    return res;
}

