#include <iostream>
#include <vector>
#include "coins.h"
using namespace std;


int weigh(const vector<int> &a, const vector<int> &b);


int bin_search(int a, int b){
    if (a==b) return a;
    int  m = (a+b+1)/2;

    vector<int> fi((b-a+1)/2, 0);
    vector<int> si((b-a+1)/2, 0);
    for (int i=a; i<(b+a+1)/2; i++) fi[i-a] = i;
    for (int i=(b+a+1)/2; i<=b; i++) si[i-(b+a+1)/2] = i;

    int r = weigh(fi, si);
    if (r==1){
        return bin_search(a, m-1);
    } else {
        return bin_search(m, b);
    }
}

pair<int, int> count_heavy(int k){
    if (k==1){
        pair<int, int> ans;
        ans.first = 1;
        ans.second = (weigh({0},{1})==1)?0:1;
        return ans;
    }
    int a = 0;
    int b = (int)(1<<k)-1;

    int  m = (a+b+1)/2;

    vector<int> fi((b-a+1)/2, 0);
    vector<int> si((b-a+1)/2, 0);
    for (int i=a; i<(b+a+1)/2; i++) fi[i-a] = i;
    for (int i=(b+a+1)/2; i<=b; i++) si[i-(b+a+1)/2] = i;

    int r= weigh(fi,si);
    if (r==1){
        int a = 0;
        int b = (int)(1<<(k-1))-1;

        int  m = (a+b+1)/2;

        vector<int> fi((b-a+1)/2, 0);
        vector<int> si((b-a+1)/2, 0);
        for (int i=a; i<(b+a+1)/2; i++) fi[i-a] = i;
        for (int i=(b+a+1)/2; i<=b; i++) si[i-(b+a+1)/2] = i;

        int r = weigh(fi,si);
        if (r==0){
            pair<int, int> ans; ans.first = (int)(1<<k)-1; ans.second = 0; return ans;
        } else {
            pair<int, int> ans; ans.first = 1; ans.second = bin_search(0, (int)(1<<k)-1); return ans;
        }
    } else if (r==-1){
        int a = (int)(1<<(k-1));
        int b = (int)(1<<k)-1;;

        int  m = (a+b+1)/2;

        vector<int> fi((b-a+1)/2, 0);
        vector<int> si((b-a+1)/2, 0);
        for (int i=a; i<(b+a+1)/2; i++) fi[i-a] = i;
        for (int i=(b+a+1)/2; i<=b; i++) si[i-(b+a+1)/2] = i;

        int r = weigh(fi,si);
        if (r==0){
            pair<int, int> ans; ans.first = (int)(1<<k)-1; ans.second = (int)(1<<k)-1; return ans;
        } else {
            pair<int, int> ans; ans.first = 1; ans.second = bin_search(0, (int)(1<<k)-1); return ans;
        }
    }
}

