#include <bits/stdc++.h>

using namespace std;

//#define int long long

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    const int MAXN = 1e5;

    vector<int> sieve(MAXN + 1, 1);

    sieve[1] = 0;
    for(int i = 2; i <= MAXN; i++) {
        for(int j = i + i; j <= MAXN; j += i) {
            sieve[j] += i;
        }
    }

    vector<vector<int>> ps(11, vector<int>(MAXN + 1));
    for(int i = 2; i <= MAXN; i++) {
        int si = sieve[i];
        for(int j = 10; j >= 1; j--) {
            ps[j][i] = ps[j][i - 1];
        }
        for(int j = min(10, si - 1); j >= 1; j--) {
            ps[j][i]++;
        }
    }

    int q;
    cin >> q;

    while(q--) {
        int l, r, v;
        cin >> l >> r >> v;
        int cnt = 0;
        if(v <= 10) {
            cnt = ps[v][r] - ps[v][l - 1];
        }
        else {
            for(int i = l; i <= r; i++) {
                cout << i << ' ' << sieve[i] << '\n';
                if(sieve[i] > v) {
                    cnt++;
                }
            }
        }
        cout << cnt << '\n';
    }

    return 0;
}
