// C
#include <cstdio>
#include <iostream>
#include <vector>


using namespace std;

#define ll long long


const ll N = 1e4+3;
ll spf[N];
// ll sum_prime_power[N];
ll sum_div[N];
ll ans[N][11];
ll power[N][20];

// void sieve()
// {
	
// }
void preprocess()
{
	for (ll i=1; i<N; i++)
		spf[i] = i;
	for (ll i=2; i<N; i+=2)
		spf[i] = 2;
	for (ll i=2; i*i<N; i++)
	{
		if (spf[i]==i)
		{
			for (ll j=i*i; j<N; j+=i)
			{
				if (spf[j]==j)
					spf[j] = i;
			}
			ll cur = i;
			power[i][0] = 1;
			for (ll j=1; j<20; j++)
			{
				power[i][j] = cur;
				cur*=i;
				if (cur>(N*N*N))
					break;
			}
		}
	}
	for (ll i=2; i<N; i++)
	{
		vector<pair<ll,ll>> primes;
		ll cur = i;
		while (cur!=1)
		{
			ll cnt = 0;
			ll cur_div = spf[cur];
			while (cur%cur_div==0)
			{
				cnt++;
				cur/=cur_div;
			}
			primes.push_back({cur_div, cnt});
		}
		ll temp = 1;
		for (pair<ll,ll> j:primes)
		{
			temp*=(((power[j.first][j.second+1]-1)/(j.first-1)));
		}
		sum_div[i] = temp;
	}
}



int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// sieve();
	preprocess();
	ll q;
	// scanf("%lld", &q);
	cin >> q;
	// calculate sum of divisors.
	// for every prime calculate:

	for (ll r=0; r<=N; r++)
	{
		for (ll i=1; i<=10; i++)
		{
			if (r==0)
			{
				ans[r][i] = 0;
				continue;
			}
			if ((sum_div[r]-r)>i)
				ans[r][i] = ans[r-1][i]+1;
			else
				ans[r][i] = ans[r-1][i];
		}
	}
	while (q--)
	{
		ll l,r,v;
		cin >> l >> r >> v;
		// scanf("%lld %lld %lld", &l, &r, &v);
		cout << ans[r][v] - ans[l-1][v] << endl;
		// printf("%lld\n", ans[r][v] - ans[l-1][v]);
	}
}