#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

int const N=1e3+10;
bool vis[N];
vector<int> primes[N];

int sum(int x)
{
	int ans=1;
	for(int j:primes[x])
	{
		int po=0;
		int n=x;
		while(n%j==0)
		{
			n/=j;
			po++;
		}
		int cnt=0;
		for (int k = 0; k <= po; ++k)
			cnt+=pow(j,k);
		ans*=cnt;
	}
	return ans;
}

void solve()
{
	int l,r,v;
	cin >> l >> r >> v;
	int ans=0;
	for (int i = l; i <= r; ++i)
	{
		int su=sum(i);
		su-=i;
		if(su>v)
			ans++;
	}
	cout << ans << endl;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL), cout.tie(NULL);
	for (int i = 2; i < N; ++i)
	{
		if(!vis[i])
			for (int j = i; j < N; j+=i)
			{
				vis[j]=true;
				primes[j].push_back(i);
			}
	}
	int t;
	cin >> t;
	while(t--)
		solve();
	return 0;
}