#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

int const N=1e5+50;
bool vis[N];
bool inc[N];
bool prime[N];
int pre_pri[N];
vector<int> primes[N];

int sum(int x)
{
	int ans=1;
	for(int j:primes[x])
	{
		int po=0;
		int n=x;
		while(n%j==0)
		{
			n/=j;
			po++;
		}
		int cnt=0;
		for (int k = 0; k <= po; ++k)
			cnt+=pow(j,k);
		ans*=cnt;
	}
	return ans;
}

void solve()
{
	int l,r,v;
	cin >> l >> r >> v;
	int ans=r-l+1;
	for (int i = 2; i < 300; ++i)
		if(!prime[i] and sum(i)-i<=v and i>=l and i<=r)
			ans--;
	ans-=pre_pri[r]-pre_pri[l-1];
	cout << ans << endl;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL), cout.tie(NULL);
	for (int i = 2; i < N; ++i)
	{
		if(!vis[i])
		{
			prime[i]=true;
			for (int j = i; j < N; j+=i)
			{
				vis[j]=true;
				primes[j].push_back(i);
			}
		}
	}
	pre_pri[0]=0;
	pre_pri[1]=0;
	for (int i = 2; i < N; ++i)
		if(prime[i])
			pre_pri[i]=pre_pri[i-1]+1;
		else
			pre_pri[i]=pre_pri[i-1];
	int t;
	cin >> t;
	while(t--)
		solve();
	return 0;
}