#include<iostream>

using namespace std;

#define INF 1e18
#define ll long long
const int N = (1<<18), M = 1e5+1;
ll ST[N][2];
ll a[M];

void update(int i, ll x)
{
  ST[i][1] = ST[i][0] = x;
  // cerr << "update("<<i<<", "<<x<<")\n";
  i/=2;
  while(i)
    {
      //  cerr << i << endl;
      ST[i][0] = min(ST[i*2][0],ST[i*2+1][0]);
      ST[i][1] = max(ST[i*2][1],ST[i*2+1][1]);
      //cerr << ST[i][0] << " " << ST[i][1] << endl;
      i/=2;
    }
}

int query(int l , int r, int v , int s = 1 , int e = N/2, int i = 1)
{
 
  if(l<=s and e<=r)
    {
      //cerr << l << " " << r << " "<<v << " "<<s<<" "<<e<<" "<<i<<endl;
      //cerr << ST[i][0] << " " << ST[i][1] << endl;
      if(ST[i][1]<=v)
	return 0;
      
      if(ST[i][0]>v)
	return (e-s+1);
    }
  if(r<s or e<l) return 0;
  int mid = (s+e)/2;
  return query(l,r,v,s,mid,i*2)+query(l,r,v,mid+1,e,i*2+1);
}

int main()
{
  for(int i=0;i<N;i++)
    {
      ST[i][0] = INF;
      ST[i][1] = -INF;
    }
  for(int i=1;i<M;i++)
      for(int j=i+i;j<M;j+=i)
	a[j]+=i;

  for(int i=1;i<M;i++)
    update(N/2 + i -1,a[i]);
  
    
  int t;
  scanf("%d",&t);
  while(t--)
    {
      int l, r, v;
      scanf("%d %d %d",&l,&r,&v);
      printf("%d\n",query(l,r,v));
    }
  return  0;
}
