#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const long long  N=100001;
long long prime[N];
long long sum[N][101];
void sieve()
{

	for(int i=2;i<=N;i++)
	{
		for(int j=i+i;j<=N;j+=i)
			prime[j]+=i;
		prime[i]+=1;
	}
}
void ss()
{
	for(int i=1;i<=N;i++)
	{
		for(int j=0;j<=100;j++)
			if(j!=prime[i])
				sum[i][j]=sum[i-1][j];
		if(prime[i]<101)
			sum[i][prime[i]]=1+sum[i-1][prime[i]];
	}
}
int rich_number(int l,int r,int v)
{
	int cnt=0;
	if(v<=100)
	{
		for(int i=v;i>=1;i--)
		{
			cnt+=(sum[r][i]-sum[l-1][i]);
		}
		cnt=(r-l+1)-cnt;
	}
	else
	{
		for(int i=l;i<=r;i++)
			if(prime[i]>v)
				cnt++;
	}
	if(l==1 and v!=0)
		cnt--;
	return cnt;
}
int main()
{
	sieve();
	ss();
	int t;
	cin>>t;
	while(t--)
	{
		int l,r,v;
		cin>>l>>r>>v;
		cout<<rich_number(l,r,v)<<endl;
	}
}