#ifndef COINS_H_INCLUDED

#include <vector>
#include <bits/stdc++.h>

int weigh(const std::vector<int> &a, const std::vector<int> &b);

std::pair < int, int > go_down_and_hope_for_the_best ( int st, int dr, int max_only );

int perm[( 1 << 20)];
std::pair<int, int> count_heavy ( int k ) {
    if ( k == 1 ) {
        if ( weigh ( {0}, {1} ) == 1 )
            return { 1, 0 };
        return { 1, 1 };
    }

    for ( int i = 0; i < ( 1 << k ); i++ )
        perm[i] = i;

    std::random_shuffle ( perm, perm + ( 1 << k ) );

    return go_down_and_hope_for_the_best ( 0, ( 1 << k ) - 1, 1 );
}

std::pair < int, int > go_down_and_hope_for_the_best ( int st, int dr, int max_only ) {
    if ( st + 1 == dr ) {
        int rez = weigh ( { perm[st] }, { perm[dr] } );
        if ( rez == 0 )
            return { 2 * max_only, perm[st] };
        else if ( rez == 1 )
            return { 1, perm[st] };
        return { 1, perm[dr] };
    }
    std::vector < int > a, b;
    int mij = ( st + dr ) / 2;
    for ( int i = st; i <= mij; i++ )
        a.push_back ( perm[i] );
    for ( int i = mij + 1; i <= dr; i++ )
        b.push_back ( perm[i] );
    int rez = weigh ( a, b );
    if ( rez == 0 ) {
        std::pair < int, int > x = go_down_and_hope_for_the_best ( st, mij, max_only );
        return { 2 * x.first, x.second };
    } else {
        std::pair < int, int > left = go_down_and_hope_for_the_best ( st     , mij, rez == 1  ),
                              right = go_down_and_hope_for_the_best ( mij + 1,  dr, rez == -1 );
        left.first += right.first;
        if ( rez == -1 )
            left.second = right.second;
        return left;
    }
}

#define COINS_H_INCUDED
#endif // COINS_H_INCLUDED