#include <iostream>
#include <vector>

using namespace std;

struct vect{
    short int edge[2001];
    short int nr=0;
}v[2001];

int pos[2001][2001];
int com[2001];
bool ver[2001];

int c[2001];
int t[2001];


void jump(int i,int s,int j,int m)
{
    if(j<m)
    {
        pos[s][i]=j;
        for(int k=1;k<=v[i].nr;k++)
        {
            if(pos[s][v[i].edge[k]]>pos[s][i]+1 || pos[s][v[i].edge[k]]==0)
                jump(v[i].edge[k],s,j+1,m);
        }
    }
    if(j==m)
        pos[s][i]=j;
}


long long mini=2000000001;
short int n;

void afis()
{
    int j,i;
    bool p=1;
    long long s=0;
    for(i=1;i<=n && p;i++)
    {
        if(ver[i]==0)
        {
            p=0;
            for(j=1;j<=n && !p;j++)
                if(com[j]>=pos[j][i] && pos[j][i]!=0)
                    p=1;
        }
        if(p)
            s+=c[com[i]];
    }
    if(s<mini && p)
    {
        mini=s;
    }
}

void backtrack(int i,int n)
{
    if(i<=n)
    {
        int j;
        for(j=1;j<=n && !(ver[i]);j++)
            if(com[j]>=pos[j][i] && pos[j][i]!=0)
                ver[i]=1;
        for(com[i]=0;com[i]<=pos[i][0];com[i]++)
        {
            if(com[i]>=1)
                ver[i]=1;
            backtrack(i+1,n);
            afis();
        }
        com[i]=0;
        ver[i]=0;
    }
}


int main()
{
    bool p=1;
    short int i;
    int x,y,j;
    cin>>n;
    for(i=1;i<=n;i++)
        cin>>c[i];
    for(i=1;i<=n;i++)
        cin>>t[i];
    for(i=1;i<n;i++)
    {
        cin>>x>>y;
        v[y].edge[++v[y].nr]=x;
        v[x].edge[++v[x].nr]=y;
    }

    for(i=1;i<=n && p==1;i++)
    {
        if(v[i].nr==0)
        {
            cout<<"-1";
            p=0;
        }
        else
        {
            jump(i,i,1,t[i]);
        }
    }
    //cerr<<"jump clear"<<endl;
    if(p==1)
    {
        for(i=1;i<=n;i++)
        {
            for(j=1;j<=n;j++)
            {
                pos[i][0]=max(pos[i][0],pos[i][j]);
            }
        }
        //cerr<<"max pos clear"<<endl;
        backtrack(1,n);
        cout<<mini;
    }
    //cerr<<"clear";
    return 0;
}
