#include "coins.h"
#include <vector>
//#include <fstream>

using namespace std;

//ofstream fout("file.out");

int count(vector<int> a, int &poz) {
    if (a.size() == 2) {
        vector<int> x;
        x.push_back(a[0]);
        vector<int> y;
        y.push_back(a[1]);
        int w = weigh(x, y);
        if (w == -1)
            poz = a[1];
        else if (w == 1)
            poz = a[0];
        if (w == 0)
            return 0;
        return 1;
    }
    vector<int> x;
    for (int i = 0; i < a.size()/2; i++)
        x.push_back(a[i]);
    vector<int> y;
    for (int i = a.size()/2; i < a.size(); i++)
        y.push_back(a[i]);
    int w = weigh(x, y);
    int xw = count(x, poz), yw = count(y, poz);
    if (xw == 0 && w == 1)
        return x.size() + yw;
    if (yw == 0 && w == -1)
        return xw + y.size();
    return xw + yw;
}

pair<int,int> sol1(int k) {
    vector<int> a;
    for (int i = 0; i < (1 << k); i++)
        a.push_back(i);
    int poz;
    int val = count(a, poz);
    return pair<int,int>(val,poz);
}

int find(vector<int> a) {
    vector<int> x,y;
    if (a.size() == 2) {
        x.push_back(a[0]);
        y.push_back(a[1]);
        if (weigh(x, y) == -1)
            return y[0];
        return x[0];
    }
    for (int i = 0; i < a.size()/2; i++)
        x.push_back(a[i]);
    for (int i = a.size()/2; i < a.size(); i++)
        y.push_back(a[i]);
    if (weigh(x,y) == -1)
        return find(y);
    return find(x);
}

pair<int,int> sol2(int k) {
    vector<int> x;
    for (int i = 0; i < (1<<(k -1)); i++)
        x.push_back(i);
    vector<int> y;
    for (int  i = (1<<(k-1)); i < (1<<k); i++)
        y.push_back(i);
    int w = weigh(x, y);
    vector<int> c;
    if (w == -1)
        c = y;
    else
        c = x;
    vector<int> x2;
    for (int i = 0; i < c.size()/2; i++)
        x2.push_back(c[i]);
    vector<int> y2;
    for (int  i = c.size()/2; i < c.size(); i++)
        y2.push_back(c[i]);
    if (weigh(x2, y2) == 0)
        return pair<int,int>((1<<k)-1,x2[0]);
    return pair<int,int>(1,find(c));
}

pair<int, int> count_heavy(int k) {
    if (k <= 10)
        return sol1(k);
    return sol2(k);
}