#include <iostream>
#include <vector>
#include <tuple>

using namespace std;

typedef tuple<int,int,int> query;

const int maxn = 1e5;
const int maxv = 100;
int sumdiv[maxn];
int rich[maxn][maxv];
int queries[maxn][3];

void preprocess() {
    for (int i = 2; i <= maxn; i++) {
        sumdiv[i] = 1;
        int j;
        for (j = 2; j * j < i; j++)
            if (i % j == 0)
                sumdiv[i] += j + i/j;
        if (j * j == i)
            sumdiv[i] += j;
        for (int k = 1; k <= maxv; k++)
            rich[i][k] = (sumdiv[i] > k);
    }
    for (int j = 1; j <= maxv; j++)
        for (int i = 2; i <= maxn; i++)
            rich[i][j] += rich[i - 1][j];

    //for (int i = 0; i <= 20; i++)
     //   cout << rich[i][20] << ' ';
}

int main() {
    preprocess();
    ios_base::sync_with_stdio(false);
    int q;
    cin >> q;
    for (int k = 0; k < q; k++)
        for (int j  =0; j <3; j++)
            cin >> queries[k][j];
    for (int i = 0; i < q; i++) {
        int l = queries[i][0];
        int r = queries[i][1];
        int v = queries[i][2];
        cout << rich[r][v] - rich[l - 1][v] << '\n';
    }

    return 0;
}