#include <bits/stdc++.h>
#define NMAX 2000
#define int64 long long

using namespace std;

struct strinter {
  int l, r, cost;
};

int n;
int vcost[NMAX + 1], vpump[NMAX + 1];
vector <int> vsons[NMAX + 1];
vector <strinter> vinter;
int64 dp[NMAX + 1];

void dfs(int node, int tata, int level) {
  int nsons, i;

  for (i = 1; i <= min(vpump[node], n); i++) {
    vinter.push_back({max(1, level - i + 1), min(n, level + i + 1), vcost[i]});
  }

  nsons = vsons[node].size();
  for (i = 0; i < nsons; i++) {
    if (vsons[node][i] != tata)
      dfs(vsons[node][i], node, level + 1);
  }
}

int main() {
  freopen("garden.in", "r", stdin);
  freopen("garden.out", "w", stdout);

  int i, x, y, j;
  cin >> n;

  for (i = 1; i <= n; i++) {
    cin >> vcost[i];
  }

  for (i = 1; i <= n; i++) {
    cin >> vpump[i];
  }

  for (i = 0; i < n; i++) {
    cin >> x >> y;
    vsons[x].push_back(y);
  }

  int top;
  for (i = 1; i <= n; i++) {
    if (vsons[i].size() == 1)
      top = i;
  }

  dfs(top, 0, 1);

  for (i = 1; i <= n; i++) {
    dp[i] = LLONG_MAX;
    for (j = 1; j <= vinter.size(); j++) {
      if (i >= vinter[j].l && i <= vinter[j].r)
        dp[i] = min(dp[i], dp[vinter[j].l - 1] + vinter[j].cost);
    }
  }

  cout << dp[n];
  return 0;
}
