#include <bits/stdc++.h>
#define INMAX 100000
#define int64 long long

using namespace std;

int sol;
vector <int> vprime;
bool vciur[INMAX + 1];

void prec_ciur() {
  int i, j;

  for (i = 2; i * i <= INMAX; i++) {
    if (vciur[i] == 0) {
      for (j = i * i; j <= INMAX; j += i)
        vciur[j] = 1;
    }
  }
}

void prec_prime() {
  int i;
  for (i = 2; i <= INMAX; i++) {
    if (vciur[i] == 0)
      vprime.push_back(i); /// se poate optimiza la vector normal
  }
}

void bkt(int nextdiv, int crtval, int crtsumdiv, int maxval, int maxsumdiv) {
  if (crtsumdiv <= maxsumdiv) {
    sol++;
    //cout << crtval << " ";
  }

  int i, ok;

  ok = 0;
  i = nextdiv;
  while (i < vprime.size() && (int64)crtval * vprime[i] <= maxval && ok == 0) {
    int div = vprime[i];
    int copval = crtval;
    int copsumdiv = crtsumdiv;
    crtsumdiv = copsumdiv + copval;
    int64 sumadd = crtsumdiv;

    while ((int64)crtval * div <= maxval) {
      sumadd *= div;
      crtval *= div;
      if (crtsumdiv + sumadd - crtval <= maxsumdiv) {
        crtsumdiv = crtsumdiv + sumadd;
        bkt(i + 1, crtval, crtsumdiv - crtval, maxval, maxsumdiv);
      }
      else {
        if (crtval == copval * div)
          ok = 1;
        break;
      }
    }

    crtval = copval;
    crtsumdiv = copsumdiv;
    i++;
  }
}

int query(int val, int v) {
  if (val == 0)
    return 0;
  sol = 0;
  bkt(0, 1, 0, val, v);
  //cout << "\n";
  return val - sol;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);

  ///!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//    freopen("a.in", "r", stdin);
//    freopen("a.out", "w", stdout);
  //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  int i, q, l, r, v;
  cin >> q;

  prec_ciur();
  prec_prime();

  while (q--) {
    cin >> l >> r >> v;
    cout << query(r, v) - query(l - 1, v) << "\n";
  }
  return 0;
}