#include <bits/stdc++.h>
#define INMAX 100000
#define int64 long long

using namespace std;

int nprime;
int sol;
int vprime[10000];
bool vciur[INMAX + 1];
int vclose[INMAX + 1];

void prec_ciur() {
  int i, j, last;

  vciur[1] = 1;
  for (i = 2; i <= INMAX; i++) {
    if (vciur[i] == 0) {
      for (j = 2 * i; j <= INMAX; j += i)
        vciur[j] = 1;
      vprime[nprime++] = i;
      last = nprime - 1;
    }
    vclose[i] = last;
  }
}

void bkt(int nextdiv, int crtval, int crtsumdiv, int maxval, int maxsumdiv) {
  if (crtsumdiv <= maxsumdiv && vciur[crtval] == 1) {
    sol++;
  }

  int i, ok;

  ok = 0;
  i = nextdiv;
  while (i < nprime && vprime[i] <= maxsumdiv && (int64)crtval * vprime[i] <= maxval && ok == 0) {
    int div = vprime[i];
    int copval = crtval;
    int copsumdiv = crtsumdiv;
    crtsumdiv = copsumdiv + copval;
    int64 sumadd = crtsumdiv;

    while ((int64)crtval * div <= maxval) {
      sumadd *= div;
      crtval *= div;
      if (crtsumdiv + sumadd - crtval <= maxsumdiv) {
        crtsumdiv = crtsumdiv + sumadd;
        bkt(i + 1, crtval, crtsumdiv - crtval, maxval, maxsumdiv);
      }
      else {
        if (crtval == copval * div)
          ok = 1;
        break;
      }
    }

    crtval = copval;
    crtsumdiv = copsumdiv;
    i++;
  }
}

int query(int val, int v) {
  if (val == 0)
    return 0;
  sol = 0;
  bkt(0, 1, 0, val, v);
  sol += vclose[val] + 1;
  return val - sol;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);

  ///!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//    freopen("a.in", "r", stdin);
//    freopen("a.out", "w", stdout);
  //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  int i, q, l, r, v;
  cin >> q;

  prec_ciur();

  while (q--) {
    cin >> l >> r >> v;
    cout << query(r, v) - query(l - 1, v) << "\n";
  }
  return 0;
}
