#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;

bool sieve[100005];
vector<int>primes;
int sp[100005][12];
int NMAX = 100000;

long long sumdiv(vector<int>f,vector<int>e)
{
    long long suma = 1ll;
    for (int i = 0; i < f.size(); i++)
    {
        long long p = f[i];
        long long d = e[i];
        long long pp = 1ll;
        for (int j = 1; j <= d + 1; j++)
            pp *= p;
        long long add = (pp - 1) / (p - 1);
        suma *= add;
    }
    return suma;
}

void prec()
{
    sieve[0] = sieve[1] = true;
    for (int i = 2; i * i <= NMAX; i++)
        if (!sieve[i])
            for (int j = 2 * i; j <=NMAX; j += i)
                sieve[j] = true;
    for (int i = 2; i <= NMAX; i++)
        if (!sieve[i])
            primes.push_back(i);
    for (int v = 1; v <= 10; v++)
    {
        for (int x = 1; x <= NMAX; x++)
        {
            vector<int>f,e;
            sp[x][v] = sp[x - 1][v];
            int y = x;
            for (int i = 0; primes[i] * primes[i] <= y; i++)
            {
                if (y % primes[i] == 0)
                {
                    f.push_back(primes[i]);
                    int ex = 0;
                    while (y % primes[i] == 0)
                        ex++,y /= primes[i];
                    e.push_back(ex);
                }
            }
            if (y != 1)
            {
                f.push_back(y);
                e.push_back(1);
            }
            long long suma = sumdiv(f,e) - x;
            if (suma > v)
                sp[x][v]++;
        }
    }
}

int main()
{
    prec();
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int q;
    cin >> q;
    while (q--)
    {
        int l,r,v;
        cin >> l >> r >> v;
        cout << sp[r][v] - sp[l - 1][v] << '\n';
    }
    return 0;
}
