#include <bits/stdc++.h>

using namespace std;

struct query
{
    int l,r,v,pos;
};

bool cmp(query A,query B)
{
    return A.v > B.v;
}

const int NMAX = 100000;
int val[100005];
bool sieve[100005];
vector<int>primes;
vector<pair<int,int>>vals;
int rsp[100005];

int q;
query a[100005];
int aib[100005];

int sumdiv(vector<int>f,vector<int>e)
{
    long long suma = 1ll;
    for (int i = 0; i < f.size(); i++)
    {
        long long p = f[i];
        long long d = e[i];
        long long pp = 1ll;
        for (int j = 1; j <= d + 1; j++)
            pp *= p;
        long long add = (pp - 1) / (p - 1);
        suma *= add;
    }
    return suma;
}

void prec()
{
    sieve[0] = sieve[1] = true;
    for (int i = 2; i * i <= NMAX; i++)
        if (!sieve[i])
            for (int j = 2 * i; j <=NMAX; j += i)
                sieve[j] = true;
    for (int i = 2; i <= NMAX; i++)
        if (!sieve[i])
            primes.push_back(i);
    for (int x = 1; x <= NMAX; x++)
    {
        vector<int>f,e;
        int y = x;
        for (int i = 0; primes[i] * primes[i] <= y; i++)
        {
            if (y % primes[i] == 0)
            {
                f.push_back(primes[i]);
                int ex = 0;
                while (y % primes[i] == 0)
                    ex++,y /= primes[i];
                e.push_back(ex);
            }
        }
        if (y != 1)
        {
            f.push_back(y);
            e.push_back(1);
        }
        int suma = sumdiv(f,e) - x;
        val[x] = suma;
    }
}

void update(int pos)
{
    for (int i = pos; i <= NMAX; i += (i & -i))
        aib[i]++;
}

int query(int pos)
{
    int sum = 0;
    for (int i = pos; i >= 1; i -= (i & -i))
        sum += aib[i];
    return sum;
}

int main()
{
    prec();
    cin >> q;
    for (int i = 1; i <= q; i++)
        cin >> a[i].l >> a[i].r >> a[i].v,a[i].pos = i;
    sort(a + 1,a + q + 1,cmp);
    for (int i = 1; i <= NMAX; i++)
        vals.push_back({val[i],i});
    sort(vals.begin(),vals.end());
    reverse(vals.begin(),vals.end());
    int i1 = 0;
    for (int i = 1; i <= q; i++)
    {
        while (i1 < vals.size() and vals[i1].first > a[i].v)
            update(vals[i1].second),i1++;
        rsp[a[i].pos] = query(a[i].r) - query(a[i].l - 1);
    }
    for (int i = 1; i <= q; i++)
        cout << rsp[i] << '\n';
    return 0;
}
