#include <iostream>
#include <cstring>
#include <vector>
#include <climits>
#define MAX 2002
using namespace std;
int n,c[MAX],t[MAX],x,y,ans=INT_MAX,vf[MAX],d[MAX],nrd,cost,st[MAX];
vector<int> v[MAX];

void infect(int nod, int niv){
    vf[nod] = 1;
    if(d[nod] == 0){
        nrd++;
    }
    d[nod] = 1;
    if(niv > 0){
        for(int i = 0; i < v[nod].size(); i++){
            int vecin = v[nod][i];
            if(vf[vecin] == 0){
                infect(vecin, niv-1);
            }
        }
    }
}

void dezinfect(int nod, int niv){
    vf[nod] = 1;
    if(d[nod] == 1){
        nrd--;
    }
    d[nod] = 0;
    if(niv > 0){
        for(int i = 0; i < v[nod].size(); i++){
            int vecin = v[nod][i];
            if(vf[vecin] == 0){
                dezinfect(vecin, niv-1);
            }
        }
    }
}

void backtrack(int pas){
    if(nrd == n || pas >= n+1){
        if(nrd == n){
            ans = min(ans, cost);
        }
    }else{
        for(int i = 0; i < 2; i++){
            if(i == 1 && t[pas] == 0){
                continue;
            }
            if(i == 1){
                for(int j = 1; j <= t[pas]; j++){
                    memset(vf, 0, sizeof(vf));
                    infect(pas, j);
                    memset(vf, 0, sizeof(vf));
                    cost += c[j+1];
                    st[pas] = j;
                    backtrack(pas+1);
                    cost -= c[j+1];
                    memset(vf, 0, sizeof(vf));
                    dezinfect(pas, j);
                }
            }else{
                st[pas] = 0;
                backtrack(pas+1);
            }
        }
    }
}

int main()
{
    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> c[i];
    }
    for(int i = 1; i <= n; i++){
        cin >> t[i];
    }
    for(int i = 1; i < n; i++){
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    backtrack(1);
    cout << ans;
    return 0;
}
