#include <iostream>
#include <vector>
#include "coins.h"
using namespace std;

int v[1005],k;

int weigh(const vector<int> &a, const vector<int> &b){

    int sum1 = 0,sum2 = 0;

    for(int i=0;i<a.size();i++){
        sum1+=v[a[i]];
    }

    for(int i=0;i<b.size();i++){
        sum2+=v[b[i]];
    }

    if(sum1 == sum2){
        return 0;
    }else if (sum1 > sum2){
        return 1;
    }else{
        return -1;
    }

}

pair<int, int> count_heavy(int k){
    vector <int> a;
    a.push_back(1);

    int heavyPoz,sol = 1;

    for(int i=2;i<=(1<<k);i++){
        vector <int> b;
        b.push_back(i);

        int tmp = weigh(a,b);
        if(tmp !=0 ){
            if(tmp == 1){
                heavyPoz = 1;
            }else{
                heavyPoz = i;
            }
            break;
        }
    }

    vector <int> a2;
    a2.push_back(heavyPoz);

    for(int i=1;i<=(1<<k);i++){
        if(i!=heavyPoz){
            vector <int> b2;
            b2.push_back(i);

            if(weigh(a2,b2) == 0){
                sol++;
            }
        }
    }

    return {heavyPoz,sol};
}

/*int main()
{
    cin>>k;
    for(int i=1;i<=(1<<k);i++){
        cin>>v[i];
    }
    pair <int,int> sol = count_heavy(k);

    cout<<sol.first<<" "<<sol.second;
    return 0;
}*/

