#include <iostream>
#include <vector>
#include "coins.h"
using namespace std;


pair<int, int> count_heavy(int k){

    int heavyPoz = -1,sol = -1;
    int poz1 = -1,poz2 = -1,diff = 0;

    for(int i=0;i+1<(1<<k);i+=2){
        vector <int> a;
        a.push_back(i);

        vector <int> b;
        b.push_back(i+1);

        int tmp = weigh(a,b);
        if(tmp != 0){

            diff = tmp;
            poz1 = i;
            poz2 = i+1;
        }
    }

    if(diff == -1){ /// poz1 < poz2
        vector <int> a;
        a.push_back(poz1);

        vector <int> b;
        if(poz1 == 0){
            b.push_back((1<<k)-1);
        }else{
            b.push_back(poz1-1);
        }

        if(weigh(b,a) == 1){ ///pozb > poz1
            sol = (1<<k)-1;
            heavyPoz = b.front();
        }else{
            sol = 1;
            heavyPoz = poz2;
        }
    }else{ /// poz1 > poz2
        vector <int> a;
        a.push_back(poz2);

        vector <int> b;
        if(poz2 == (1<<k)-1){
            b.push_back(0);
        }else{
            b.push_back(poz2+1);
        }

        if(weigh(a,b) == -1){ ///poz2 < pozf
            sol = (1<<k)-1;
            heavyPoz = b.front();
        }else{
            sol = 1;
            heavyPoz = poz1;
        }
    }

    return {sol,heavyPoz};
}
