#include <iostream>
#include <tuple>
#include <vector>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>

#define all(x) (x).begin(),(x).end() 

using namespace std;
// using namespace __gnu_pbds;

using ll = long long;
// #define int ll
#define sz(x) (int)(x).size()

using pii = pair<int,int>;
using tii = tuple<int,int,int>;
using tiii = tuple<int,int,int,int>;
// typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;

const int nmax = 1e5 + 5, vmax = 304920 + 5;

int sum[nmax];

#define lsb(x) (x & -x)
namespace AIB {
	int tree[nmax];
	int len = nmax - 1;
	void upd(int a, int b) {
		a++;
		while(a	<= len)
			tree[a] += b, a += lsb(a);
		return;
	}
	int query(int a) {
		a++;
		int sum = 0;
		while(a > 0)
			sum += tree[a], a -= lsb(a);
		return sum;
	}
};

vector<pii> aint[nmax * 4];
int rez[nmax];

int fl[nmax * 4], fr[nmax * 4], ptrf = 2;



void _push(int l, int r, int v, int i, int node = 1, int cl = 1, int cr = nmax - 1) {
	if(cr < l || r < cl) return;
	if(l <= cl && cr <= r) {
		// cerr << l << ' ' << cl << ' ' << cr << ' ' << r << '\n';
		aint[node].emplace_back(v, i);
		return;
	}
	int mid = cl + cr >> 1;
	_push(l, r, v, i, 2 * node, cl, mid);
	_push(l, r, v, i, 2 * node + 1, mid + 1, cr);
}
void calculate(int node = 1, int cl = 1, int cr = nmax - 1) {
	// AIB::init(nmax - 1);
	// #warning incearca totusi vmax
	if(aint[node].size()) {
		// cerr << node << ' ' << cl << ' ' << cr << ' ' << aint[node].size() << '\n';
		for(int i = cl; i <= cr; i++)
			AIB::upd(sum[i], 1);
		for(auto [v, i] : aint[node])
			// cerr << v << ' ' << i << ' ' << cl << ' ' << cr << '\t' << AIB::query(v) << '\n',
			rez[i] += cr - cl + 1 - AIB::query(v);
		for(int i = cl; i <= cr; i++)
			AIB::upd(sum[i], -1);
	}
	
	if(cl != cr) {
		int mid = cl + cr >> 1; 
		calculate(2 * node, cl, mid);
		calculate(2 * node + 1, mid + 1, cr);
	}
	
	
	return;
}

void push(int l, int r, int v, int i) {
	_push(l, r, v, i);
}

signed main() {
	cin.tie(0) -> sync_with_stdio(0);
	for(int i = 1; i < nmax; i++) {
		for(int j = i * 2; j < nmax; j += i)
			sum[j] += i;
	}
	
	int q;
	cin >> q;
	for(int i = 0, l, r, v; i < q; i++) {
		cin >> l >> r >> v;
		push(l, r, v, i);
	}
	calculate();
	
	for(int i = 0; i < q; i++) 
		cout << rez[i] << '\n';
}
