#include "coins.h"

#include <vector>
#include <stdio.h>

// int weigh( const vector<int> &a, const vector<int> &b )

std::pair<int, int> num_elem( std::vector<int> poz ){ // it is guaranteed that there is at leas one heavy position
	int n = poz.size(), half = n >> 1, i, st, dr, mij, aux, vst, vdr;
	std::vector<int> a, b;

	a.reserve( half );
	b.reserve( half );

	for( i = 0 ; i < half ; i++ )
		a.push_back( poz[i] );
	for( i = half ; i < n ; i++ )
		b.push_back( poz[i] );

	if( n == 2 ){
		aux = weigh( a, b );

		if( aux == 0 )
			return std::make_pair( 2, a[0] );
		if( aux == +1 )
			return std::make_pair( 1, a[0] );
		if( aux == -1 )
			return std::make_pair( 1, b[0] );
	}

	vst = weigh( a, b );
	vdr = -vst;

	if( vst ){
		st = 0;
		dr = half;
		while( dr - st > 1 ){
			mij = (st + dr) >> 1;

			for( i = 0 ; i < mij ; i++ )
				std::swap( a[i], b[i] );

			aux = weigh( a, b );

			if( !aux ){
				auto p = num_elem( a );

				return std::make_pair( p.first << 1, p.second );
			}

			for( i = 0 ; i < mij ; i++ )
				std::swap( a[i], b[i] );

			if( aux == vdr )
				dr = mij;
			else
				st = mij;
		}
	}else{
		auto p = num_elem( a );

		return std::make_pair( p.first << 1, p.second );
	}

	if( vst > 0 ){
		for( i = 0 ; i < st ; i++ )
			std::swap( a[i], b[i] );

		auto p = num_elem( a );

		return std::make_pair( (p.first << 1) - 1, p.second );
	}else{
		for( i = 0 ; i < dr ; i++ )
			std::swap( a[i], b[i] );

		auto p = num_elem( a );

		return std::make_pair( (p.first << 1) - 1, p.second );
	}
}

std::pair<int, int> count_heavy( int k ){
	int n = 1 << k, i;
	std::vector<int> init;

	init.reserve( n );

	for( i = n ; i-- ; )
		init.push_back( i );

    return num_elem( init );
}

