#include <bits/stdc++.h>

#include "coins.h"

using namespace std;

const int NMAX=(1<<20)+5;

int aib[NMAX];

int ub(int x)
{
    return x&(-x);
}

void update(int n, int poz, int v)
{
    poz++;
    for(;poz<=n;poz+=ub(poz))
        aib[poz]+=v;
}

int query(int poz)
{
    poz++;
    int r=0;
    for(;poz>0;poz-=ub(poz))
        r+=aib[poz];
    return r;
}

vector<int> known;

int theHeavy;

bool checkHeavy(int x)
{
    vector<int> v1;
    v1.push_back(x);
    vector<int> v2;
    v2.push_back(theHeavy);
    return (weigh(v1,v2)==0);
}

int getOne(int st, int dr)
{
    if(st==dr)
        return st;
    int mij=(st+dr)/2;
    vector<int> v1;
    vector<int> v2;
    for(int i=st;i<=mij;i++)
        v1.push_back(i);
    for(int i=mij+1;i<=dr;i++)
        v2.push_back(i);
    int r=weigh(v1,v2);
    if(r>=0)
        return getOne(st,mij);
    return getOne(mij+1,dr);

}

bool celPutinUna(int st, int dr)
{
    if(st>dr)
        return 0;
    if(st==dr)
    {
        if(st==theHeavy)
            return 0;
        return 1;
    }
    vector<int> v1,v2;
    int mij=(st+dr)/2;
    for(int i=st;i<=mij;i++)
        v1.push_back(i);
    for(int i=mij+1;i<=dr;i++)
        v2.push_back(i);
    int r = weigh(v1,v2);
    int unde=1;
    if(theHeavy>=mij+1)
        unde=-1;

    //unde 1 st
    //-1 dr
    if(r==0)
        return 1;
    if(r==unde)
    {
        if(r==1)
            return celPutinUna(st,mij);
        return celPutinUna(mij+1,dr);
    }
    else return 1;

}

bool isHeavy[NMAX];

int getSecond(int st, int dr)
{
    if(st==dr)
        return st;
    int mij=(st+dr)/2;
    vector<int> v1,v2;
    for(int i=st;i<=mij;i++)
    {
        if(!isHeavy[i])
            v1.push_back(i);
    }
    for(int i=mij+1;i<=dr;i++)
    {
        if(!isHeavy[i])
            v2.push_back(i);
    }
    int s1=v1.size();
    int s2=v2.size();
    if(s1==s2)
    {
        int r=weigh(v1,v2);
        if(r>=0)
            return getSecond(st,mij);
        else return getSecond(mij+1,dr);
    }
    else if(s1<s2)
    {
        vector<int> v3;
        int d=s2-s1;
        for(auto it:v2)
        {
            if(d==0)
                break;
            if(!checkHeavy(it))
            {
                d--;
            }
            else v3.push_back(it);
        }
        if(d)
        {
            while(d>0)
            {
                d--;
                v3.pop_back();
            }
        }
        int r=weigh(v1,v3);
        if(r>=0)
            return getSecond(st,mij);
        return getSecond(mij+1,dr);
    }
    else{
        vector<int> v3;
        int d=s1-s2;
        for(auto it:v1)
        {
            if(d==0)
                break;
            if(!checkHeavy(it))
            {
                d--;
            }
            else v3.push_back(it);
        }
        if(d)
        {
            while(d>0)
            {
                d--;
                v3.pop_back();
            }
        }
        int r=weigh(v2,v3);
        if(r<0)
            return getSecond(st,mij);
        return getSecond(mij+1,dr);
    }
}


pair<int,int> count_heavy(int k)
{
    int n = (1<<k);
    theHeavy = getOne(0,n-1);
    int ans = 1;
    if(!celPutinUna(0,n-1))
        return make_pair(ans,theHeavy);
    known.push_back(theHeavy);
    isHeavy[theHeavy]=1;
    //update(n,theHeavy,1);
    int i;
    for(i=2;i<=k;i++)
    {
        known.push_back(getSecond(0,n-1));
        vector<int> v1;
        v1.push_back(theHeavy);
        vector<int> v2;
        v2.push_back(known.back());
        if(weigh(v1,v2)!=0)
            break;
        isHeavy[known.back()]=1;
        //update(n,known.back(),1);
    }
    return make_pair(i-1,theHeavy);
}
