#include <bits/stdc++.h>

using namespace std;

int mymin(int a, int b)
{
    return (a<b?a:b);
}

int mymax(int a, int b)
{
    return(a>b?a:b);
}

const int NMAX = 2005;

int timp[NMAX];
int cost[NMAX];
int n;

int minc[NMAX][NMAX];

vector<int> g[NMAX];

vector<int> lant;

void dfs(int nod, int dad)
{
    lant.push_back(nod);
    for(auto it:g[nod])
        if(it!=dad)
            dfs(it,nod);
}

int suf[NMAX];
int dp[NMAX];

const int INF = 2e9 + 1;

void solve()
{
    cin>>n;
    for(int i=1;i<=n;i++)
        cin>>cost[i];
    for(int i=1;i<=n;i++)
        cin>>timp[i];
    for(int i=1;i<n;i++)
    {
        int u,v;
        cin>>u>>v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int root;
    for(int i=1;i<=n;i++)
        if(g[i].size()==1)
            root=i;
    lant.push_back(0);
    dfs(root,0);
    dp[0]=0;
    for(int i=1;i<=n;i++)
    {
        minc[i][i]=cost[i];
        for(int j=i+1;j<=n;j++)
            minc[i][j]=mymin(minc[i][j-1],cost[j]);
    }
    for(int i=1;i<=n;i++)
    {
        dp[i]=-1;
        for(int j=i-1;j>=0;j--)
        {
            for(int k=j+1;k<=i;k++)
            {
                int p = mymax(i-k+1,k-j);
                if(p<=timp[lant[k]]&&dp[j]!=-1)
                {
                    if(dp[i]==-1)
                        dp[i]=dp[j]+minc[p][timp[lant[k]]];
                    else dp[i]=mymin(dp[i],dp[j]+minc[p][timp[lant[k]]]);
                }
            }
        }
    }
    cout<<dp[n];
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
