#include <bits/stdc++.h>

using namespace std;

const int NMAX=100005;

int l,r,x,q;

vector<int> aint[NMAX*4];

int sum[NMAX];

const int SZ=100000;

void prec(int x)
{
    for(int i=1;i<=x;i++)
    {
        for(int j=i+i;j<=x;j+=i)
            sum[j]+=i;
    }
}

void build(int nod, int st, int dr)
{
    if(st==dr)
    {
        aint[nod].push_back(sum[st]);
        return;
    }
    int mij=(st+dr)/2;
    build(nod*2,st,mij);
    build(nod*2+1,mij+1,dr);
    int ls=nod*2;
    int rs=nod*2+1;
    int n=aint[ls].size();
    int m=aint[rs].size();
    int i=0,j=0;
    while(i<n&&j<m)
    {
        if(aint[ls][i]<=aint[rs][j])
            aint[nod].push_back(aint[ls][i++]);
        else aint[nod].push_back(aint[rs][j++]);
    }
    while(i<n)
        aint[nod].push_back(aint[ls][i++]);
    while(j<m)
        aint[nod].push_back(aint[rs][j++]);
}

int query(int nod, int st, int dr, int l, int r, int x)
{
    if(l<=st&&dr<=r)
    {
        int lp=0;
        int rp=aint[nod].size()-1;
        int poz=rp+1;
        while(lp<=rp)
        {
            int mij=(lp+rp)/2;
            if(aint[nod][mij]>x)
            {
                poz=mij;
                rp=mij-1;
            }
            else lp=mij+1;
        }
        return aint[nod].size()-poz;
    }
    int mij=(st+dr)/2;
    int s1=0,s2=0;
    if(l<=mij)
        s1=query(nod*2,st,mij,l,r,x);
    if(mij<r)
        s2=query(nod*2+1,mij+1,dr,l,r,x);
    return s1+s2;
}

void solve()
{
    prec(SZ);
    build(1,1,SZ);
    cin>>q;
    while(q--)
    {
        cin>>l>>r>>x;
        cout<<query(1,1,SZ,l,r,x)<<'\n';
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
