#include <bits/stdc++.h>

using namespace std;

const int NMAX=100005;
const int SZ=100000;
int l,r,x,q;

int sum[NMAX];

int aib[NMAX];

vector<int> nr[NMAX];

int ub(int x)
{
    return x&(-x);
}

void Update(int poz)
{
    for(;poz<=SZ;poz+=ub(poz))
        aib[poz]++;
}

int Query(int poz)
{
    int r=0;
    for(;poz>0;poz-=ub(poz))
        r+=aib[poz];
    return r;
}

struct query{
    int l,r,x,idx;
};

bool cmp(query a, query b)
{
    return (a.x>b.x);
}

vector<query> qr;

void prec(int x)
{
    for(int i=1;i<=x;i++)
    {
        if(sum[i]>SZ)
            nr[SZ+1].push_back(i);
        else nr[sum[i]].push_back(i);
        for(int j=i+i;j<=x;j+=i)
            sum[j]+=i;
    }
}

int ans[NMAX];

void solve()
{
    prec(SZ);
    cin>>q;
    for(int i=0;i<q;i++)
    {
        cin>>l>>r>>x;
        qr.push_back({l,r,x,i});
    }
    sort(qr.begin(),qr.end(),cmp);
    for(int i=SZ+1;i>qr[0].x;i--)
    {
        for(int p:nr[i])
            Update(p);
    }
    for(int i=0;i<q;i++)
    {
        ans[qr[i].idx] = Query(qr[i].r)-Query(qr[i].l-1);
        if(i<q-1)
        {
            for(int j=qr[i].x;j>qr[i+1].x;j--)
            {
                for(int p:nr[j])
                    Update(p);
            }
        }
    }
    for(int i=0;i<q;i++)
        cout<<ans[i]<<'\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
