#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
ifstream fin("input.txt");
#define cin fin
#endif

const int NMAX = 1e5+5;
const int SQRTN = 370;

struct Query {
    int l, r, v;
};

int n, m;
short b[SQRTN][NMAX];
Query q[NMAX];
int sum_div[NMAX];
int bsz, bucket[NMAX];
int s[SQRTN][NMAX];

void read() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> m;
    for (int i = 1; i <= m; i++) {
        cin >> q[i].l >> q[i].r >> q[i].v;
        n = max(n, q[i].r);
    }
}

void precalc() {
    int mx = 0;
    bsz = sqrt(NMAX - 1);
    for (int i = 1; i < NMAX; i++) {
        sum_div[i] = 1;
        for (int j = 2; j * j <= i; j++) {
            if (i % j == 0) {
                sum_div[i] += j + (i / j);
                if (j * j == i)
                    sum_div[i] -= j;
            }
        }
    }
    for (int i = 1; i < NMAX; i++)
        bucket[i] = ((i - 1) / bsz + 1);
    int cnt = 0;
    for (int i = 1; i < NMAX; i++)
        b[bucket[i]][min(sum_div[i], NMAX - 1)]++;
    for (int i = NMAX - 2; i > 0; i--)
        for (int j = 1; j < SQRTN; j++)
            b[j][i] += b[j][i + 1];
    for (int j = 1; j < SQRTN; j++)
        for (int i = 1; i < NMAX; i++)
            s[j][i] = s[j - 1][i] + b[j][i];
}

int solve(const Query q) {
    return 0;
    if (bucket[q.l] == bucket[q.r]) {
        int ans = 0;
        for (int i = q.l; i <= q.r; i++)
            ans += sum_div[i] > q.v;
        return ans;
    }
    int lb = bucket[q.l] + 1;
    int rb = bucket[q.r] - 1;
    int ans = s[rb][q.v + 1] - s[lb - 1][q.v + 1];
    for (int i = q.l; bucket[i] == bucket[q.l] && i <= q.r; i++)
        ans += sum_div[i] > q.v;
    for (int i = q.r; bucket[i] == bucket[q.r]; i--)
        ans += sum_div[i] > q.v;
    return ans;
}

int main() {
    read();
    precalc();
    for (int i = 1; i <= m; i++)
        cout << solve(q[i]) << '\n';
    return 0;
}
