#include <bits/stdc++.h>

using namespace std;

#define ll long long
const int INF=1e9,SQ=317,LOG=20;
const ll LINF=1e18;
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long,long long>
#define mid ((l+r)/2)
#define sz(a) (int(a.size()))
#define all(a) a.begin(),a.end()
#define endl "\n"
#define PRINT(x) cerr<<#x<<"="<<x<<endl;
#define pb push_back
#define PRINTvec(niz) {cerr<<#niz<<"="; for(int _i:niz) cerr<<_i<<" "; cerr<<endl;}

mt19937 rng;

int Random(int a,int b){
    return uniform_int_distribution<int>(a,b)(rng);
}

const int mxN=2001;
vector<int> adj[mxN];
vector<int> in(mxN);
int timer;

void Dfs(int node,int par){
    in[node]=++timer;
    for(int v:adj[node]){
        if(v!=par){
            Dfs(v,node);
        }
    }
}

void Solve(){
    int N; cin>>N;
    vector<int> c(N+1),t(N+1);
    for(int i=1;i<=N;i++) cin>>c[i];
    for(int i=1;i<=N;i++) cin>>t[i];
    for(int i=1;i<=N-1;i++){
        int u,v; cin>>u>>v;
        adj[u].pb(v);
        adj[v].pb(u);
    }
    int start=1;
    for(int i=1;i<=N;i++){
        if(sz(adj[i])==1){
            start=i;
        }
    }
    //PRINT(start);
    vector<pair<int,ll>> segs[mxN];
    vector<ll> dp(N+1,LINF);
    Dfs(start,start);
    for(int i=1;i<=N;i++){
        //PRINT(i);
        //PRINT(in[i]); cerr<<endl;
    }
    for(int i=1;i<=N;i++){
        for(int j=1;j<=t[i];j++){
            int L=max(1,i-(j-1)),R=min(N,i+(j-1));
            int X=c[j];
            //PRINT(i);
            //PRINT(j);
            //cerr<<"["<<L<<","<<R<<"]="<<X<<endl;
            segs[R].pb({L,X});
        }
        //cerr<<endl;
    }
    dp[0]=0;
    for(int i=1;i<=N;i++){
        for(auto p:segs[i]){
            int R=i,L=p.fi;
            ll X=p.se;
            dp[R]=min(dp[L-1]+X,dp[R]);
        }
    }
    cout<<(dp[N]!=LINF ? dp[N] : 0)<<endl;
}

int main(){
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);
    int t=1;
    //cin>>t;
    while(t--){
        Solve();
    }
}
