#include <bits/stdc++.h>
#define int long long

using namespace std;
using pii = pair <int, int>;

constexpr int maxn = 2e3 + 10;
constexpr int inf = 1e17 + 10;

int c [maxn], t [maxn];
vector <int> graph [maxn];
vector <int> way;

inline void dfs (int v, int p = -1) {
    way.push_back (v);
    for (int i : graph[v]) if (i != p) {
        dfs (i, v);
    }
}

int mx [maxn];

inline void solve () {
    int n, u, v;
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> t[i];
    for (int i = 0; i < n - 1; ++i) {
        cin >> u >> v, --u, --v;
        graph[u].push_back (v);
        graph[v].push_back (u);
    }
    for (int i = 0; i < n; ++i) if ((int) graph[i].size () == 1) {
        dfs (i);
        break;
    }
    for (int i = 0; i < n; ++i) mx[i] = inf;
    for (int i = 0; i < n; ++i) {
        v = way[i];
        for (int j = 1; j <= t[v]; ++j) {
            int L = i - j, R = i + j - 1;
            //cout << L << ' ' << R << '\n';
            int A = 0;
            if (L >= 0) A = mx[L];
            R = min (R, n - 1);
            mx[R] = min (A + c[j - 1], mx[R]);
        }
        for (int j = n - 2; j >= 0; --j) mx[j] = min (mx[j], mx[j + 1]);
    }
    if (mx[n - 1] == inf) mx[n - 1] = -1;
    cout << mx[n - 1] << '\n';
}

signed main () {
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve ();
    return 0;
}


/*

5
1 111 111 111 111
4 4 4 4 4
1 2
2 3
3 4
4 5


*/
