#include <bits/stdc++.h>
#define int long long
#define X first
#define Y second
#define mp make_pair

using namespace std;
using pii = pair <int, int>;

constexpr int maxn = 2e3 + 10;
constexpr int inf = 1e17 + 10;

int tin [maxn], tout [maxn], timer = 0;
vector <int> graph [maxn];

inline void _dfs (int v, int p = -1) {
    tin[v] = ++timer;
    for (int i : graph[v]) if (i != p) _dfs (i, v);
    tout[v] = timer;
}

int n, c [maxn], t [maxn];
int dp [maxn][maxn];
int w [maxn];
vector <int> dist [maxn];

inline int sum (int L, int R) {
    int result = 0;
    for (int i = L; i <= R; ++i) result += w[i];
    return result;
}

inline void clr (int L, int R) {
    for (int i = L; i <= R; ++i) w[i] = 0;
}

inline void dfs1 (int v, int p, int D) {
    dist[D].push_back (v);
    for (int i : graph[v]) if (i != p) dfs1 (i, v, D + 1);
}

inline void dfs (int v, int p = -1) {
    memset (w, 0, sizeof (w));
    for (int i : graph[v]) if (i != p) dfs (i, v);
    for (int i = 0; i <= n + 1; ++i) dist[i].clear (), dp[v][i] = inf;
    for (int i : graph[v]) if (i != p) {
        dfs1 (i, v, 1);
    }
    for (int i = 1; i <= t[v]; ++i) {
        memset (w, 0, sizeof (w));
        int result = 0;
        for (int j : dist[i]) w[tin[j]] = dp[j][1], result += dp[j][1];
        for (int j = 1; j < i; ++j) {
            for (int x : dist[i - j]) {
                int S = sum (tin[x], tout[x]);
                if (S <= dp[x][j + 1]) continue;
                result += dp[x][j + 1] - S;
                clr (tin[x] + 1, tout[x]);
                w[tin[x]] = dp[x][j + 1];
            }
        }
        //if (v == 3) {
            //cout << "thhthtw " << result << '\n';
        //}
        int delta = 0;
        for (int j : graph[v]) if (j != p) {
            int S = sum (tin[j], tout[j]);
            delta = min (delta, dp[j][i + 1] - S - c[i]);
        }
        dp[v][i] = min (dp[v][i], result + c[i] + delta);
    }
    for (int i = t[v] + 1; i <= n; ++i) {
        memset (w, 0, sizeof (w));
        int result = 0;
        for (int j : dist[i]) w[tin[j]] = dp[j][1], result += dp[j][1];
        for (int j = 1; j < i; ++j) {
            for (int x : dist[i - j]) {
                int S = sum (tin[x] + 1, tout[x]);
                if (S <= dp[x][j + 1]) continue;
                result += dp[x][j + 1] - S;
                clr (tin[x] + 1, tout[x]);
                w[tin[x]] = dp[x][j + 1];
            }
        }
        //if (v == 3 && i == 2) {
            //cout << "thhthtw " << result << '\n';
        //}
        int delta = inf;
        for (int j : graph[v]) if (j != p) {
            int S = sum (tin[j], tout[j]);
            //if (v == 3 && i == 2) cout << "wegwg " << S << ' ' << dp[j][i + 1] << '\n';
            delta = min (delta, dp[j][i + 1] - S);
        }
        dp[v][i] = min (dp[v][i], result + delta);
    }
    for (int i = n - 1; i > 0; --i) dp[v][i] = min (dp[v][i], dp[v][i + 1]);
}

inline void solve () {
    int u, v;
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> t[i];
    for (int i = 0; i < n - 1; ++i) {
        cin >> u >> v, --u, --v;
        graph[u].push_back (v);
        graph[v].push_back (u);
    }
    _dfs (0);
    //int ver = 3;
    //dfs (ver, 0);
    //cout << dp[ver][1] << ' ' << dp[ver][2] << ' ' << dp[ver][3] << '\n';
    dfs (0);
    cout << (dp[0][1] == inf ? -1LL : dp[0][1]) << '\n';
}

signed main () {
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve ();
    return 0;
}


/*

5
1 111 111 111 111
4 4 4 4 4
1 2
2 3
3 4
4 5


*/
