#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int weigh(const vector<int> &a, const vector<int> &b);

pair <int, int> count_heavy(int k) {
    int n = (1 << k);
    if (k <= 5) {
        int cntEq = 0, cntBigger = 0, cntSmaller = 0;
        int v = -1;
        for (int i = 1; i < n; i ++) {
            int w = weigh({0}, {i});
            if (w == 0) cntEq ++;
            else if (w == -1) cntSmaller ++, v = i;
            else cntBigger ++;
        }
        if (cntSmaller > 0)
            return {cntSmaller, v};
        else
            return {cntEq + 1, 0};
    }
    /////////////////////////////////////////////////////////////
    int indH;
    int blocked = 0;
    bool oneHeavy = true;
    for (int e = k - 1; e >= 0; e --) {
        vector <int> a, b;
        for (int i = 0; i < (1 << e); i ++) {
            a.push_back(blocked + i);
            b.push_back(blocked + (1 << e) + i);
        }
        int w = weigh(a, b);
        if (w == 0)
            oneHeavy = false;
        if (w == -1)
            blocked += (1 << e);
    }
    indH = blocked;
    //---------------------------------------------------------------
    int indL;
    blocked = 0;
    //bool oneHeavy = true;
    for (int e = k - 1; e >= 0; e --) {
        vector <int> a, b;
        for (int i = 0; i < (1 << e); i ++) {
            a.push_back(blocked + i);
            b.push_back(blocked + (1 << e) + i);
        }
        int w = weigh(a, b);
        //if (w == 0)
        //    oneHeavy = false;
        if (w == 1)
            blocked += (1 << e);
    }
    indL = blocked;
    //-------------------------------------------------------------------
    /*
    int cnt = (oneHeavy ? 1 : n - 1);
    return {cnt, ind};
    */
    int krn = sqrt(n);
    krn = min(krn, k + 1);
    vector <int> heavy = {}, light = {};
    for (int i = 0; i < n; i ++) {
        if (i == indH) continue;
        int w = weigh({indH}, {i});
        if (w == 0)
            heavy.push_back(i);
        else
            light.push_back(i);
        if (max(heavy.size(), light.size()) >= krn)
            break;
    }
    if (light.size() >= krn) {
        set <int> sh;
        for (int i = 0; i < n / krn; i ++) {
            int blocked = krn * i;
            vector <int> b;
            for (int i = blocked; i < min(blocked + krn, n); i ++)
                b.push_back(i);
            
            if (n - blocked < krn || weigh(light, b) == -1) {
                for (int i = blocked; i < n; i ++)
                    if (i == indH || weigh({indH}, {i}) == 0)
                        sh.insert(i);
            }
        }
        return {sh.size(), indH};
    }
    else {
        set <int> sl;
        for (int i = 0; i < n / krn; i ++) {
            int blocked = krn * i;
            vector <int> b;
            for (int i = blocked; i < min(blocked + krn, n); i ++)
                b.push_back(i);
            
            if (n - blocked < krn || weigh(heavy, b) == -1) {
                for (int i = blocked; i < n; i ++)
                    if (i == indL || weigh({indL}, {i}) == 0)
                        sl.insert(i);
            }
        }
        return {n - sl.size(), indH};
    }
}