#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 8;
const int INF = 1e9 + 123;
int n;

int res = INF;

int c[N], t[N];
bool used[N] = {}, pred[N] = {};

vector <int> g[N];

void dfs(int v, int par, int d, int maxD, bool used_assign) {
    if (used_assign) {
        pred[v] = used[v];
        used[v] = true;
    }
    else {
        used[v] = pred[v];
    }
    if (d + 1 >= maxD)
        return;
    for (auto to : g[v])
        if (to != par)
            dfs(to, v, d + 1, maxD, used_assign);
}

void Recursion(int step, int cost) {
    //cout << cost << " : ";
    //for (int i = 0; i < n; i ++) cout << used[i];
    //cout << '\n'; 
    if (step == n) {
        for (int i = 0; i < n; i ++)
            if (!used[i])
                return;
        res = min(res, cost);
        //cout << cost << '\n';
        return;
    }
    /*
    bool f = true;
    for (int i = 0; i < n; i ++)
        if (!used[i]) {
            f = false;
            break;
        }
    if (f)
        res = min(res, cost);
    */
    
    Recursion(step + 1, cost);
    for (int i = 1; i <= t[step]; i ++) {
        int save[N];
        for (int j = 0; j < N; j ++) save[j] = used[j];
        dfs(step, -1, 0, i, true);
        Recursion(step + 1, cost + (i == 0 ? 0 : c[i - 1]));
        //dfs(step, -1, 0, i, false);
        for (int j = 0; j < N; j ++) used[j] = save[j];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    /*#ifndef ONLINE_JUDGE
        freopen("input123.txt", "r", stdin);
        freopen("output123.txt", "w", stdout);
    #endif*/

    cin >> n;
    for (int i = 0; i < n; i ++) cin >> c[i];
    for (int i = 0; i < n; i ++) cin >> t[i];
    for (int i = 0; i < n - 1; i ++) {
        int u, v; cin >> u >> v; u --, v --;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    Recursion(0, 0);
    cout << res << '\n';
    return 0;
}