#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 100;
const ll INF = 1e16 + 123;
int n;

ll res = INF;

int c[N], t[N];
bool used[N] = {};

vector <int> g[N];

int dfs(int v, int par, int d, int maxD, bool used_assign) {
    used[v] = used_assign;
    int ret = d;
    if (d + 1 >= maxD)
        return 0;
    for (auto to : g[v])
        if (to != par)
            ret = max(ret, dfs(to, v, d + 1, maxD, used_assign));
    return ret;
}

void Recursion(int step, ll cost) {
    if (step >= n) {
        for (int i = 0; i < n; i ++)
            if (!used[i])
                return;
        res = min(res, cost);
        return;
    }
    
    Recursion(step + 1, cost);
    
    if (t[step] == 0) return;

    int mx = dfs(step, -1, 0, t[step], true);
    mx = min(t[step], mx);
    Recursion(step + mx + 1, cost + c[mx]);
    /*for (int i = 1; i <= t[step]; i ++) {
        int save[N];
        for (int j = 0; j < N; j ++) save[j] = used[j];
        dfs(step, -1, 0, i, true);
        Recursion(step + 1, cost + c[i - 1]);
        for (int j = 0; j < N; j ++) used[j] = save[j];
    }*/
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    /*#ifndef ONLINE_JUDGE
        freopen("input123.txt", "r", stdin);
        freopen("output123.txt", "w", stdout);
    #endif*/

    cin >> n;
    for (int i = 0; i < n; i ++) cin >> c[i];
    for (int i = 0; i < n; i ++) cin >> t[i];
    for (int i = 0; i < n - 1; i ++) {
        int u, v; cin >> u >> v; u --, v --;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    Recursion(0, 0);
    cout << (res == INF ? -1 : res) << '\n';
    return 0;
}