#include <vector>
#include "coins.h"

using namespace std;

int ask(int l1, int r1, int l2, int r2) {
    vector <int> a, b;
    for (int i = l1; i <= r1; i++)
        a.push_back(i);
    for (int i = l2; i <= r2; i++)
        b.push_back(i);
    return weigh(a, b);
}

bool all_ok = true;

int smaller_one(int l, int r) {

    if (l == r)
        return l;

    if (!all_ok)
        return -1;
    int m = (l + r) >> 1;
    int cur = ask(l, m, m + 1, r);
    if (cur == 0) {
        all_ok = false;
        return -1;
    }

    if (cur == -1)
        return smaller_one(l, m);

    return smaller_one(m + 1, r);

}

int bigger_one(int l, int r) {

    if (l == r)
        return l;

    if (!all_ok)
        return -1;
    int m = (l + r) >> 1;
    int cur = ask(l, m, m + 1, r);
    if (cur == 0) {
        all_ok = false;
        return -1;
    }

    if (cur == -1)
        return bigger_one(m+1, r);

    return bigger_one(l, m);

}

std::pair<int, int> count_heavy(int k) {

    if (k <= 5) {
        int was_equal = 0, was_bigger = 0, tot = 1;
    bool found = false;
    vector <int> res = {0};
    for (int i = 1; i < (1 << k); i++) {
        vector <int> cur = {i};
        int ask = weigh(res, cur);

        if (found) {
            tot += !ask;
            continue;
        }
        if (ask == -1) {
            res = cur;
            found = true;
            tot += was_bigger;
        } else if (ask == 1) {
            was_bigger++;
        } else {
            was_equal++;
        }
    }
    if (!found) tot += was_equal;
    return {tot, res.front()};
    }

    all_ok = true;
    int mb = smaller_one(0, (1 << k) - 1);

    if (all_ok) {
        return {(1<<k)-1, (mb+1)%(1<<k)};
    }

    all_ok = true;
    return {1, bigger_one(0, (1 << k) - 1)};

}
