#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

const int N = 10;
int t[N], c[N];
vector <int> g[N];

ll ans = 1e18;

int n;

bitset < N > used;

bool check(vector<int> &a) {
    used.reset();

    for (int i = 1; i <= n; i++) {
        int d = a[i - 1];
        if (!d) continue;
        queue < pair<int, int> > q;
        used[i] = true;
        q.push({i, 1});
        while (!q.empty()) {
            auto [v, dist] = q.front(); q.pop();
            for (auto to : g[v])
                if (dist+1<=d) {
                    used[to] = true;
                    q.push({to, dist+1});
                }
        }
    }

    for (int i = 1; i <= n; i++)
        if (!used[i])
            return false;

    return true;
}

void rec(vector<int> cur, ll cost) {
    int i = cur.size();

    if (i == n) {
        if (ans < cost || !check(cur)) return;
        ans = min(ans, cost);
        return;
    }

    for (int v = 0; v <= t[i+1]; v++) {
        cur.push_back(v);
        rec(cur, cost+c[v]);
        cur.pop_back();
    }
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> t[i];
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    rec({}, 0);

    cout << ans << '\n';
}

main() {
    boost;
    solve();
    return 0;
}
