#include <bits/stdc++.h>

#pragma GCC Optimize("Ofast")
#pragma GCC Optimize("unroll-loops")

using namespace std;

const int MAXN = 1e5 + 2;

int cnt[MAXN];

void init() {
    cnt[0] = cnt[1] = 0;
    for (int i = 2; i < MAXN; i++) {
        cnt[i]++;
        for (int j = 2 * i; j < MAXN; j += i)
            cnt[j] += i;
    }
}

vector<int> t[4 * MAXN];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v].push_back(cnt[tl]);
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);

    int i = 0, j = 0;
    while (i < t[v << 1].size() || j < t[v << 1 | 1].size()) {
        if (i >= t[v << 1].size()) {
            while (j < t[v << 1 | 1].size())
                t[v].push_back(t[v << 1 | 1][j++]);
        } else if (j >= t[v << 1 | 1].size()) {
            while (i < t[v << 1].size())
                t[v].push_back(t[v << 1][i++]);
        } else {
            if (t[v << 1][i] < t[v << 1 | 1][j]) t[v].push_back(t[v << 1][i++]);
                else t[v].push_back(t[v << 1 | 1][j++]);
        }
    }
}

int get(int l, int r, int val, int v, int tl, int tr) {
    if (tl > r || tr < l)
        return 0;
    if (l <= tl && tr <= r) {
        if (t[v].front() > val)
            return t[v].size();
        if (t[v].back() <= val)
            return 0;
        int L = 0, R = t[v].size() - 1;
        while (L + 1 < R) {
            int M = (L + R) >> 1;
            if (t[v][M] <= val)
                L = M;
            else
                R = M;
        }
        int ans = L + (t[v][L] <= val);
        return (int) t[v].size() - ans;
    }
    int tm = (tl + tr) >> 1;
    return get(l, r, val, v << 1, tl, tm) +
            get(l, r, val, v << 1 | 1, tm + 1, tr);
}

main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    init();
    build(1, 0, MAXN - 1);

    int t;
    cin >> t;
    while (t--) {
        int l, r, v;
        cin >> l >> r >> v;
        cout << get(l, r, v, 1, 0, MAXN - 1) << '\n';
    }

    return 0;
}

