#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

#define endl '\n'

using namespace std;
typedef long long  ll;


ll n;
ll c[200007], t[20007];
vector<ll>d[200007];

vector<ll>order;

void dfs(ll v, ll par){
    order.push_back(v);
    
    for(auto i: d[v])
        if(i != par)
            
            dfs(i, v);
}

map<pair<ll, ll>, ll> mp;

/*
       _________
 o o o o o I o o o
 d[i][j]
 
 */

ll dp[507][507]; // dp[l][r]

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    cin >> n;
    
    for(int i = 1; i <= n; i++)
        cin >> c[i];
    
    for(int i = 1; i <= n; i++)
        cin >> t[i];
    
    for(int i = 0; i < n - 1; i++){
        ll a, b;
        cin >> a >> b;
        
        d[a].push_back(b);
        d[b].push_back(a);
    }
    
    order.push_back(-1);
    for(int i = 1; i <= n; i++){
        if(d[i].size() < 2){
            dfs(i, -1);
            
            break;
        }
    }
    
    for(int l = n; l >= 1; l--){
        for(int r = l; r <= n; r++){
            dp[l][r] = 1e9;
            
            for(int i = l; i <= r; i++){
                for(int j = 1; j <= t[order[i]]; j++){
                    ll cnt = c[j];
                    if((i - j) >= 1)
                        cnt += dp[l][i - j];
                    if(i + j <= n)
                        cnt += dp[i + j][r];
                    
                    dp[l][r] = min(dp[l][r], cnt);
                }
            }
        }
    }
    
    if(dp[1][n] >= 1e9)
        dp[1][n] = -1;
    
    cout << dp[1][n] << endl;
    
    return 0;
}
/*
 
 4
 1 2 3 4
 0 3 2 1
 1 2
 2 3
 3 4
 
 */
/*
 2
 4 3
 1 1
 1 2
 
 */
