#include <bits/stdc++.h>

using namespace std;

const int maxn = 2048;
long long dp[maxn][maxn], c[maxn], t[maxn], cnt1[maxn], cnt2[maxn], n;
vector<int> v[maxn];
int used[maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> c[i];
    }
    for(int i = 1;i <= n;i++){
        cin >> t[i];
    }
    for(int i = 1;i <= n - 1;i++){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    int stv = 0, finv = 0;
    for(int i = 1;i <= n;i++){
        if(v[i].size() == 1 && stv == 0) stv = i;
        else if(v[i].size() == 1) finv = i;
    }
    int idx = stv, curr = 1;
    used[stv] = 1;
    while(curr <= n){
        swap(t[idx], t[curr]);
        curr++;
        for(int x : v[idx]){
            if(!used[x]){
                idx = x;
                used[x] = 1;
                break;
            }
        }
    }
}

void solve(){
    for(int i = 0;i <= n;i++){
        for(int j = 0;j <= n;j++){
            dp[i][j] = 1e9;
        }
    }
    dp[1][0] = 0;
    for(int i = 1;i <= t[1];i++){
        dp[1][i] = c[i];
    }
    for(int i = 2;i <= n;i++){
        for(int j = 1;j < i;j++){
            int dist = i - j + 1;
            if(dist <= t[j]){
                dp[i][0] = min(dp[i][0], dp[j][dist]);
            }
        }
        for(int k = 1;k < i;k++){
            for(int p = k;p <= i;p++){
                int dist1 = i - p + 1, dist2 = p - k;
                if(dist1 <= t[i] && dist2 <= t[k]){
                    dp[i][dist1] = min(dp[i][dist1], dp[k][dist2] + c[dist1]);
                }
            }
        }
    }
    long long ans = 1e9;
    for(int i = 0;i <= n;i++){
        ans = min(ans, dp[n][i]);
    }
    if(ans == 1e9) ans = -1;
    cout << ans << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
