#include <bits/stdc++.h>

#include "coins.h"

using namespace std;

const int MAXN = 2e6 + 50;

int findFirstHeavy(int n)
{
    int l = 0, r = n-1, mid, ans = -1;
    while (l < r)
    {
        mid = (l+r)/2;
        vector <int> a, b;
        a.reserve(mid-l + 1);
        b.reserve(r-mid);
        for (int i = l; i <= mid; i++)
            a.push_back(i);
        for (int i = mid+1; i <= r; i++)
            b.push_back(i);

        int res = weigh(a, b);
        if (res == 0)
            r = mid;
        if (res == 1)
            r = mid;
        if (res == -1)
            l = mid+1;
    }
    return r;
}

pair <int, int> count_heavy(int k)
{
    int n = (1<<k);
    if (n == 2)
    {
        int cmp = weigh({0}, {1});
        if (cmp == 1)
        return{1, 0};

        else
        return{1, 1};
    }

    int heavyIndex = findFirstHeavy(n), cmpINDEX1 = 0, cmpINDEX2 = 2;
    if (heavyIndex == 0)
        cmpINDEX1 = 1;
    if (heavyIndex == 1)
        cmpINDEX2 = 3;


    int cmp1 = weigh({heavyIndex}, {cmpINDEX1});
    int cmp2 = weigh({heavyIndex}, {cmpINDEX2});

    if (cmp1 == 0 || cmp2 == 0)
    {
        return {n-1, heavyIndex};
    }

    else
    {
        return {1, heavyIndex};
    }

    return {-1, -1};
}
