#include<iostream>
#include<vector>
#include<cstring>
#include<algorithm>
using namespace std;
const int MAX_N=1e5+1;
int sum[MAX_N];
vector<int>tree[4*MAX_N];
vector<int>posL[4*MAX_N];
vector<int>posR[4*MAX_N];
int len[4*MAX_N];
void Precompute()
{
    for(int i=100000;i>=1;i--)
    {
        for(int j=i+i;j<=100000;j+=i)
        {
            sum[j]+=i;
        }
    }
}
int q;
void Init(int node,int l,int r)
{
    if(l==r)
    {
        len[node]=1;
        tree[node].push_back(sum[l]);
        return;
    }
    int mid=(l+r)/2;
    Init(2*node,l,mid);
    Init(2*node+1,mid+1,r);
    len[node]=len[2*node]+len[2*node+1];
    /*for(int x:tree[2*node])
    {
        tree[node].push_back(x);
    }
    for(int x:tree[2*node+1])
    {
        tree[node].push_back(x);
    }
    sort(tree[node].begin(),tree[node].end());*/
    int l_idx=0;
    int r_idx=0;
    for(int i=l;i<=r;i++)
    {
        if((r_idx>=tree[2*node+1].size()) or (l_idx<tree[2*node].size() && tree[2*node][l_idx]<=tree[2*node+1][r_idx]))
        {
            tree[node].push_back(tree[2*node][l_idx]);
            l_idx++;
        }
        else
        {
            tree[node].push_back(tree[2*node+1][r_idx]);
            r_idx++;
        }
    }
}
void Two(int node,int l,int r)
{
    if(l==r)
    {
        return;
    }
    int mid=(l+r)/2;
    Two(2*node,l,mid);
    Two(2*node+1,mid+1,r);
    int l_idx=0;
    int r_idx=0;
    for(int x:tree[node])
    {
        while(l_idx<tree[2*node].size() && tree[2*node][l_idx]<x)
        {
            l_idx++;
        }
        if(l_idx<tree[2*node].size())posL[node].push_back(l_idx);
        else posL[node].push_back(-1);

        while(r_idx<tree[2*node+1].size() && tree[2*node+1][r_idx]<x)
        {
            r_idx++;
        }
        if(r_idx<tree[2*node+1].size())posR[node].push_back(r_idx);
        else posR[node].push_back(-1);
    }
}
int ql,qr;
int Query(int node,int l,int r,int pos)
{
    if(pos==-1)return 0;
    if(ql<=l && r<=qr)
    {
        return len[node]-pos;
    }
    int ans=0;
    if(ql<=((l+r)/2))ans+=Query(2*node,l,((l+r)/2),posL[node][pos]);
    if(qr>((l+r)/2))ans+=Query(2*node+1,((l+r)/2)+1,r,posR[node][pos]);
    return ans;
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    Precompute();
    Init(1,1,100000);
    Two(1,1,100000);
    cin>>q;
    int l,r,v;
    int ans,le,re,mid;
    int pos;
    while(q--)
    {
        cin>>l>>r>>v;
        le=0;
        re=tree[1].size()-1;
        pos=-1;
        while(le<=re)
        {
            mid=(le+re)/2;
            if(tree[1][mid]>v)
            {
                pos=mid;
                re=mid-1;
            }
            else le=mid+1;
        }
        if(pos==-1)
        {
            cout<<0<<"\n";
            continue;
        }
        /*cout<<0<<"\n";
        continue;*/
        ql=l;
        qr=r;
        ans=Query(1,1,100000,pos);
        cout<<ans<<"\n";
    }
    return 0;
}
