#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
using namespace std;
const int MAXN = 1e5+6;
int ans[MAXN+5];
vector<int> tree[4*MAXN];
void build_tree(int l,int r,int ind){
    if(l==r){
        tree[ind].push_back(ans[l]);
        return;
    }
    int m=(l+r)/2;
    build_tree(l,m,2*ind);
    build_tree(m+1,r,2*ind+1);
    int p1=0,p2=0;
    while(p1<tree[2*ind].size() or p2<tree[2*ind+1].size()){
        if(p1!=tree[2*ind].size() and (p2==tree[2*ind+1].size() or tree[2*ind][p1]<tree[2*ind+1][p2])){
            tree[ind].push_back(tree[2*ind][p1]);
            p1++;
        }else{
            tree[ind].push_back(tree[2*ind+1][p2]);
            p2++;
        }
    }
}
int l1=0,r1;
int m1;
int nameripogolemi(int ind,int v){
    l1=0;
    r1=tree[ind].size()-1;
    while(l1<=r1){
            //broideistviq++;
        m1=(l1+r1)/2;
        if(tree[ind][m1]>v){
            r1=m1-1;
        }else{
            l1=m1+1;
        }
    }
    //cout<<"dvoichno s "<<broideistviq<<"\n";
    return tree[ind].size()-(r1+1);
    /*int a = 5;
    for(int i=1;i<=30;i++){
        a+=5;
        a/=2;
        a-=5;
        if(1) a*=3;
    }
    //cout<<"dvoichno\n";
    return tree[ind].size()-5;*/
}
int findcnt(int l,int r,int ind,int qr,int v){
    //cout<<l<<" "<<r<<"\n";
    /*if(r<=qr){
        return nameripogolemi(ind,v);
    }*/
    int otg = 0 ;
    int m=(l+r)/2;
    if(qr>=m){
        otg+=nameripogolemi(2*ind,v);
        if(qr>m) otg+=findcnt(m+1,r,2*ind+1,qr,v);
    }else{
        otg+=findcnt(l,m,2*ind,qr,v);
    }
    return otg;
    //return 1;
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    /*freopen("input.in","r",stdin);
    freopen("output.out","w",stdout);*/
    int q,l,r,v;
    ans[0]=0;
    for(int i=1;i<=MAXN;i++){
        ans[i]=1;
        for(int j=2;j<=sqrt(i);j++){
            if(i%j==0){
                ans[i]+=j;
                if((i/j)>sqrt(i)){
                    ans[i]+=(i/j);
                }
            }
        }
    }
    build_tree(0,MAXN,1);
    int curr=0;
    cin>>q;
    while(q--){
        cin>>l>>r>>v;
        if(l>1) cout<<findcnt(0,MAXN,1,r,v)-findcnt(0,MAXN,1,l-1,v)<<"\n";
        else cout<<findcnt(0,MAXN,1,r,v)<<"\n";
    }
}

