#include<iostream>
#include<vector>
#include<cmath>
using namespace std;
const int MAXN = 1e5+1;
int ans[MAXN+5];
vector<int> tree[4*MAXN];
void build_tree(int l,int r,int ind){
    if(l==r){
        tree[ind].push_back(ans[l]);
        return;
    }
    int m=(l+r)/2;

    build_tree(l,m,2*ind);
    build_tree(m+1,r,2*ind+1);
    int szl = tree[2*ind].size();
    int szr = tree[2*ind+1].size();
    int p1=0,p2=0;
    while(p1<szl or p2<szr){
        if(p1!=szl and (p2==szr or tree[2*ind][p1]<tree[2*ind+1][p2])){
            tree[ind].push_back(tree[2*ind][p1]);
            p1++;
        }else{
            tree[ind].push_back(tree[2*ind+1][p2]);
            p2++;
        }
    }
}
int l1=0,r1;
int m1,ql,qr,v;
int findcnt(int l,int r,int ind){
    if(l==r){
        return (ans[l]>v);
    }
    if(ql<=l and r<=qr){
        //cout<<"vliza izcqlo\n";
        l1=0;
        r1=r-l;
        while(l1<=r1){
            //obshtbroi+=4;
            m1=(l1+r1)/2;
            if(tree[ind][m1]>v){
                r1=m1-1;
            }else{
                l1=m1+1;
            }
        }
        //cout<<"i otg e "<<r-l-r1<<"\n";
        return r-l-r1;
    }
    int otg = 0 ;
    int m=(l+r)/2;
    if(ql<=m){
        otg+=findcnt(l,m,2*ind);
    }
    if(qr>m){
        otg+=findcnt(m+1,r,2*ind+1);
    }
    return otg;
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //cout.tie(nullptr);
    //freopen("input.in","r",stdin);
    //freopen("output.out","w",stdout);*/
    int q;
    ans[0]=0;
    for(int i=1;i<=MAXN;i++){
        ans[i]=1;
        for(int j=2;j<=sqrt(i);j++){
            if(i%j==0){
                ans[i]+=j;
                if((i/j)>sqrt(i)){
                    ans[i]+=(i/j);
                }
            }
        }
    }
    build_tree(0,MAXN,1);
    cin>>q;
    for(int i=0;i<q;i++){
        cin>>ql>>qr>>v;
        cout<<findcnt(0,MAXN,1)<<"\n";
    }

}

