#include "coins.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e6+5;
int used[maxn];

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

pair<int, int> solve1(int k)
{
    int maxch = 0;
    for(int i=1;i<(1<<k);i++)
    {
        vector<int>v1,v2;
        v1.push_back(i-1);
        v2.push_back(i);
        used[i] = used[i-1] - weigh(v1,v2);
        maxch = max(maxch,used[i]);
    }
    int idx = 0;
    int br = 0;
    for(int i=0;i<(1<<k);i++)
    {
        if(used[i]==maxch)
        {
            br++;
            idx = i;
        }
    }
    pair<int,int>ans;
    ans.first = br;
    ans.second = idx;
    return ans;
}

pair<int, int> solve2(int k)
{
    vector<int>v1,v2;
    pair<int,int>ans;
    int ch = 0;
    int l = 0, r = (1<<k) - 1;
    int mid = (l+r)/2;
    for(int i=l;i<=mid;i++) v1.push_back(i);
    for(int i=mid+1;i<=r;i++) v2.push_back(i);
    ch = weigh(v1,v2);

    if(ch==1) r = mid;
    else l = mid+1;

    mid = (l+r)/2;
    v1.clear();
    v2.clear();
    for(int i=l;i<=mid;i++) v1.push_back(i);
    for(int i=mid+1;i<=r;i++) v2.push_back(i);
    ch = weigh(v1,v2);
    if(ch==0)
    {
        ans.first = (1<<k) - 1;
        ans.second = l;
        return ans;
    }
    ans.first = 1;
    if(ch==1) r = mid;
    else l = mid+1;
    while(l<r)
    {
        mid = (l+r)/2;
        v1.clear();
        v2.clear();
        for(int i=l;i<=mid;i++) v1.push_back(i);
        for(int i=mid+1;i<=r;i++) v2.push_back(i);
        ch = weigh(v1,v2);
        if(ch==1) r = mid;
        else l = mid+1;
    }
    ans.second = l;
    return ans;
}

pair<int, int> count_heavy(int k)
{
    speed();
    if(k<=10) return solve1(k);
    else return solve2(k);
}
