#include <bits/stdc++.h>

using namespace std;

const int maxn = 2048;
int n;
int c[maxn],t[maxn];
int p[maxn],used[maxn];
bool vis[maxn];
long long ans;
vector<int>v[maxn];

void read()
{
    ans = -1;
    cin >> n;
    for(int i=1;i<=n;i++) cin >> c[i];
    for(int i=1;i<=n;i++) cin >> t[i];
    int x,y;
    for(int i=1;i<=n-1;i++)
    {
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}

void BFS(int beg)
{
    memset(vis,false,sizeof(vis));
    used[beg] = 1;
    vis[beg] = true;
    queue<int>q;
    q.push(beg);
    int w,nb,sz;
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        if(used[w]==p[beg]) return;
        sz = v[w].size();
        for(int i=0;i<sz;i++)
        {
            nb = v[w][i];
            if(!vis[nb])
            {
                vis[nb] = true;
                used[nb] = used[w] + 1;
                q.push(nb);
            }
        }
    }
}

void check()
{
    memset(used,0,sizeof(used));
    long long sum = 0;
    for(int i=1;i<=n;i++)
    {
        sum += c[p[i]];
        if(p[i]) BFS(i);
    }
    for(int i=1;i<=n;i++)
    {
        if(!used[i]) return;
    }
    if(ans==-1) ans = sum;
    else ans = min(ans,sum);
}

void rec(int pos)
{
    for(int i=0;i<=t[pos];i++)
    {
        p[pos] = i;
        if(pos==n) check();
        else rec(pos+1);
    }
}

void solve1()
{
    rec(1);
    cout << ans << endl;
}

void solve()
{
    if(n<=8) solve1();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
