#include <bits/stdc++.h>

using namespace std;

const int maxn = 16;
const int maxm = 2048;
int n;
long long c[maxm],t[maxm];
int p[maxm],used[maxn];
long long dp[maxm];
//bool nz[maxm];
bool vis[maxn];
long long ans;
vector<int>v[maxm];

void read()
{
    ans = -1;
    cin >> n;
    for(int i=1;i<=n;i++) cin >> c[i];
    for(int i=1;i<=n;i++) cin >> t[i];
    int x,y;
    for(int i=1;i<=n-1;i++)
    {
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}

void BFS(int beg)
{
    memset(vis,false,sizeof(vis));
    used[beg] = 1;
    vis[beg] = true;
    queue<int>q;
    q.push(beg);
    int w,nb,sz;
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        if(used[w]==p[beg]) return;
        sz = v[w].size();
        for(int i=0;i<sz;i++)
        {
            nb = v[w][i];
            if(!vis[nb])
            {
                vis[nb] = true;
                used[nb] = used[w] + 1;
                q.push(nb);
            }
        }
    }
}

void check()
{
    memset(used,0,sizeof(used));
    long long sum = 0;
    for(int i=1;i<=n;i++)
    {
        sum += c[p[i]];
        if(p[i]) BFS(i);
    }
    for(int i=1;i<=n;i++)
    {
        if(!used[i]) return;
    }
    if(ans==-1) ans = sum;
    else ans = min(ans,sum);
}

void rec(int pos)
{
    for(int i=0;i<=t[pos];i++)
    {
        p[pos] = i;
        if(pos==n) check();
        else rec(pos+1);
    }
}

void dfs(int i, int idx)
{
    int nb;
    for(int j=0;j<v[i].size();j++)
    {
        nb = v[i][j];
        if(p[idx-1]!=nb)
        {
            idx++;
            p[idx] = nb;
            dfs(nb,idx);
            return;
        }
    }
}

void make_p()
{
    p[0] = -20;
    for(int i=1;i<=n;i++)
    {
        if(v[i].size()==1)
        {
            p[1] = i;
            dfs(i,1);
            return;
        }
    }
}

void solve1()
{
    rec(1);
    cout << ans << endl;
}

void solve2()
{
    memset(dp,-1,sizeof(dp));
    dp[0] = 0;
    //memset(nz,false,sizeof(nz));
    make_p();
    int idx,newidx;
    long long mindp,res;
    for(int i=1;i<=n;i++)
    {
        idx = p[i];
        mindp = dp[i];
        newidx = i-1;
        for(int j=1;j<=t[idx];j++)
        {
            newidx++;
            newidx = min(newidx,n);
            if(i-j>=0)
            {
                if(mindp==-1) mindp = dp[i-j];
                else if(dp[i-j]!=-1) mindp = min(mindp,dp[i-j]);
            }
            if(mindp==-1) res = -1;
            else res = mindp + c[j];
            if(dp[newidx]==-1) dp[newidx] = res;
            else if(res!=-1) dp[newidx] = min(dp[newidx],res);
        }
    }
    /*for(int i=0;i<=n;i++)
    {
        cout << dp[i] << " ";
    }
    cout << endl;*/
    cout << dp[n] << endl;
}

void solve()
{
    if(n<=8) solve1();
    else solve2();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
/*
8
1 4 9 16 25 36 49 64
1 5 1 1 0 0 5 0
3 5
5 1
1 8
8 4
4 7
7 2
2 6
*/
