#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll MOD = 1e9 + 7;
const ll N = 1e5 + 7;
ll n, m, k;
int a[N];
vector<int>t[4 * N];
bool is_comp[N];
vector<int>primes;

void eratosthenes() {
	for (ll i = 2; i < N; i++) {
		if (!is_comp[i]) {
			primes.push_back(i);
			for (ll j = i * i; j < N; j += i) {
				is_comp[j] = true;
			}
		}
	}
}

ll sum_of_divisors(ll x) {
	ll tmp = x;
	ll ans = 1;
	for (int i : primes) {
		ll cur = 1;
		ll exp = 0;
		while (x % i == 0) {
			x /= i;
			exp++;
			cur += pow(i, exp);
		}
		ans *= cur;
		if (x == 1)return ans - tmp;
		if (!is_comp[x]) {
			ans *= (x + 1);
			return ans - tmp;
		}
	}
	return ans;
}

void precalc() {
	eratosthenes();
	for (int i = 1; i < N; i++) {
		a[i] = sum_of_divisors(i);
		//cout << a[i] << " ";
	}
}

int main() {
	precalc();
	cin >> ttt;
	while (ttt--) {
		int l, r, v;
		cin >> l >> r >> v;
		int ans = 0;
		for (int i = l; i <= r; i++) {
			ans += (a[i] > v);
		}
		cout << ans << endl;
	}
}