#include "coins.h"
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <iomanip>
#include <string>
#include <assert.h>
using namespace std;

#define ll long long
#define ull unsigned long long
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int, int>
#define yes cout<<"YES\n"

pii count_heavy(int k) {
	int n = 1 << k;
	vi v0(n + 5);
	v0[1] = 1;
	int cnt = 0;
	for (int i = 1; i < n; ++i) {
		vi u1, u2;
		u1.push_back(0);
		u2.push_back(i);

		int num = weigh(u1, u2);
		if (num) {
			v0[i] = 2;
			++cnt;
		}
		else {
			v0[i] = 1;
		}
	}
	if (cnt == n - 1) {
		vi u1 = { 0 }, u2 = { 1 };
		int num = weigh(u1, u2);
		if (num == 1) {
			return make_pair(1, 0);
		}
		else {
			return make_pair(n - 1, 1);
		}
	}
	for (int i = 1; i < n; ++i) {
		vi u1, u2;
		u1.push_back(0);
		if (v0[i] == 2) {
			u2.push_back(i);
			int num = weigh(u1, u2);
			if (num == 1) {
				return make_pair(n - 1, 0);
			}
			else {
				return make_pair(1, i);
			}
		}
	}
}