#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <iomanip>
#include <string>
using namespace std;

#define ll long long
#define ull unsigned long long
#define vi vector<int>
#define vll vector<ll>
#define yes cout<<"YES\n"

struct node {
	int l;
	int r;
	int ind;
	int v;
};

bool op(node x, node y) {
	if (x.v == y.v) {
		return x.l > y.l;
	}
	else {
		return x.v > y.v;
	}
}

const int N = 100005;
ll baj[N];
node a[2 * N];
int l[N], r[N], qr[N], t[2 * N], ans[N];

void upd(int n, int ind) {
	while (ind <= n) {
		++t[ind];
		ind += ind & (-ind);
	}
}

int qry(int ind) {
	int res = 0;
	while (ind) {
		res += t[ind];
		ind -= ind & (-ind);
	}
	return res;
}

void solve() {
	int q;
	cin >> q;
	for (int i = 1; i <= q; ++i) {
		cin >> l[i] >> r[i] >> qr[i];
	}
	for (int i = 1; i < N; ++i) {
		a[i].v = baj[i];
		a[i].ind = a[i].l = 0;
		a[i].r = i;
	}
	for (int i = N; i < N + q; ++i) {
		a[i].l = l[i - N + 1];
		a[i].r = r[i - N + 1];
		a[i].v = qr[i - N + 1];
		a[i].ind = i - N + 1;
	}
	sort(a + 1, a + N + q, op);
	for (int i = 1; i < N + q; ++i) {
		if (a[i].ind == 0) {
			upd(N - 1, a[i].r);
		}
		else {
			int num = qry(a[i].r) - qry(a[i].l - 1);
			ans[a[i].ind] = num;
		}
	}
	for (int i = 1; i <= q; ++i) {
		cout << ans[i] << "\n";
	}
}

void precalc() {

	for (int i = 1; i < N; ++i) {
		baj[i] = 1;
		for (int j = 2; j * j <= i; ++j) {
			if (i % j == 0) {
				baj[i] += j;
				if (j * j != i) {
					baj[i] += i / j;
				}
			}
		}
	}
	baj[1] = 0;
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	precalc();
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}