#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using ll = long long;
using namespace std;
ll qanp[100005], stug[100005];
ll arj[100005];
vector<pair<ll, pair<ll, pair<ll, ll>>>> q;
vector<pair<ll, ll>> tver;

ll s[400020];

void update(ll p, ll lp, ll rp, ll ind)
{
	if (lp == rp)
	{
		s[p] = 1;
		return;
	}
	ll m = (lp + rp) / 2;
	if (ind <= m)
	{
		update(p * 2, lp, m, ind);
	}
	else
	{
		update(p * 2 + 1, m + 1, rp, ind);
	}
	s[p] = s[p * 2] + s[p * 2 + 1];
}

ll getg(ll p, ll lp, ll rp, ll l, ll r)
{
	if (l > r)
		return 0;
	if (lp == l && rp == r)
		return s[p];
	ll m = (lp + rp) / 2;
	return getg(p * 2, lp, m, l, min(r, m)) + getg(p * 2 + 1, m + 1, rp, max(m + 1, l), r);
}

ll anss[100005];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie();
	for (ll i = 1; i <= 20; i++)
	{
		ll n = i, res = 1;
		for (ll j = 2; j <= 320; j++)
		{
			ll p = j;
			while (n % j == 0)
			{
				n /= j;
				p *= j;
			}
			res *= (p - 1) / (j - 1);
		}
		if (n == 1)
			arj[i] = res - i;
		else
			arj[i] = res;
		tver.push_back({ arj[i], i });
	}
	ll tt = 1, i = 0;
	cin >> tt;
	for ( i = 0; i < tt; i++)
	{
		ll l, r, v;
		cin >> l >> r >> v;
		q.push_back({ v,{i, {l, r} } });
	}
	sort(q.begin(), q.end());
	sort(tver.begin(), tver.end());
	ll ind = 0;
	for (ll i = 0; i < q.size(); i++)
	{
		if (tver.size() == ind || tver[ind].first > q[i].first)
		{
			anss[q[i].second.first] = q[i].second.second.second - q[i].second.second.first + 1 - getg(1, 1, 100000, q[i].second.second.first, q[i].second.second.second);
		}	
		else
		{
			update(1, 1, 100000, tver[ind].second);
			ind++;
			i--;
		}
	}
	for ( i = 0; i < tt; i++)
	{
		cout << anss[i] << '\n';
	}
	return 0;
}