#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;
int qanp[100005], stug[100005];
int arj[100005];
vector<pair<int, pair<int, pair<int, int>>>> q;
vector<pair<int, int>> tver;

int s[400020];

void update(int p, int lp, int rp, int ind)
{
	if (lp == rp)
	{
		s[p] = 1;
		return;
	}
	int m = (lp + rp) / 2;
	if (ind <= m)
	{
		update(p * 2, lp, m, ind);
	}
	else
	{
		update(p * 2 + 1, m + 1, rp, ind);
	}
	s[p] = s[p * 2] + s[p * 2 + 1];
}

int getg(int p, int lp, int rp, int l, int r)
{
	if (l > r)
		return 0;
	if (lp == l && rp == r)
		return s[p];
	int m = (lp + rp) / 2;
	return getg(p * 2, lp, m, l, min(r, m)) + getg(p * 2 + 1, m + 1, rp, max(m + 1, l), r);
}

int anss[100005];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie();
	for (int i = 1; i <= 100000; i++)
	{
		int res = 0;
		for (int j = 1; j <= int(sqrt(i)); j++)
		{
			if (j * j == i)
			{
				res += j;
			}
			else if (i % j == 0)
			{
				res += j + i / j;
			}
		}
		arj[i] = res - i;
		tver.push_back({ arj[i], i });
	}
	int tt = 1, i = 0;
	cin >> tt;
	for ( i = 0; i < tt; i++)
	{
		int l, r, v;
		cin >> l >> r >> v;
		q.push_back({ v,{i, {l, r} } });
	}
	sort(q.begin(), q.end());
	sort(tver.begin(), tver.end());
	int ind = 0;
	for (int i = 0; i < q.size(); i++)
	{
		if (tver.size() == ind || tver[ind].first > q[i].first)
		{
			anss[q[i].second.first] = q[i].second.second.second - q[i].second.second.first + 1 - getg(1, 1, 100000, q[i].second.second.first, q[i].second.second.second);
		}	
		else
		{
			update(1, 1, 100000, tver[ind].second);
			ind++;
			i--;
		}
	}
	for ( i = 0; i < tt; i++)
	{
		cout << anss[i] << '\n';
	}
	return 0;
}