#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
#include "coins.h"
#include <random>
using namespace std;

#define ff first
#define ss second
#define mpr make_pair
#define pb push_back

vector<int> v;

pair<int, int> rec(int l, int r, bool t)
{
	int i, j;

	vector<int> va, vb;

	int m = (l + r) / 2;

	for (i = l; i <= r; i++) {
		if (i <= m) va.pb(v[i]);
		else vb.pb(v[i]);
	}

	int ans = weigh(va, vb);

	if (l + 1 == r) {
		if (ans == -1) return { 1, (t == 1 ? v[l] : v[r]) };
		if (ans == 1) return { 1, (t == 1 ? v[r] : v[l]) };

		return { 2, v[l] };
	}

	pair<int, int> p, q;

	if (ans == -1) {
		p = rec(l, m, 1);
		q = rec(m + 1, r, 0);

		int h = (m - l + 1) - p.ff + q.ff;
		if (t == 0) return { h, q.ss };
		return { (r - l + 1) - h, p.ss };
	}

	if (ans == 1) {
		p = rec(l, m, 0);
		q = rec(m + 1, r, 1);

		int h = p.ff + (r - m) - q.ff;
		if (t == 0) return { h, p.ss };
		return { (r - l + 1) - h, q.ss };
	}

	p = rec(l, m, t);
	return { p.ff * 2, p.ss };
}

pair<int, int> count_heavy(int k)
{
	int i, j;

	int n = (1 << k);

	if (k == 1) {
		if (weigh({ 0 }, { 1 }) == -1) return { 1, 1 };
		else return { 1, 0 };
	}

	for (i = 0; i < n; i++) v.pb(i);

	random_shuffle(v.begin(), v.end());
	random_shuffle(v.begin(), v.begin() + rand() % (rand() % (n / 2) + 1) + 1);
	random_shuffle(v.begin(), v.end());
	random_shuffle(v.begin(), v.begin() + rand() % (rand() % n + 1) + 1);
	random_shuffle(v.begin(), v.end());
	random_shuffle(v.begin(), v.end());

	return rec(0, (1 << k) - 1, 0);
}