#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
using namespace std;

#define ff first
#define ss second
#define mpr make_pair
#define pb push_back

long long binpow(long long a, int b)
{
	long long ans = 1;
	while (b) {
		if (b & 1) ans *= a;

		a *= a;
		b >>= 1;
	}

	return ans;
}

//---------------------------------------------//

int mxr = 100005;

const int Q = 100005, MAX = 305005;
vector < pair<pair<int, int>, pair<int, int>>> a;
int ans[Q];
int q, mx;

bool cond(const pair<pair<int, int>, pair<int, int>>& a, const pair<pair<int, int>, pair<int, int>>& b)
{
	return a.ff.ss < b.ff.ss;
}

int s[100005];

int cnt;

int f[MAX];

void upd(int ind, int x)
{
	cnt += x;
	for (int i = ind; i < mx; i |= (i + 1)) f[i] += x;

	return;
}

int qry(int ind)
{
	int sum = 0;
	for (int i = ind; i >= 0; i = (i & (i + 1)) - 1) sum += f[i];

	return sum;
}

void del(int ind)
{
	upd(s[ind], -1);
	return;
}

void add(int ind)
{
	upd(s[ind], 1);
	return;
}

void solve()
{
	int i, j;

	int l, r, x;
	
	cin >> q;
	for (i = 1; i <= q; i++) {
		cin >> l >> r >> x;

		a.pb(mpr(mpr(l, r), mpr(x, i)));
	}

	sort(a.begin(), a.end());

	int oo = mx / int(sqrt(q));
	int o = oo;

	int last = 0;

	for (i = 0; i < a.size(); i++) {
		if (a[i].ff.ff > o) {
			sort(a.begin() + last, a.begin() + i, cond);

			last = i;
			o += oo;
		}
	}

	sort(a.begin() + last, a.end(), cond);

	l = 1, r = 0;
	
	int ql, qr, xx;

	for (i = 0; i < a.size(); i++) {
		ql = a[i].ff.ff;
		qr = a[i].ff.ss;
		xx = a[i].ss.ff;

		while (l < ql) {
			del(l);
			l++;
		}
		while (l > ql) {
			add(l - 1);
			l--;
		}
		while(r < qr) {
			add(r + 1);
			r++;
		}
		while (r > qr) {
			del(r);
			r--;
		}

		ans[a[i].ss.ss] = cnt - qry(xx);
	}

	for (i = 1; i <= q; i++) {
		cout << ans[i] << "\n";
	}

	return;
}

long long sigma(int t)
{
	int i, j;

	long long ans = 1;

	int q;

	for (i = 2; i * i <= t; i++) {
		if (t % i == 0) {
			q = 0;
			while(t % i == 0) {
				t /= i;
				q++;
			}

			ans *= ((binpow(i, q + 1) - 1) / (i - 1));
		}
	}

	if (t > 1) ans *= (t + 1);

	return ans;
}

void precalc()
{
	int i, j;

	for (i = 2; i <= mxr; i++) {
		s[i] = sigma(i) - i;
		mx = max(mx, s[i]);
	}

	return;
}

int main()
{
	int i, j;

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	precalc();

	solve();

	return 0;
}