#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
using namespace std;

#define ff first
#define ss second
#define mpr make_pair
#define pb push_back

long long binpow(long long a, int b)
{
	long long ans = 1;
	while (b) {
		if (b & 1) ans *= a;

		a *= a;
		b >>= 1;
	}

	return ans;
}

//---------------------------------------------//

int mxr = 100005;

const int Q = 100005, MAX = 305005;
vector<pair<pair<int, int>, pair<int, int>>> a;
vector<pair<int, pair<int, int>>> b;
int ans[Q * 2];
int q, mx;

int s[100005];

int f[MAX];

void upd(int ind)
{
	for (int i = ind; i < mx; i |= (i + 1)) f[i]++;

	return;
}

int qry(int ind)
{
	int sum = 0;
	for (int i = ind; i >= 0; i = (i & (i + 1)) - 1) sum += f[i];

	return sum;
}

void solve()
{
	int i, j;

	int l, r, x;
	
	cin >> q;
	for (i = 0; i < q; i++) {
		cin >> l >> r >> x;

		a.pb(mpr(mpr(l, r), mpr(x, i)));
		b.pb(mpr(r, mpr(x, i * 2)));
		b.pb(mpr(l - 1, mpr(x, i * 2 + 1)));
	}

	sort(b.begin(), b.end());

	r = 0;
	int qr, xx;
	int cnt = 0;

	for (i = 0; i < b.size(); i++) {
		qr = b[i].ff;
		xx = b[i].ss.ff;

		//cout << qr << "\n";

		while (r < qr) {
			upd(s[r + 1]);
			r++;
			cnt++;
		}

		ans[b[i].ss.ss] = cnt - qry(xx);
	}

	for (i = 0; i < q; i++) {
		cout << ans[i * 2] - ans[i * 2 + 1] << "\n";
	}

	return;
}

long long sigma(int t)
{
	int i, j;

	long long ans = 1;

	int q;

	for (i = 2; i * i <= t; i++) {
		if (t % i == 0) {
			q = 0;
			while(t % i == 0) {
				t /= i;
				q++;
			}

			ans *= ((binpow(i, q + 1) - 1) / (i - 1));
		}
	}

	if (t > 1) ans *= (t + 1);

	return ans;
}

void precalc()
{
	int i, j;

	for (i = 2; i <= mxr; i++) {
		s[i] = sigma(i) - i;
		mx = max(mx, s[i]);
	}

	return;
}

int main()
{
	int i, j;

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	precalc();

	solve();

	return 0;
}