#include "coins.h"
using namespace std;

pair<int, int> count_heavy(int k) {
	int nm = 1;
	for (int i = 1; i <= k; i++) nm *= 2;
	if (k <= 10) {
		int c1 = 0, c2 = 0;
		vector<int> v1, v2;
		v1.push_back(0);
		v2.push_back(1);
		for (int i = 1; i < nm; i++) {
			if (weigh(v1, v2) == 1) {
				c1++;
				c2 = 0;
			}
			else if (weigh(v1, v2) == -1) {
				c1++;
				c2 = i;
			}
			v2.clear();
			v2.push_back(i + 1);
		}
		return make_pair(c1, c2);
	}
	else {
        int l = 0, r = nm - 1;
        int l1 = 0, r1 = r / 2, l2 = r1 + 1, r2 = r;
        vector<int> v1, v2;
        while (1) {
            for (int i = l1; i <= r1; i++) {
                if (i <= (l1 + r1) / 2) {
                    v1.push_back(i);
                }
                else {
                    v2.push_back(i);
                }
            }
            if (weigh(v1, v2) == 0) {
                if (r1 - l1 == 1) {
                    r = r2, l = l2;
                    break;
                }
                else {
                    l1 = l2;
                    r1 = (l2 + r2) / 2;
                    l2 = r1 + 1;
                }
            }
            else {
                if (r1 - l1 == 1) {
                    r = r1, l = l1;
                    break;
                }
                else {
                    r2 = r1;
                    r1 = (l1 + r1) / 2;
                    l2 = r1 + 1;
                }
            }
            v1.clear();
            v2.clear();
        }
        v1.clear();
        v2.clear();
        v1.push_back(l);
        v2.push_back(r);
        int q = weigh(v1, v2);
        int kx = (l == 0 ? r + 1 : l - 1);
        v2.clear();
        v2.push_back(kx);
        if (weigh(v1, v2) == 0) {
            if (q == 1) {
                return make_pair(nm - 1, l);
            }
            else {
                return make_pair(1, r);
            }
        }
        else {
            if (q == 1) {
                return make_pair(1, l);
            }
            else {
                return make_pair(nm - 1, r);
            }
        }
	}
}