#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
using namespace std;

const int N = 1e5 + 5;
int erat[N];
vector<int> p;

void slv() {
	int l, r, v;
	cin >> l >> r >> v;
	int ans = 0;
	//if (v <= 10) {
	//	return;
	//}
	for (int i = l; i <= r; i++) {
		if (!erat[i] || i == 1) continue;
		int sum = 0;
		for (int j = 1; j < i; j++) {
			if (i % j == 0) sum += j;
		}
		if (sum > v) ans++;
	}
	cout << ans << '\n';
}

void precalc() {
	for (int i = 2; i < 317; i++) {
		if (!erat[i]) {
			for (int j = i * i; j < 100001; j += i) {
				erat[j] = 1;
			}
		}
	}
	for (int i = 2; i < 100001; i++) {
		if (!erat[i]) p.push_back(i);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tstc = 1;
	precalc();
	cin >> tstc;
	while (tstc--) slv();
	return 0;
}