#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
using namespace std;

const int N = 1e5 + 5;
int erat[N], pref[N], cnt[55];
vector<int> p;

void slv() {
	int l, r, v;
	cin >> l >> r >> v;
	int ans = 0;
	if (v <= 10) {
		if (r <= 3) {
			cout << 0 << '\n';
			return;
		}
		for (int i = max(l, 4); i <= min(r, 49); i++) {
			if (!erat[i]) continue;
			if (cnt[i] > v) ans++;
		}
		l = max(l, 50);
		if (l > r) {
			cout << ans << '\n';
			return;
		}
		ans += (r - l + 1);
		ans -= pref[r] - pref[l - 1];
		cout << ans << '\n';
		return;
	}
	for (int i = l; i <= r; i++) {
		if (!erat[i] || i == 1) continue;
		int sum = 1;
		for (int j = 2; j <= sqrt(i); j++) {
			if (i % j == 0) {
				if (j == (i / j)) {
					sum += j;
				}
				else {
					sum += (j + i / j);
				}
			}
		}
		if (sum > v) ans++;
	}
	cout << ans << '\n';
}

void precalc() {
	for (int i = 2; i < 317; i++) {
		if (!erat[i]) {
			for (int j = i * i; j < 100001; j += i) {
				erat[j] = 1;
			}
		}
	}
	for (int i = 2; i < 100001; i++) {
		pref[i] = pref[i - 1];
		if (!erat[i]) p.push_back(i), pref[i]++;
	}
	for (int i = 4; i <= 49; i++) {
		if (!erat[i]) continue;
		int sum = 1;
		for (int j = 2; j <= sqrt(i); j++) {
			if (i % j == 0) {
				if (j == (i / j)) {
					sum += j;
				}
				else {
					sum += (j + i / j);
				}
			}
		}
		cnt[i] = sum;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tstc = 1;
	precalc();
	cin >> tstc;
	while (tstc--) slv();
	return 0;
}