#include<bits/stdc++.h>
#define ll long long
using namespace std;
int c[2001], t[2000], dist[2000];
vector<int> tree[2000];
int use[8];
ll ans;

void dfs(int u, int d, int p) {
	dist[u] = d;
	for (auto c : tree[u]) {
		if (c != p) dfs(c, d + 1, u);
	}
}

void rec(int i, int n) {
	if (i == n) {
		bool ok = 0;
		for (int j = 0; j < n; j++) {
			dfs(j, 1, j);
			ok = 0;
			for (int j2 = 0; j2 < n; j2++) {
				if (dist[j2] <= use[j2]) ok = 1;
			}
			if (!ok) break;
		}
		if (ok) {
			ll cost = 0;
			for (int j = 0; j < n; j++) cost += c[use[j]];
			ans = min(ans, cost);
		}
		return;
	}
	else {
		for (int j = 0; j <= t[i]; j++) {
			use[i] = j;
			rec(i + 1, n);
		}
	}
}

int main() {
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++) cin >> c[i];
	for (int i = 0; i < n; i++) cin >> t[i];
	for (int i = 0; i < n - 1; i++) {
		int v, u;
		cin >> v >> u; v--; u--;
		tree[v].push_back(u);
		tree[u].push_back(v);
	}
	if (n <= 8) {
		ans = INT64_MAX;
		rec(0, n);
		cout << ans << "\n";
	}
}