#include <iostream>
#include <cmath>
#include <algorithm>
using namespace std;

void fastio() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}
const int N = 1e5 + 7;
int pref[N];

void solve() {
	int l, r, v;
	cin >> l >> r >> v;
	int m = v / 2;
	m *= m;
	int ans = 0;
	// cout << ans << endl;
     if (r <= m && l<=m) {
		for (int i = l; i <= r; i++) {
			int x = 0;
			for (int j = 2; j <= sqrt(i); j++) {
				if (i % j == 0) {
					x += i / j;
					if (i / j != j) {
						x += j;
				}
				}
			}
			if (x > v) {
				ans++;
			}
		}
	 }
	//cout << ans << endl;
	 else if (l >= m) {
		 if (l <= 9 && r >= 9 && v >= 4) {
			 ans--;
		 }
		 if (l <= 25 && r >= 25 && v >= 6) {
			 ans--;
		 }
		 if (l <= 49 && r >= 49 && v >= 8) {
			 ans--;
		 }
		 if (r == l && l == 25 || r == l && l == 49 || r == l && l == 9) {
			 ans = 0;
		 }
		 ans += r - l + (l != m) - (pref[r] - pref[l - 1]);
	 }
	else {
		 if (l <= 9 && r >= 9 && v >= 4) {
			 ans--;
		 }
		 if (l <= 25 && r >= 25 && v >= 6) {
			 ans--;
		 }
		 if (l <= 49 && r >= 49 && v >= 8) {
			 ans--;
		 }
		 if (r == l && l == 25 || r == l && l == 49 || r == l && l == 9) {
			 ans = 0;
		 }
		ans += r - m - (pref[r] - pref[m-1]);
		for (int i = l; i <= m; i++) {
			int cnt = 0;
			for (int j = 1; j <= sqrt(i); j++) {
				if (i % j == 0) {
					cnt += j;
					if (i / j != j) {
						cnt += i / j;
					}
				}
			}
			if (cnt-m > v) {
				ans++;
			}
		}
	}
	cout << ans << "\n";
}

int main() {
	fastio();
	for (int i = 1; i <= 1e5; i++) {
		bool f = true;
		for (int j = 2; j <= sqrt(i); j++) {
			if (i % j == 0) {
				f = false;
			}
		}
		if (f) {
			pref[i]++;
		}
		pref[i] += pref[i - 1];
	}
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}