#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAX = 1e5 + 5;
const int sMAX = sqrt(MAX);
vector<int> lp(MAX);

void precomp(){
    int d = sqrt(sMAX);
    for(int i=2 ; i<d ; i++){
        if(lp[i] == 0){
            lp[i] = i;
            for(int j=i*i ; j<sMAX ; j+=i){
                lp[j] = i;
            }
        }
    }
}

void solve(){
    int l , r , need;
    cin >> l >> r >> need;
    for(int i=l ; i<=r ; i++){
        int number  = i;
        while(number > 1){
            if(lp[number] == -1){
                number = 1;
            }     
            else{
                number /= lp[number];
            }
        }
    }  
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    precomp();
    int test;
    cin >> test;
    while(test--){
        solve();
    }
}