#include "coins.h"
#include <bits/stdc++.h>
using namespace std;
#define weight weigh
const int N = (1ll<<20)+10;
int n;
int c;
vector<int> heavy;
vector<int> light;
void binarysearchh(int l, int r) {
	if(heavy.size() == 2*c)return;
	if(l == r){
		heavy.push_back(l);
		return;
	}
	int mid = (l+r)/2;
	vector<int> a, b;
	for(int i = l;i<=mid;i++)a.push_back(i);
	for(int i = mid+1;i<=r;i++)b.push_back(i);
	int v = weight(a,b);
	if(v==0) {
		binarysearchh(l, mid);
		binarysearchh(mid+1, r);
	}
	else if(v==1) {
		binarysearchh(l,mid);
	}
	else binarysearchh(mid+1,r);
}
void binarysearchl(int l, int r) {

	if(light.size() == 2*c)return;
	if(l == r){
		light.push_back(l);
		return;
	}
	int mid = (l+r)/2;
	vector<int> a, b;
	for(int i = l;i<=mid;i++)a.push_back(i);
	for(int i = mid+1;i<=r;i++)b.push_back(i);
	int v = weight(a,b);
	if(v==0) {
		binarysearchl(l, mid);
		binarysearchl(mid+1, r);
	}
	else if(v==-1) {
		binarysearchl(l,mid);
	}
	else binarysearchl(mid+1,r);
}
pair<int, int> count_heavy(int k) {
 	n=(1ll<<k);
	c = sqrtl(n);
	binarysearchl(0,n-1);
	binarysearchh(0,n-1);
	long long res=0;
	for(int i = 0;i<n;i+=c) {
		int lo = 0, hi = c;
		while(lo < hi) {
			int mid = (lo+hi)/2;
			vector<int> _b;
			vector<int> _a;
			for(int j = i;j<i+c;j++)_a.push_back(j);
			for(int j = 0;j<mid;j++)_b.push_back(heavy[j]);
			for(int j = 0;j<c-mid;j++)_b.push_back(light[j]);
			vector<int> a, b;
			for(int j:_a) {
				if(find(_b.begin(), _b.end(), j)!=_b.end())continue;
				a.push_back(j);
			}
			for(int j:_b) {
				if(find(_a.begin(), _a.end(), j)!=_a.end())continue;
				b.push_back(j);
			}	
			int val = weight(a,b);
			if(val == 0) {
				lo=mid;
				hi=mid;
				break;
			}
			else if(val == 1){
				lo = mid+1;
			}
			else {
				hi=mid-1;
			}
		}
		res+=lo;

	}
	return {res,heavy.back()};
}
