#include <bits/stdc++.h>

typedef long long ll;
typedef unsigned long long ull;
const ll INFL = 0x3f3f3f3f3f3f3f3f;
const ull INFUL = INFL;
#define IOF ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define WH while
#define WHI(t) WH(t--)
#define FOR(typ,i,a,b,c) for(typ i = a; i<b; i+=c)
#define FORR(typ,i,a,b,c) for(typ i = a; i>b; i-=c)
#define FORA(a,x) for(auto &x : a)
#define RET return
#define V vector
#define TYP 1
using namespace std;
ll l, r, v, c;
V<ll> lp, prms;
ll po(ll a, ll b)
{
	ll res = 1;
	WH(b > 0)
	{
		if (b & 1)res *= a;
		a *= a;
		b >>= 1;
	}
	return res;
}
ll mult(ll a, ll b, ll m)
{
	ll res = 0;
	a %= m;
	WH(b > 0)
	{
		if (b & 1)res = (res + a) % m;
		a = (2 * a) % m;
		b >>= 1;
	}
	return res;
}
ll pom(ll a, ll b, ll m)
{
	ll res = 1;
	a %= m;
	WH(b > 0)
	{
		if (b & 1)res = mult(a,res,m);
		a = mult(a, a, m);
		b >>= 1;
	}
	return res;
}
bool chk_com(ll a, ll s, ll q, ll n)
{
	ll x = pom(a, q, n);
	if (x == n - 1 || x == 1)return 0;
	FOR(ll, i,0 , s, 1)
	{
		x = mult(x, x, n);
		if (x == n - 1 || x == 1)return 0;
	}
	return 1;
}
bool miller(ll n)
{
	if (n < 2)return 0;
	if (n < 4)return 1;
	if (n & 1 ^ 1)return 0;
	ll d = n - 1, s = 0;
	WH(d&1^1)d >>= 1, s++;
	for (auto a : { 2,3,5,7,11,13,17,19,23,29,31,37 })
	{
		if (a == n)return 1;
		if (chk_com(a, s, d, n))return 0;
	}
		
	return 1;
}
ll divs(ll n)
{
	if (miller(n))return 1;
	ll res = 1, n1=n;
	map<ll, ll> d;
	WH(n > 1)
	{
		d[lp[n]]++;
		n /= lp[n];
		
	}
	if (n > 1)d[n]++;
	FORA(d, p)res *= (po(p.first, p.second + 1) - 1) / (p.first - 1);
	return res-n1;
}

void solve()
{
	cin >> l >> r >> v;
	c = 0;
	FOR(ll, x, l, r + 1, 1)
		c += divs(x) > v;
	cout << c << endl;
}

void init()
{
	lp.resize(10001);
	FOR(ll, i, 2, 10001, 1)
	{
		if (!lp[i])
		{
			prms.emplace_back(i);
			lp[i] = i;
		}
		for (ll j = 0; prms[j] * i <= 10000; j++)
		{
			lp[prms[j] * i] = lp[i];
			if (prms[j] == lp[i])break;
		}
	}
}

void handle()
{
	ll t = 1;
	if (TYP) cin >> t;
	WHI(t)solve();


}

int main()
{
	IOF
	init();
	handle();
	RET 0;
}

