#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define endl '\n'
const int N = 1e5+1;
vector<int> segTree[4*N+5];
vector<int> sum(N+5);
void build(int l=1,int r=N,int p=1){
    if(l>r) return;
    if(l == r){
        segTree[p] = {sum[l]};
        return;
    }
    int md = l + r >> 1;
    build(l,md,p*2);
    build(md+1,r,p*2+1);
    for(auto i : segTree[p*2]){
        segTree[p].push_back(i);
    }
    for(auto i : segTree[p*2+1]){
        segTree[p].push_back(i);
    }
    sort(segTree[p].begin(),segTree[p].end());
}
int query(int lQ,int rQ,int x,int l=1,int r=N,int p=1){
    if(l>r) return 0;
    if(r < lQ || rQ < l) return 0;
    if(lQ<=l&&r<=rQ){
        int sz = segTree[p].size();
        int idx = upper_bound(segTree[p].begin(),segTree[p].end(),x) - segTree[p].begin();
        return sz - idx;
    }
    int md = l + r >> 1;
    return query(lQ,rQ,x,l,md,p*2) + query(lQ,rQ,x,md+1,r,p*2+1);
}
void solve(){
    int l,r,x;
    cin>>l>>r>>x;
    cout<<query(l,r,x)<<endl;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);      cout.tie(0);
    int t=1;
    cin>>t;
    for(int i=1;i<=N;i++){
        ll s = 0;
        for(int j=1;j*j<=i;j++){
            if(i%j==0){
                s += j;
                if(j!=(i/j)) s += i/j;
            }
        }
        sum[i] = s-i;
    }
    build();
    while(t--){
        solve();
    }
    return 0;
}
