#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define endl '\n'
const int N = 1e5+1;
vector<int> sum(N+5);
vector<int> BIT[N+1];
void update(int i,int val){
    while(i<N){
        BIT[i].push_back(val);
        i += i&(-i);
    }
}
int prefix(int i,int x){
    int ret = 0;
    while(i>0){
        int sz = BIT[i].size();
        int idx = upper_bound(BIT[i].begin(),BIT[i].end(),x) - BIT[i].begin();
        ret += sz - idx;
        i -= i&(-i);
    }
    return ret;
}
int query(int l,int r,int x){
    return prefix(r,x) - prefix(l-1,x);
}
void solve(){
    int l,r,x;
    cin>>l>>r>>x;
    cout<<query(l,r,x)<<endl;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);      cout.tie(0);
    int t=1;
    cin>>t;
    for(int i=1;i<N;i++){
        int s = 0;
        for(int j=1;j*j<=i;j++){
            if(i%j==0){
                s += j;
                if(j!=(i/j)) s += i/j;
            }
        }
        sum[i] = s-i;
        update(i,s-i);
    }
    for(auto &i:BIT){
        if(i.size()) sort(i.begin(),i.end());
    }
    while(t--){
        solve();
    }
    return 0;
}
