#include <bits/stdc++.h>
#pragma GCC optimize("O3", "unroll-loops")

using namespace std;
#define lg long long

const lg N = 2e3+5;

lg n;
vector<lg> c(N), t(N), adj[N];
lg vis[N];

void dfs(lg src, lg path)
{
	if(!path)	return;
	vis[src] = true;
	for(auto it : adj[src])
	{
		if(vis[it])	continue;
		dfs(it, path-1);
	}
	return;
}

lg solve(lg idx, vector<lg> v)
{
	if(idx == n)
	{
		lg s = 0;
		for(auto it : v)	s += c[it];
		for(int i = 1; i <= n; i++)
		{
			dfs(i, v[i-1]);
		}
		for(int i = 1; i <= n; i++)	if(!vis[i])	s = 1e18;
		memset(vis, 0, sizeof(vis));
		return s;
	}
	lg ans = 1e18;
	for(int i = 0; i <= t[idx]; i++)
	{
		v.push_back(i);
		ans = min(ans, solve(idx+1, v));
		v.pop_back();
	}
	return ans;
}

int main() 
{
	cin >> n;
	for(int i = 1; i <= n; i++)	
	{
		cin >> c[i];
	}
	for(int i = 1; i <= n; i++)	
	{
		cin >> t[i];
	}
	for(int i = 0; i < n-1; i++)
	{
		lg u, v;
		cin >> u >>  v;
		adj[u].push_back(v);
		adj[v].push_back(u);
	}
	vector<lg> v;
	lg ans = solve(0, v);
	if(ans > 1e8)	ans = -1;
	cout << ans << '\n';
	
	return 0;
}