#include <bits/stdc++.h>


using namespace std;

vector<int> seg[262144];

struct segtree{
	int n = 131072;
	void build()
	{
		for(int i = 1; i <= n; i++)	seg[i-1+n].push_back(0);
		for(int i = 1; i <= n; i++)
		{
			for(int j = (i << 1); j <= n; j += i)
			{
				seg[j-1+n][0] += i;
			}
		}
		for(int i = n-1; i > 0; i--)
		{
			int l = 0, r = 0;
			while(l < seg[(i << 1)].size() && r < seg[(i << 1)+1].size())
			{
				if(seg[(i << 1)][l] < seg[(i << 1)+1][r])	seg[i].push_back(seg[(i << 1)][l++]);
				else	seg[i].push_back(seg[(i << 1)+1][r++]);
			}
			while(l < seg[(i << 1)].size())
			{
				seg[i].push_back(seg[(i << 1)][l++]);
			}
			while(r < seg[(i << 1)+1].size())
			{
				seg[i].push_back(seg[(i << 1)+1][r++]);
			}
		}
	}
	int get(int node, int low_range, int high_range, int low_query, int high_query, int val)
	{
		if(low_range > high_query || low_query > high_range)	return 0;
		if(low_range >= low_query && high_query >= high_range)
		{
			int l = 0, r = seg[node].size()-1, ans = seg[node].size();
			while(l <= r)
			{
				int mid = ((l+r) >> 1);
				if(seg[node][mid] > val)	
				{
					r = mid-1;
					ans = mid;
				}
				else	l = mid+1;
			}
			return seg[node].size()-ans;
		}
		int mid = ((low_range+high_range) >> 1);
		return get((node << 1), low_range, mid, low_query, high_query, val)+get((node << 1)+1, mid+1, high_range, low_query, high_query, val);
	}
};

int main()
{
	ios_base::sync_with_stdio(0);cin.tie(NULL);cout.tie(NULL);
	segtree s;	
	s.build();
	int q;
	cin >> q;
	while(q--)
	{
		int l, r, v;
		cin >> l >> r >> v;
		cout << s.get(1, 1, s.n, l, r, v) << '\n';
	}
}