#include "bits/stdc++.h"
#include "coins.h"
using namespace std;

struct dsu {
    vector<int> p;
    vector<int> r;

    int get(int x) {
        if (x == p[x]) {
            return x;
        } else {
            return p[x] = get(p[x]);
        }
    }

    void join(int a, int b) {
        a = get(a);
        b = get(b);

        if (a == b) {
            return;
        }

        if (r[a] < r[b]) {
            swap(a, b);
        }

        r[a] += r[b];
        p[b] = a;
    }

    dsu(int n) {
        r.assign(n + 2, 1);
        p.assign(n + 2, 0);
        iota(p.begin(), p.end(), 0);
    }
};

pair<int, int> count_heavy(int k) {
    int n = (1 << k);
    dsu d(n);

    int heavy;

    for (int i = 0; i < n - 1; i++) {
        int w = weigh({i}, {i + 1});

        if (w == 0) {
            d.join(i, i + 1);
        } else if (w == -1) {
            d.join(i, n);
            d.join(i + 1, n + 1);

            heavy = i + 1;
        } else if (w == 1) {
            d.join(i, n + 1);
            d.join(i + 1, n);

            heavy = i;
        }
    }

    return {d.r[d.get(n + 1)] - 1, heavy};
}