﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include "coins.h"
#include <random>
using namespace std;
typedef int ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forr(i, n) for (ll i = 0;i<n;i++)
mt19937 rng(0);
ll getw(ll l, ll r) {
    if (l == r) return l;
    if (l + 1 == r) {
        vector<int> a = {l}, b = {r};
        if (weigh(a, b) == 1) return l;
        else return r;
    }
    ll k = (r - l + 1) / 3;
    vector<int> a, b;
    for (int i = l; i < l + k; i++) a.push_back(i);
    for (int i = l + k; i < l + 2 * k; i++) b.push_back(i);
    ll res = weigh(a, b);
    if (res == 1) return getw(l, l + k);
    else if (res == 0) return getw(l + 2 * k, r);
    else return getw(l + k, l + 2 * k);
}

pair<int, int> count_heavy(int k) {
    int n = (1 << k);
    if (k <= 10) {
        ll ans = 0;
        ll b = 0;
        for (ll i = 1; i < n; i++) {
            ll res = weigh({0}, {i});
            if (res == 0) ans++;
            else {
                if (res == -1) b = i;
            }
        }
        if (b == 0) return {ans + 1, b};
        else return {n - ans - 1, b};
    }
    ll w = getw(0, n - 1);
    ll nw = rng() % n;
    if (w == nw) nw = rng() % n;
    if (weigh({w}, {nw}) != 1) {
        return {n - 1, nw};
    }
    return {1, w};
}

/*int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    return 0;
}*/