#include "coins.h"
#include<bits/stdc++.h>

using namespace std;

typedef int ll;

const ll INF = 2000000000;

mt19937 rnd(time(0));

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

bool ch(ll u, vector<ll>& at, vector<ll>& al, vector<ll>& c) {
	vector<ll> sec;
	for (ll i = 0; i < u; i++) {
		sec.push_back(at[i]);
	}
	for (ll j = 0; j < c.size() - u; j++) {
		sec.push_back(al[j]);
	}
	return weigh(sec, c) == 1;
}

pair<int, int> count_heavy(int kk) {
	ll n = (1 << kk);
	if (kk <= 3) {
    vector<int> a, b;
    int num = -1, col = 0;
    int last = -1;
    vector<int> lasts(1, 0);
    for (ll i = 1; i < n; i++) {
        a.push_back(i - 1);
        b.push_back(i);
        ll check = weigh(a, b);
        if (check == 0) {
            if (last == -1) {
                lasts.push_back(i);
            } else {
                col += last == 1;
            }
        }
        if (check == -1) {
            last = 1;
            col++;
            num = i;
            lasts.clear();
        }
        if (check == 1) {
            col += lasts.size();
            if (!lasts.empty()) {
                num = lasts.back();
            }
            lasts.clear();
            last = 0;
        }
        a.pop_back();
        b.pop_back();
    }
    return make_pair(col, num);
	}
	ll k = min(n, max(2, (1 << (kk / 2))));
	ll sb = n / k;
	vector<vector<int>> block(k);
	vector<int> a(n);
	for (ll i = 0; i < n; i++) {
		a[i] = i;
	}
	shuffle(a.begin(), a.end(), rnd);
	for (ll i = 0; i < n; i++) {
		block[i / sb].push_back(a[i]);
	}
	ll check = weigh(block[0], block[1]);
	vector<ll> sorted;
	sorted.push_back(0);
	sorted.push_back(1);
	if (check == -1) {
		swap(sorted[0], sorted[1]);
	}
	for (ll i = 2; i < k; i++) {
		ll l = 0, r = sorted.size();
		if (weigh(block[i], block[sorted.back()]) == -1) {
			sorted.push_back(i);
			continue;
		}
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			ll check = weigh(block[i], block[sorted[mid]]);
			if (check == 0) {
				l = mid;
				break;
			}
			if (check == -1) {
				l = mid + 1;
			} else {
				r = mid;
			}
		}
		sorted.insert(sorted.begin() + l, i);
	}
	ll maxb = sorted[0], minb = sorted.back();
	vector<ll> at, al;
	ll last = -1;
	vector<ll> all(1, block[minb][0]);
	ll cm = 0;
	for (ll i = 1; i < sb; i++) {
		vector<ll> a, b;
		a.push_back(block[minb][i]);
		b.push_back(block[minb][i - 1]);
		ll check = weigh(b, a);
		if (check == 0) {
			if (last == -1) {
				all.push_back(block[minb][i]);
			} else {
				if (last == 1) {
					cm++;
					at.push_back(block[minb][i]);
				} else {
					al.push_back(block[minb][i]);
				}
			}
		}
		if (check == -1) {
			for (auto i : all) {
				al.push_back(i);
			}
			all.clear();
			last = 1;
			cm++;
			at.push_back(block[minb][i]);
		}
		if (check == 1) {
			for (auto i : all) {
				at.push_back(i);
				cm++;
				cerr << i << endl;
			}
			all.clear();
			last = 0;
			al.push_back(block[minb][i]);
		}
	}
	for (auto i : all) {
		al.push_back(i);
	}
	all.clear();
	all.resize(1, block[maxb][0]);
	ll cb = 0;
	last = -1;
	for (ll i = 1; i < sb; i++) {
		vector<ll> a, b;
		a.push_back(block[maxb][i]);
		b.push_back(block[maxb][i - 1]);
		ll check = weigh(b, a);
		if (check == 0) {
			if (last == -1) {
				all.push_back(block[maxb][i]);
			} else {
				if (last == 1) {
					cb++;
					at.push_back(block[maxb][i]);
				} else {
					al.push_back(block[maxb][i]);
				}
			}
		}
		if (check == -1) {
			for (auto i : all) {
				al.push_back(i);
			}
			all.clear();
			last = 1;
			cb++;
			at.push_back(block[maxb][i]);
		}
		if (check == 1) {
			for (auto i : all) {
				at.push_back(i);
				cb++;
			}
			all.clear();
			last = 0;
			al.push_back(block[maxb][i]);
		}
	}
	for (auto i : all) {
		at.push_back(i);
		cb++;
	}
	ll ans = cm + cb;
	ll u = cb;
	for (ll i = 1; i < k - 1; i++) {
		while (u != cm && ch(u, at, al, block[sorted[i]])) {
			u--;
		}
		ans += u;
	}
	return make_pair(ans, at[0]);
}
