#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 2000000000000;

mt19937 rnd(time(0));

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void dfs1(ll v, ll p, ll rn, vector<vector<pair<ll, ll>>>& arr, vector<vector<vector<ll>>>& dp, vector<vector<vector<ll>>>& dp2, vector<ll>& c, vector<ll>& t) {
	for (auto[i, nr] : arr[v]) {
		if (i != p) {
			dfs1(i, v, nr, arr, dp, dp2, c, t);
		}
	}
	if (p == v) {
		return;
	}
	ll ma = INF, mi = INF;
	for (ll np = t[v]; np >= 1; np--) {
		assign_min(mi, c[np]);
		ll now = mi;
		for (auto[i, nr] : arr[v]) {
			if (i != p) {
				now += dp[i][nr][np - 1];
			}
		}
		assign_min(ma, now);
	}
	mi = INF;
	dp[v][rn][0] = ma;
	for (ll np = arr.size(); np >= 1; np--) {
		dp[v][rn][np] = ma;
		ll now = 0, now2 = 0;
		for (auto[i, nr] : arr[v]) {
			if (i != p) {
				now += dp[i][nr][np - 1];
			}
		}
		if (np <= t[v]) {
			assign_min(mi, c[np]);
			assign_min(dp2[v][rn][np], now + mi);
		}
		if (np != arr.size()) {
			for (auto[i, nr] : arr[v]) {
				if (i != p) {
					assign_min(dp2[v][rn][np], now - dp[i][nr][np - 1] + dp2[i][nr][np + 1]);
				}
			}
		}
		assign_min(dp2[v][rn][np - 1], dp2[v][rn][np]);
		assign_min(dp[v][rn][np], now);
	}
	assign_min(dp[v][rn][0], dp2[v][rn][1]);
	for (ll np = 0; np < arr.size(); np++) {
		assign_min(dp[v][rn][np + 1], dp[v][rn][np]);
	}
}

void dfs2(ll v, ll p, ll rn, vector<vector<pair<ll, ll>>>& arr, vector<vector<vector<ll>>>& dp, vector<vector<vector<ll>>>& dp2, vector<ll>& c, vector<ll>& t) {
	if (true) {
		vector<ll> ma(arr[v].size(), INF);
		ll mi = INF;
		for (ll np = t[v]; np >= 1; np--) {
			assign_min(mi, c[np]);
			ll now = mi;
			for (auto[i, nr] : arr[v]) {
				now += dp[i][nr][np - 1];
			}
			for (ll j = 0; j < arr[v].size(); j++) {
				assign_min(ma[j], now - dp[arr[v][j].first][arr[v][j].second][np - 1]);
			}
		}
		for (ll j = 0; j < arr[v].size(); j++) {
			dp[v][j][0] = ma[j];
		}
		mi = INF;
		for (ll np = arr.size(); np >= 1; np--) {
			for (ll j = 0; j < arr[v].size(); j++) {
				dp[v][j][np] = ma[j];
			}
			ll now = 0, now2 = 0;
			for (auto[i, nr] : arr[v]) {
				now += dp[i][nr][np - 1];
			}
			if (np <= t[v]) {
				assign_min(mi, c[np]);
				for (ll j = 0; j < arr[v].size(); j++) {
					assign_min(dp2[v][j][np], now - dp[arr[v][j].first][arr[v][j].second][np - 1] + mi);
				}
			}
			if (np != arr.size()) {
				ll fm = INF, ifm = 0;
				ll sm = INF;
				for (auto[i, nr] : arr[v]) {
					ll lfm = fm;
					if (assign_min(fm, -dp[i][nr][np - 1] + dp2[i][nr][np + 1])) {
						ifm = i;
						sm = lfm;
					} else {
						assign_min(sm, -dp[i][nr][np - 1] + dp2[i][nr][np + 1]);
					}
				}
				for (ll j = 0; j < arr[v].size(); j++) {
					if (arr[v][j].first == ifm) {
						assign_min(dp2[v][j][np], now + sm - dp[arr[v][j].first][arr[v][j].second][np - 1]);
					} else {
						assign_min(dp2[v][j][np], now + fm - dp[arr[v][j].first][arr[v][j].second][np - 1]);
					}
				}
			}
			for (ll j = 0; j < arr[v].size(); j++) {
				assign_min(dp2[v][j][np - 1], dp2[v][j][np]);
				assign_min(dp[v][j][np], now - dp[arr[v][j].first][arr[v][j].second][np - 1]);
			}
		}
		for (ll j = 0; j < arr[v].size(); j++) {
			assign_min(dp[v][j][0], dp2[v][j][1]);
		}
		for (ll np = 0; np < arr.size(); np++) {
			for (ll j = 0; j < arr[v].size(); j++) {
				assign_min(dp[v][j][np + 1], dp[v][j][np]);
			}
		}
	}
	for (auto[i, nr] : arr[v]) {
		if (i != p) {
			dfs2(i, v, nr, arr, dp, dp2, c, t);
		}
	}
}

ll solve(ll n, vector<ll> cc, vector<ll> tt, vector<pair<ll, ll>> reb) {
	vector<ll> c(n + 1, 0);
	vector<ll> t(n);
	for (ll i = 1; i <= n; i++) {
		c[i] = cc[i - 1];
	}
	for (ll i = 0; i < n; i++) {
		t[i] = tt[i];
	}
	vector<vector<pair<ll, ll>>> arr(n);
	for (auto[a, b] : reb) {
		a--;
		b--;
		arr[a].emplace_back(b, arr[b].size());
		arr[b].emplace_back(a, arr[a].size() - 1);
	}
	vector<vector<vector<ll>>> dp(n), dp2(n);
	for (ll i = 0; i < n; i++) {
		dp[i].resize(arr[i].size(), vector<ll>(n + 1, INF));
		dp2[i].resize(arr[i].size(), vector<ll>(n + 1, INF));
	}
	dfs1(0, 0, -1, arr, dp, dp2, c, t);
	dfs2(0, 0, -1, arr, dp, dp2, c, t);
	ll ans = INF;
	for (ll i = 0; i < n; i++) {
		ll mi = INF;
		for (ll j = t[i]; j >= 1; j--) {
			assign_min(mi, c[j]);
			ll now = mi;
			for (auto[to, rt] : arr[i]) {
				now += dp[to][rt][j - 1];
			}
			assign_min(ans, now);
		}
	}
	return (ans >= INF ? -1 : ans);
}

void d(ll v, ll p, vector<bool>& used, vector<vector<ll>>& arr, ll nd, ll md) {
        if (nd >= md) {
                return;
        }
        used[v] = true;
        for (auto i : arr[v]) {
                if (i != p) {
                        d(i, v, used, arr, nd + 1, md);
                }
        }
}

bool check(vector<ll>& t, vector<vector<ll>>& arr) {
        vector<bool> used(arr.size(), false);
        for (ll i = 0; i < arr.size(); i++) {
                d(i, i, used, arr, 0, t[i]);
        }
        for (auto i : used) {
                if (!i) {
                        return false;
                }
        }
        return true;
}

ll rec(vector<ll>& now, vector<ll>& c, vector<ll>& t, vector<vector<ll>>& arr) {
        if (now.size() == t.size()) {
                if (check(now, arr)) {
                        return 0;
                }
                return INF;
        }
        now.push_back(0);
        ll ans = INF;
        for (; now.back() < t[now.size() - 1]; now.back()++) {
                assign_min(ans, rec(now, c, t, arr) + c[now.back()]);
        }
        now.pop_back();
        return ans;
}

ll s(ll n, vector<ll> cc, vector<ll> tt, vector<pair<ll, ll>> all) {
        vector<ll> c(n + 1, 0), t(n);
        for (ll i = 1; i <= n; i++) {
                c[i] = cc[i - 1];
        }
        for (ll i = 0; i < n; i++) {
                t[i] = tt[i];
                t[i]++;
        }
        vector<vector<ll>> arr(n);
        for (auto[a, b] : all) {
                a--;
                b--;
                arr[a].push_back(b);
                arr[b].push_back(a);
        }
        vector<ll> now;
        ll ans = rec(now, c, t, arr);
       	return (ans == INF ? -1 : ans);
}


bool b = 1;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	if (b) {
		ll n;
		cin >> n;
		vector<ll> c(n), t(n);
		vector<pair<ll, ll>> arr;
		for (ll i = 0; i < n; i++) {
			cin >> c[i];
		}
		for (ll i = 0; i < n; i++) {
			cin >> t[i];
		}
		for (ll i = 1; i < n; i++) {
			ll a, b;
			cin >> a >> b;
			arr.emplace_back(a, b);
		}
		cout << solve(n, c, t, arr) << '\n';
		return 0;
	}
	ll col = 1;
	while (true) {
		ll n = 6;
		vector<ll> c(n), t(n);
        	for (ll i = 0; i < n; i++) {
        	        c[i] = rnd() % 100000;
        	}
        	for (ll i = 0; i < n; i++) {
        	        t[i] = rnd() % (n + 1);
        	}
		vector<pair<ll, ll>> all;
       		for (ll i = 1; i < n; i++) {
        	        all.emplace_back(rnd() % i + 1, i + 1);
	        }
		ll a1 = solve(n, c, t, all), a2 = s(n, c, t, all);
		if (a1 != a2) {
			cout << a1 << ' ' << a2 << '\n';
			cout << n << '\n';
			for (auto i : c) {
				cout << i << '\n';
			}
			for (auto i : t) {
				cout << i << '\n';
			}
			for (auto[a, b] : all) {
				cout << a << ' ' << b << '\n';
			}
			return 0;
		}
		cout << "OK " << col << endl;
		col++;
	}
}
