#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int ll
const int N = int(1e5) + 10;
int a[N];
vector<int> t[4 * N];

vector<int> Merge(vector<int> &a, vector<int> &b) {
    vector<int> c;
    int i = 0, j = 0;
    while (i < int(a.size()) || j < int(b.size())) {
        if (i == int(a.size())) {
            c.emplace_back(b[j++]);
        } else if (j == int(b.size())) {
            c.emplace_back(a[i++]);
        } else if (a[i] < b[j]) {
            c.emplace_back(a[i++]);
        } else {
            c.emplace_back(b[j++]);
        }
    }
    return c;
}

void build(int v, int l, int r){
    if(l == r){
        t[v].emplace_back(a[l]);
        return;
    }
    build(v * 2, l, (l + r) / 2);
    build(v * 2 + 1, (l + r) / 2 + 1, r);
    t[v] = Merge(t[v * 2], t[v * 2 + 1]);
}

int find(vector<int> &x, int y){
    int l = 0, r = int(x.size()) - 1;
    while(r - l > 1){
        int m = (l + r) / 2;
        if(x[m] <= y)
            l = m;
        else
            r = m;
    }
    if(x[r] <= y)
        return 0;
    if(x[l] <= y)
        return int(x.size()) - r;
    return int(x.size()) - l;
}

int get_K(int v, int l, int r, int tl, int tr, int val){
    if(l > tr || r < tl)
        return 0;
    if(tl <= l && r <= tr)
        return find(t[v], val);
    int mid = (l + r) / 2;
    return get_K(v * 2, l, mid, tl, tr, val) + get_K(v * 2 + 1, mid + 1, r, tl, tr, val);
}

int rich_num(int l, int r, int val) {
    return get_K(1, 0, N - 1, l, r, val);
}

signed main() {
    for(int i = 1; i < N; i++){
        int j = 2 * i;
        while(j < N)
            a[j] += i, j += i;
    }
    build(1, 0, N - 1);
    int n;
    cin >> n;
    while (n--) {
        int l, r, v;
        cin >> l >> r >> v;
        cout << rich_num(l, r, v) << "\n";
    }
    return 0;
}