#include<bits/stdc++.h>

#define int long long

using namespace std;

const int N = 2000;
int c[N], t[N];
vector<int> g[N];
vector<bool> irrigated;

void dfs(int v, int sz, int p, int a)
{
    if(sz < a)
        irrigated[v] = true;
    else return;
    for(int i : g[v])
        if(i != p)
            dfs(i, sz + 1, v, a);
}

void tdfs(int v, int p, vector<int> &a)
{
    a.push_back(t[v]);
    for(int i : g[v])
        if(i != p)
            tdfs(i, v, a);
}

int32_t main()
{
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> c[i];
    for(int i = 0; i < n; i++)
        cin >> t[i];
    for(int i = 0, u, v; i < n - 1; i++)
    {
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int ans = c[n - 1] * (n + 1);
    if(n <= 8)
    {
        for(int i0 = 0; i0 <= t[0]; i0++)
        for(int i1 = 0; i1 <= t[1]; i1++)
        for(int i2 = 0; i2 <= t[2]; i2++)
        for(int i3 = 0; i3 <= t[3]; i3++)
        for(int i4 = 0; i4 <= t[4]; i4++)
        for(int i5 = 0; i5 <= t[5]; i5++)
        for(int i6 = 0; i6 <= t[6]; i6++)
        for(int i7 = 0; i7 <= t[7]; i7++)
        {
            vector<int> a = {i0, i1, i2, i3, i4, i5, i6, i7};
            a.resize(n);
            irrigated.assign(n, false);
            int tc = 0;
            for(int i = 0; i < n; i++)
                if(a[i])
                    tc += c[a[i] - 1];
            for(int i = 0; i < n; i++)
                if(a[i])
                    dfs(i, 0, -1, a[i]);
            bool b = true;
            for(int i = 0; i < n; i++)
                if(!irrigated[i])
                    b = false;
            if(b)
                ans = min(ans, tc);
        }
    }
    else
    {
        int beg;
        vector<int> ap, as;
        for(int i = 0; i < n; i++)
            if(g[i].size() == 1)
                beg = i;
        tdfs(beg, -1, ap);
        as = ap; reverse(as.begin(), as.end());
        vector<int> dpp(n + 1, c[n - 1] * (n + 1)), dps(n + 1, c[n - 1] * (n + 1));
        dpp[0] = 0; dps[0] = 0;
        for(int op = 0; op < 2; op++)
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < ap[i]; j++)
            {
                int tl = i + 1 - j, tr = i + 1 + j;
                tl = max(tl, 1LL), tr = min(tr, n);
//                dpp[tr] = min(dpp[tr], mn + c[j]);
                for(int k = tl; k <= tr; k++)
                    for(int l = k; l <= tr; l++)
                        dpp[l] = min(dpp[l], dpp[k - 1] + c[j]);
            }
        }
        for(int op = 0; op < 2; op++)
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < as[i]; j++)
            {
                int tl = i + 1 - j, tr = i + 1 + j;
                tl = max(tl, 1LL), tr = min(tr, n);
//                dps[tr] = min(dps[tr], mn + c[j]);
                for(int k = tl; k <= tr; k++)
                    for(int l = k; l <= tr; l++)
                        dps[l] = min(dps[l], dps[k - 1] + c[j]);
            }
        }
        for(int i = 0; i <= n; i++)
            ans = min(ans, dpp[i] + dps[n - i]);
    }
    cout << (ans >= c[n - 1] * (n + 1) ? -1LL : ans);
    return 0;
}
/*
10
2 1 3 4 5 6 7 8 9 10
1 2 2 2 2 2 2 2 2 1
1 2
2 3
3 4
4 5
5 6
6 7
7 8
8 9
9 10
*/
