#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)x.size()
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2010;
const int OO = 1e18;

int n, c[N], t[N], ans;
vec<int> g[N], v;

bool check()
{
    vec<int> used(n + 1);
    int unused = n;
    for (int i = 1; i <= n; i++)
    {
        queue<int> q;
        vec<int> dist(n + 1, OO);
        dist[i] = 0;
        q.push(i);
        while (!q.empty())
        {
            int ve = q.front(); q.pop();
            if (dist[ve] >= v[i - 1]) continue;
            if (!used[ve]) unused--;
            if (unused == 0) return true;
            used[ve] = 1;
            for (int to : g[ve])
            {
                if (dist[ve] + 1 < dist[to])
                {
                    dist[to] = dist[ve] + 1;
                    q.push(to);
                }
            }
        }
    }
    return unused == 0;
}

void brute(int ready)
{
    if (ready == 8)
    {
        if (check())
        {
            int cur = 0;
            for (int i = 1; i <= n; i++) cur += c[v[i - 1]];
            ans = min(ans, cur);
        }
        return;
    }
    for (int cnt = 0; cnt <= 6; cnt++)
    {
        if (cnt > t[ready + 1]) break;
        v.pb(cnt);
        brute(ready + 1);
        v.pop_back();
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> c[i];
    for (int i = 1; i <= n; i++) cin >> t[i];
    for (int i = 1; i < n; i++)
    {
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }
    ans = OO;
    if (n <= 8)
    {
        for (int i = 1; i <= n; i++) if (t[i] == 8) ans = c[8];
        for (int i = 1; i <= n; i++)
        {
            if (t[i] == 7)
            {
                vec<int> used(n + 1);
                int unused = n;
                queue<int> q;
                vec<int> dist(n + 1, OO);
                dist[i] = 0;
                q.push(i);
                while (!q.empty())
                {
                    int ve = q.front(); q.pop();
                    if (dist[ve] >= v[i - 1]) continue;
                    if (!used[ve]) unused--;
                    used[ve] = 1;
                    for (int to : g[ve])
                    {
                        if (dist[ve] + 1 < dist[to])
                        {
                            dist[to] = dist[ve] + 1;
                            q.push(to);
                        }
                    }
                }
                assert(unused <= 1);
                if (unused == 0) ans = min(ans, c[7]);
                else
                {
                    ans = min(ans, c[7] + c[1]);
                }
            }
        }
        brute(0);
        cout << (ans == OO ? -1 : ans);
        return 0;
    }
    return 0;
}
