#include "coins.h"
#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++ i)
#define rf(i, a, b) for (int i = (a); i >= (b); -- i)
#define fe(x, a) for (auto& x : a)

#define fi first
#define se second

#define pb push_back

using namespace std;

using ll = long long;
queue <pair <pair <ll, ll>, bool>> q;

vector <int> a, b;

pair<int, int> count_heavy(int k) {
    ll n = 1;
    while (k --) n *= 2;
    q.push({{1, n}, 0});

    ll res = 0;
    ll pos = 0;

    while (!q.empty()) {
        ll l = q.front().fi.fi;
        ll r = q.front().fi.se;
        bool w = q.front().se;

        ll mid = (l + r) >> 1;

        q.pop();

        a.clear(); b.clear();
        fr (i, l, mid) a.pb (i - 1);
        fr (i, mid + 1, r) b.pb (i - 1);
        int wes = weigh(a, b);

        if (l + 1 == r) {
            if (wes == 0)  {
                res += w * 2;
                if (w) pos = l - 1;
            }

            if (wes == 1) {
                res += 1;
                pos = l - 1;
            }

            if (wes == -1) {
                res += 1;
                pos = r - 1;
            }
            continue;
        }

        if (wes == 0) {
            q.push ({{l, mid}, w});
            q.push ({{mid + 1, r}, w});
        } else if (wes == 1) {
            q.push({{l, mid}, 1});
            q.push({{mid + 1, r}, 0});
        } else {
            q.push({{l, mid}, 0});
            q.push({{mid + 1, r}, 1});
        }
    }

//    cout << "! " << res << " " << pos << endl;
    return {res, pos};
}
