#include "coins.h"
#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++ i)
#define rf(i, a, b) for (int i = (a); i >= (b); -- i)
#define fe(x, a) for (auto& x : a)

#define fi first
#define se second

#define pb push_back

using namespace std;

using ll = long long;
queue <pair <pair <ll, ll>, pair <int, bool>>> q;

vector <int> a, b;

const int N = 1e6 + 5;
int t[4*N];
int pos;
void dfs (int v, int tl, int tr, bool w) {
    if (tl == tr - 1) {
        a.clear(); b.clear();
        a.pb (tl - 1);
        b.pb (tr - 1);

        int wes = weigh(a, b);

        if (!wes) {t[v] = 2*w; if(w)pos = tl - 1;}
        else if (wes == 1) {
            t[v] = 1;

            pos = tl - 1;
        } else {
            t[v] = 1;

            pos = tr - 1;
        }


        return;
    }
//    cout << v << " " << tl << " " << tr << " " << w << endl;
    int tm = (tl + tr) >> 1;
    a.clear();
    b.clear();
    fr (i, tl, tm) a.pb (i - 1);
    fr (i, tm + 1, tr) b.pb (i - 1);
    int wes = weigh(a, b);

    if (!wes) {
        dfs (v << 1, tl, tm, w);
        dfs (v << 1 | 1, tm + 1, tr, w);
    } else if (wes == -1) {
        dfs (v << 1 | 1, tm + 1, tr, 1);
        dfs (v << 1, tl, tm, 0);
    } else {
        dfs (v << 1 | 1, tm + 1, tr, 0);
        dfs (v << 1, tl, tm, 1);
    }
        t[v] = t[v << 1 | 1] + t[v << 1];

}

void dfs1 (int l, int r) {
    if (l == r) {
        pos = l - 1;
        return;
    }
    int mid = (l + r) >> 1;
    a.clear(); b.clear();

    fr(i, l, mid) a.pb (i - 1);
    fr(i, mid + 1, r) b.pb (i - 1);

    int wes = weigh(a, b);

    if (wes == -1) dfs1 (mid + 1, r);
    else dfs1 (l, mid);
}


pair<int, int> count_heavy(int k) {
    ll n = 1;
    while (k --) n *= 2;

    if (k <= 5) {
        dfs (1, 1, n, 0);
        return {t[1], pos};
    } else {

    int res = 1;
//    dfs (1, n);
    fr (i, 0, n - 2) {
        a.clear(); b.clear();
        a.pb (i);
        b.pb (i + 1);

        int wes = weigh(a, b);
        if (wes == 1) {
            pos = i;
            break;
        }

        if (wes == -1) {
            pos = i + 1;
            break;
        }

    }

    b.clear();
    b.pb (pos);

        if (pos == n - 1) a.pb (pos - 1);
        else if (pos == 0) a.pb (pos + 1);
        else a.pb (pos + 1);

        int wes = weigh(a, b);

        res = 1;
        if (!wes) res = n - 1;

        return {res, pos};
    }
}
