#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++ i)
#define rf(i, a, b) for (int i = (a); i >= (b); -- i)
#define fe(x, a) for (auto& x : a)

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
const int N = 1e6 + 5;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define ook order_of_key
#define fbo find_by_order

oset <pair<int, int>> t[N];
int l, r, x;
int a[N];

void build (int v, int tl, int tr) {
    if (tl == tr) {
        t[v].insert ({a[tl], tl});
        return;
    }

    int tm = (tl + tr) >> 1;

    build (v << 1, tl, tm);
    build (v << 1 | 1, tm + 1, tr);

    fe (x, t[v << 1]) t[v].insert (x);
    fe (x, t[v << 1 | 1]) t[v].insert (x);
}

int get (int v, int tl, int tr, int l, int r, int x) {
    if (l > r) return 0;
    if (tl == l && tr == r) {
        int res = t[v].ook ({x, 1e9});
        return sz(t[v]) - res;
    }
    int tm = (tl + tr) >> 1;
    return get (v << 1, tl, tm, l, min (r, tm), x) +
        get (v << 1 | 1, tm + 1, tr, max (tm + 1, l), r, x);
}

int main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(0); cin.tie(0);
    int q;cin >> q;
    if (q <= 1000) {
        fr (i, 2, 10000) {
            int res = 1, sq = sqrt (i);
            fr (j, 2, sq) {
                if (i % j == 0) {
                    res += j;
                    res += (j != i / j) * (i / j);
                }
            }
            a[i] = res;
        }

        build (1, 1, 10000);

        while (q --) {
            cin >> l >> r >> x;
            cout << get (1, 1, 10000, 1, r, x)
            - get (1, 1, 10000, 1, l - 1, x) << endl;
        }
        return 0;
    }

    fr (i, 2, 10000) {
        int res = 1, sq = sqrt (i);
        rf (j, sq, 2) {
            if (i % j == 0) {
                res += j;
                res += (j != i / j) * (i / j);
                if (res >= 10) break;
            }
        }
        a[i] = res;
    }

    build (1, 1, 10000);

    while (q --) {
        cin >> l >> r >> x;
        cout << get (1, 1, 10000, 1, r, x)
        - get (1, 1, 10000, 1, l - 1, x) << endl;
    }

//    cout << "Hello world!" << endl;
    return 0;
}
