#include <iostream>
#include <vector>

#pragma GCC optimize ("O3")

#define fr(i, a, b) for (int i = (a); i <= (b); ++ i)
#define rf(i, a, b) for (int i = (a); i >= (b); -- i)
#define fe(x, a) for (auto& x : a)

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
const int N = 1e5 + 5;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define ook order_of_key
#define fbo find_by_order

vector <int> t[4*N];
int l, r, x;
int a[N];

void comb (int v) {
    int stn1 = 0;
    int stn2 = 0;
    while (stn1 != sz(t[v << 1]) || stn2 != sz(t[v << 1 | 1])) {
        if (stn1 == sz(t[v << 1])) t[v].pb (t[v << 1 | 1][stn2 ++]);
        else if (stn2 == sz(t[v << 1 | 1])) t[v].pb (t[v << 1][stn1 ++]);
        else if (t[v << 1][stn1] < t[v << 1 | 1][stn2]) t[v].pb (t[v << 1][stn1 ++]);
        else t[v].pb (t[v << 1 | 1][stn2 ++]);
    }
}


void build (int v, int tl, int tr) {
    if (tl == tr) {
        t[v].pb (a[tl]);
        return;
    }

    int tm = (tl + tr) >> 1;

    build (v << 1, tl, tm);
    build (v << 1 | 1, tm + 1, tr);
    comb (v);
}

int get (int v, int tl, int tr, int l, int r, int x) {
    if (l > r) return 0;

    if (t[v].back() <= x) return 0;

    if (tl == l && tr == r) {
        int res = upper_bound(all(t[v]), x) - t[v].begin();
        return sz(t[v]) - res;
    }
    int tm = (tl + tr) >> 1;

    return get (v << 1, tl, tm, l, min (r, tm), x) +
        get (v << 1 | 1, tm + 1, tr, max (tm + 1, l), r, x);
}

int pref[N];
int main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(0); cin.tie(0);



    int q;cin >> q;
        int res = 0;
        fr (i, 1, 100000) {
            for (int j = 2 * i; j <= 100000; j += i) a[j] += i, ++ res;
        }

        build (1, 1, 100000);

        while (q --) {
            cin >> l >> r >> x;
            cout << get (1, 1, 100000, 1, r, x)
                - get (1, 1, 100000, 1, l - 1, x) << '\n';

        }
        return 0;

//    cout << "Hello world!" << endl;
    return 0;
}
