#include <iostream>
#include <vector>

#pragma GCC optimaze ("O3")

using namespace std;
vector <int> t[262142];
int l, r, x, a[100000];
int stn1, stn2;

void comb (int v) {
    stn1 = 0, stn2 = 0;
    t[v].resize((int)t[v << 1].size() + (int)t[v << 1 | 1].size());
    int ind = 0;
    while (stn1 != t[v << 1].size() || stn2 != t[v << 1 | 1].size()) {
        if (stn1 == t[v << 1].size())t[v][ind ++ ] =t[v << 1 | 1][stn2 ++];
        else if (stn2 == t[v << 1 | 1].size()) t[v][ind ++ ] =t[v << 1][stn1 ++];
        else if (t[v << 1][stn1] < t[v << 1 | 1][stn2]) t[v][ind ++ ] =t[v << 1][stn1 ++];
        else t[v][ind ++ ] = t[v << 1 | 1][stn2 ++];
    }
}
void build (int v, int tl, int tr) {

    if (tl == tr) {
        if(a[tl] > 1) t[v].push_back (a[tl]);
        return;
    }

    int tm = (tl + tr) >> 1;

    build (v << 1, tl, tm);
    build (v << 1 | 1, tm + 1, tr);
    comb (v);
}

int get (int v, int tl, int tr, int l, int r, int x) {
    if (l > r) return 0;

    if (t[v].empty()) return 0;
    if (t[v].back() <= x) return 0;

    if (tl == l && tr == r) {
        int res = lower_bound(t[v].begin(), t[v].end(), x + 1) - t[v].begin();
        return (int)t[v].size() - res;
    }

    int tm = (tl + tr) >> 1;

    return get (v << 1, tl, tm, l, min (r, tm), x) +
        get (v << 1 | 1, tm + 1, tr, max (tm + 1, l), r, x);
}
int q;
int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    cin >> q;
    int i = 1;
    while (i ++ < 50000) {
        int j = 2 * i;
        while (j <= 100000) {
            a[j] += i;
            j += i;
        }
    }

    build (1, 1, 100000);
    ++ q;
    while (-- q) {
        cin >> l >> r >> x;
        -- x;
        cout << get (1, 1, 100000, 1, r, x)
            - get (1, 1, 100000, 1, l - 1, x) << '\n';
    }
}
