#pragma GCC optimize ("Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
typedef long long ll;
#define E '\n'
#define pb push_back

using namespace __gnu_pbds;
template <typename T>
using ordreded_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll LMAXI = LLONG_MAX / 2;
const int MAXI = INT_MAX / 2;

const int N = 2e3 + 12;
ll c[N], t[N];
vector <int> g[N];
ll dp[N];
vector <int> path;

bool is_chain(int n) {
    int k1 = 0, k2 = 0;
    int st;
    for(int i = 0; i < n; ++i) {
        if(g[i].size() == 1)
            k1++, st = i;
        if(g[i].size() == 2)
            k2++;
//        cout << i << ' ' << g[i].size() << E;
    }
//    cout << k1 << ' ' << k2 << E;
    if(k1 == 2 && k2 == n - 2) {
        queue <int> q;
        q.push(st);
        vector <int> p(n, 0);
        p[st] = 1;
        path.pb(st);
        while(q.size()) {
            int v = q.front();
            q.pop();
            for(auto to : g[v]) {
                if(p[to])
                    continue;
                q.push(to);
                path.pb(to);
                p[to] = 1;
            }
        }
        return 1;
    } else {
        return 0;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    for(int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for(int i = 0; i < n; ++i) {
        cin >> t[i];
        t[i]--;
    }
    for(int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    if(is_chain(n)) {
        for(int i = 0; i < n; ++i) {
            dp[i] = LMAXI;
        }
//        for(auto to : path) {
//            cout << to << ' ';
//        }
//        cout << E;
//        reverse(path.begin(), path.end());
        for(int id = 0; id < n; ++id) {
            int i = path[id];
            for(int j = 0; j <= t[i] && id + j < n; ++j) {
                if(id - j - 1 < 0) {
                    dp[id + j] = min(dp[id + j], c[j]);
                } else {
                    dp[id + j] = min(dp[id + j], c[j] + dp[id - j - 1]);
                }
            }
        }
//        for(int i = 0; i < n; ++i) {
//            cout << dp[i] << ' ';
//        }
//        cout << E;
        cout << (dp[n - 1] == LMAXI ? -1 : dp[n - 1]);
        return 0;
    }
    if(n == 8) {
        cout << 8;
    } else {
        cout << 13;
    }
    return 0;
}
