#include <bits/stdc++.h>

#define fi first
#define se second
//#define int int64_t
#define pb push_back
#define ll long long

using namespace std;
const int N = 4e4 + 50;
ll clc[N], f[N], ans[N], sz;

struct node {
    int l, r, x, id;
};

node v[N];

bool comp (node a, node b) {
    if(a.l / sz != b.l / sz) {
        return a.l < b.l;
    } else {
        return a.r < b.r;
    }
}

void add (int x) {
    while (x < N) {
        f[x]++;
        x = (x | (x + 1));
    }
}

void del (int x) {
    while (x < N) {
        f[x]--;
        x = (x | (x + 1));
    }
}

int get (int x) {
    int ans = 0;
    while (x >= 1) {
        ans += f[x];
        x = (x & (x + 1)) - 1;
    }
    return ans;
}

int get (int l, int r) {
    return get(r) - get(l - 1);
}


int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    for(int i = 1; i < N; ++i) {
        for(int j = i * 2; j < N; j += i) {
            clc[j] += i;
        }
    }
    int n = 1e5 + 1;
    sz = sqrt(n);
    int q;
    cin >> q;
    bool fl = 1;
    for(int i = 0; i < q; ++i) {
        cin >> v[i].l >> v[i].r >> v[i].x;
        if(v[i].l != 1) {
            fl = 0;
        }
        v[i].id = i;
    }
    sort(v, v + q, comp);
    int l = 0, r = -1;
    vector <int> ans(q, -1);
    for(int i = 0; i < q; ++i) {
        while (r < v[i].r) {
            ++r;
            add(clc[r]);
        }
        while (r > v[i].r) {
            del(clc[r]);
            --r;
        }
        while (l < v[i].l) {
            del(clc[l]);
            ++l;
        }
        while (l > v[i].l) {
            --l;
            add(clc[l]);
        }
        ans[v[i].id] = get(v[i].x + 1, N - 1);
    }
    for(auto to : ans) {
        cout << to << endl;
    }
    return 0;
}
