#include <bits/stdc++.h>

#pragma GCC optimize("-O3")

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())

using namespace std;

const int N = 1e4 + 5;

typedef long long ll;

int a[N], sum[N];
bool fl[N];
vector<int> t[4 * N];

void build(int v = 1, int tl = 1, int tr = N){
    if(tl == tr){
        t[v].pb(a[tl]);
        return;
    }

    int tm = (tl + tr) >> 1;

    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);

    merge(all(t[v << 1]), all(t[v << 1 | 1]), back_inserter(t[v]));
}

int get(int v, int tl, int tr, int l, int r, int x){
    if(l > r){
        return 0;
    }

    if(tl == l and tr == r){
        return sz(t[v]) - (upper_bound(all(t[v]), x) - t[v].begin());
    }

    int tm = (tl + tr) >> 1;

    return get(v << 1, tl, tm, l, min(tm, r), x) + get(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r, x);
}

int main()
{
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    for(int i = 1; i <= N; i++){
        for(int j = i + i; j <= N; j += i){
            a[j] += i;
        }
    }

    build();

    int q;

    cin >> q;

    while(q--){
        int l, r, x;

        cin >> l >> r >> x;

        cout << get(1, 1, N, l, r, x) << "\n";
    }

    return 0;
}
