// rich_num1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <iterator>

using namespace std;
using ll = long long;

struct q
{
	ll r;
	ll l;
	ll v;
	ll place;
};

struct place
{
	ll rich;
	ll num;
};

void add_rich_at(vector<place>& rich_at, ll n)
{
	if (n == 0) { rich_at[0].rich = 0; return; }

	for (int i = 2 * n; i < rich_at.size(); i += n)
	{
		rich_at[i].rich += n;
	}

}

int main()
{
	ll n;
	cin >> n;
	ll ans;
	ll start = n;
	ll max_r = 0;
	vector<q> all_q(n);

	for (int i = 0; i < all_q.size(); i++)
	{
		q temp;
		cin >> temp.l >> temp.r >> temp.v;
		temp.place = i;
		if (temp.r > max_r)
		{
			max_r = temp.r;
		}
		all_q[i] = temp;
	}
	vector<place> rich_at(max_r + 1);
	for (int i = 0; i < rich_at.size(); i++)
	{
		rich_at[i].num = i;
		add_rich_at(rich_at, i);
	}

	for (int i = 0; i < n; i++) 
	{
		ans = 0;
		for (int j = all_q[i].l; j <= all_q[i].r; j++)
		{
			if (rich_at[j].rich > all_q[i].v)
			{
				ans++;
			}
		}
		cout << ans << endl; 
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
