#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
using namespace std;

int n = 1e4 + 10;
int t = 1 << 14;

vector<int> merge(vector<int>& a, vector<int>& b) {
	vector<int> v(a.size() * 2);
	int i = 0, j = 0;
	a.push_back(INT32_MAX);
	b.push_back(INT32_MAX);
	for (int k = 0; k < 2 * (a.size() - 1); ++k) {
		if (a[i] < b[j]) {
			v[k] = a[i];
			i++;
		}
		else {
			v[k] = b[j];
			j++;
		}
	}
	a.pop_back();
	b.pop_back();
	return v;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	vector<int> P;
	for (int i = 2; i <= n; ++i) {
		bool lol = true;
		for (int j = 0; j < P.size(); ++j) {
			if (i % P[j] == 0) {
				lol = false; break;
			}
		}
		if (lol) P.push_back({ i });
	}
	
	vector<vector<int>> v(2 * t, vector<int>(1, 0));
	v[t][0] = 1;
	for (int i = 2; i < n; ++i) {
		v[i + t - 1][0] = 1;
		int j = i;
		int k = 0;
		bool lol = false;
		while (j != 1) {
			if (lol) {
				v[i + t - 1][0] *= (v[j + t - 1][0] + j);
				break;
			}
			if (j % P[k]) k++;
			else {
				lol = true;
				int p = 1;
				int g = P[k];
				while (j % g == 0) { 
					p += g;
					g *= P[k];
				}
				j *= P[k];
				j /= g;
				v[i + t - 1][0] *= p;
			}
		}
		v[i + t - 1][0] -= i;
	}
	
	/*for (int i = t; i < t + n - 1; ++i) {
		v[i] = { h[i - t + 1] };
	}*/

	for (int i = t - 1; i > 0; --i) {
		if (v[2 * i + 1].size()) v[i] = merge(v[2 * i], v[2 * i + 1]);
	}
	int Q; cin >> Q;
	while (Q--) {
		int l, r, x;
		cin >> l >> r >> x;
		int ans = 0;
		l += t - 1;
		r += t - 1;
		while (l <= r) {
			if (l & 1) {
				ans += v[l].size() - distance(v[l].begin(), upper_bound(v[l].begin(), v[l].end(), x));
				l++;
				l >>= 1;
			}
			else l >>= 1;
			if (r & 1) r >>= 1;
			else {
				ans += v[r].size() - distance(v[r].begin(), upper_bound(v[r].begin(), v[r].end(), x));
				r--;
				r >>= 1;
			}
			//cout << ans << ' ' << l << ' ' << r << '\n';
		}
		//if (l == r) ans += v[l].size() - distance(v[l].begin(), upper_bound(v[l].begin(), v[l].end(), x));
		cout << ans << '\n';
	}
}