#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vll vector<ll>
#define vvll vector<vll>

const ll maxN = 2001;

ll n;

ll c[maxN];
ll t[maxN];
vll graph[maxN];
ll dpT[maxN][maxN];
ll dpS[maxN][maxN];

void dp(ll node, ll par) {
    for (ll c : graph[node]) {
        if (c == par) continue;
        dp(c, node);
        for (ll v = 1; v <= n; v++) {
            dpT[node][v] += dpT[c][v-1];
        }
    }
    dpS[node][0] = 1e12;
    dpS[node][n+1] = 1e12;
    for (ll v = 1; v <= n; v++) {
        dpS[node][v] = 1e12;
        if (v <= t[node]) {
            ll cv = c[v] + dpT[node][v];
            dpS[node][v] = min(dpS[node][v], cv);
        }
        for (ll c : graph[node]) {
            if (c == par) continue;
            ll cv = dpT[node][v] + dpS[c][v+1] - dpT[c][v-1];
            dpS[node][v] = min(dpS[node][v], cv);
        }
    }
    // cout << node+1 << endl;
    // for (ll v = 0; v <= n; v++) cout << dpS[node][v] << ' ';
    // cout << endl;
    // for (ll v = 0; v <= n; v++) cout << dpT[node][v] << ' ';
    // cout << endl;
    for (ll i = n; i - 1 >= 0; i--) dpS[node][i-1] = min(dpS[node][i], dpS[node][i-1]);
    dpT[node][0] = dpS[node][0];
    for (ll i = 0; i + 1 <= n; i++) dpT[node][i+1] = min(dpT[node][i], dpT[node][i+1]);
    // for (ll v = 0; v <= n; v++) cout << dpS[node][v] << ' ';
    // cout << endl;
    // for (ll v = 0; v <= n; v++) cout << dpT[node][v] << ' ';
    // cout << endl;
}

int main() {
    cin >> n;
    for (ll i = 1; i <= n; i++) cin >> c[i];
    for (ll i = 0; i < n; i++) cin >> t[i];
    for (ll i = 0; i + 1 < n; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    dp(0, -1);
    ll a = dpT[0][0];
    if (a > 1e10) a = -1;
    cout << a << endl;
}