#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vll vector<ll>

const ll maxN = 1e5+2;
const ll maxD = 304921;

struct SEG {
    vll arr;
    ll sz;

    void make(ll n) {
        for (sz = 1; sz < n; sz <<= 1);
        arr.resize(sz*2);
    }

    void add(ll ind, ll val) {
        ind += sz;
        arr[ind] += val;
        while(ind>>=1)arr[ind]=arr[ind*2]+arr[ind*2+1];
    }

    ll sum(ll l, ll r) {
        l += sz, r += sz;
        ll a = 0;
        while (l <= r) {
            if (l % 2 == 1) a += arr[l++];
            if (r % 2 == 0) a += arr[r--];
            l>>=1, r>>=1;
        }
        return a;
    }
};

ll dsum[maxN];
vll queries[maxN];

int main() {
    SEG seg;
    seg.make(maxD);
    for (ll i = 1; i < maxN; i++) {
        for (ll j = 2 * i; j < maxN; j += i) dsum[j] += i;
    }
    // for (ll i = 12; i <= 20; i++) {
    //     cout << i << ' ' << dsum[i] << endl;
    // }
    // cout << max_element(begin(dsum), end(dsum)) - begin(dsum) << endl;
    // cout << *max_element(begin(dsum), end(dsum)) << endl;
    ll q;
    cin >> q;
    vll ans(q);
    vll V(q);
    for (ll i = 0; i < q; i++) {
        ll l, r, v;
        cin >> l >> r >> v;
        V[i] = v;
        queries[l-1].push_back(-(i+1));
        queries[r].push_back(i+1);
    }
    for (ll i = 2; i < maxN; i++) {
        seg.add(dsum[i], 1);
        for (ll qu : queries[i]) {
            if (qu > 0) {
                ans[qu-1] += seg.sum(V[qu-1]+1, maxD-1);
            } else {
                ans[-qu-1] -= seg.sum(V[-qu-1]+1, maxD-1);
            }
        }
    }
    for (ll v : ans) cout << v << '\n';
}