#include <iostream>
#include <vector>
#include "coins.h"
using namespace std;


int weigh(const vector<int> &a, const vector<int> &b);

int fh(int a, int b){
    if (a==b) return a;
    vector<int> fi((b-a+1)/2, 0);
    vector<int> si((b-a+1)/2, 0);
    for (int i=a; i<(b+a+1)/2; i++) fi[i-a] = i;
    for (int i=(b+a+1)/2; i<=b; i++) si[i-(b+a+1)/2] = i;
    int r = weigh(fi, si);
    if (r==1){
        return fh(a, (b+a+1)/2-1);
    } else {
        return fh((b+a+1)/2, b);
    }
}


pair<int, int> count_heavy(int k){
    int it = 0;
    int a;
    int b;
    int r;
    int s;
    vector<int> p((int)(1<<k), 0);
    while (it<k){
        vector<int> n(p.size()/2);
        for (int i=0; i<p.size(); i+=2){
            a = p[i]; b = p[i+1];
            if (a>0 && b>0) n[i/2] = a+b;
            else {
                s = (int)(1<<it);
                vector<int> fi(s, 0);
                vector<int> si(s, 0);
                for (int j = s * i; j< s*(i+1); j++) fi[j-s*i] = j;
                for (int j = s * (i+1); j< s*(i+2); j++) si[j-s*(i+1)] = j;

                if (a==0 && b==0){
                    r = weigh(fi,si);
                    if (r==0) n[i/2] = 0;
                    else n[i/2] = (int)(1<<it);
                } else if (a==0){
                    r = weigh(fi,si);
                    if (r==1) n[i/2] = (int)(1<<it) + b;
                    else n[i/2] = b;
                } else if (b==0){
                    r = weigh(fi,si);
                    if (r==-1) n[i/2] = (int)(1<<it) + a;
                    else n[i/2] = a;
                }
            }
        }
        p = n;
        it++;
    }
    int heavy = fh(0, (int)(1<<k)-1);
    pair<int, int> ans;
    ans.first = p[0];
    ans.second = heavy;
    return ans;
}


