#include <iostream>
#include <unordered_map>
using namespace std;

int bin_exp(int a, int b){
    int res = 1;
    while (b){
        if (b&1) res*=a;
        a*=a;
        b>>=1;
    }
    return res;
}

bool sod(int n, int v){
    int res = 1;
    unordered_map<int, int> prf;
    int k = n;
    for (int i=2; i*i<=k; i++){
        while (k%i == 0){
            prf[i]++;
            k/=i;
        }
    }
    if (k>1) prf[k] ++;
    for (auto [p,a] : prf){
        res*= (bin_exp(p,a+1)-1)/(p-1);
        if (res-n>v) return 1;
    }
    return res - n > v;
}

int main(){
    int t;
    cin>>t;
    while(t--){
        int l, r, v;
        cin>>l>>r>>v;

        int res = 0;
        for (int i=l; i<=r; i++){
            if (sod(i, v)) res++;
        }
        cout<<res<<'\n';
    }

    return 0;
}
