#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    const int MAXN = 1e3;

    vector<int> sieve(MAXN + 1, 1);

    sieve[1] = 0;
    for(int i = 2; i <= MAXN; i++) {
        for(int j = i + i; j <= MAXN; j += i) {
            sieve[j] += i;
        }
    }

    int q;
    cin >> q;

    while(q--) {
        int l, r, v;
        cin >> l >> r >> v;
        int cnt = 0;
        for(int i = l; i <= r; i++) {
            //cout << i << ' ' << sieve[i] << '\n';
            if(sieve[i] > v) {
                cnt++;
            }
        }
        cout << cnt << '\n';
    }

    return 0;
}
