#include<iostream>
#include<vector>

using namespace std;

const int N = 10;
int c[N] , t[N], vis[N];
vector<int> G[N];
int ans = 2e9;
int mark = 0;

void dfs(int s, int e , int curr = 1)
{
  if(vis[s]==mark or curr>e)
    return;
  vis[s] = mark;
  for(int i:G[s])
    dfs(i,e,curr+1);
}
int n;

void find_cost(vector<int> & v, int i = 0)
{
  //cerr << i << endl;
  if(i>=v.size())
    {
      int cost = 0;
      for(int i:v)
	cost+=c[t[i]];
      bool ok = true;
      
      mark++;
      for(int i:v)
	dfs(i,t[i]);
      for(int i=1;i<=n;i++)
	  ok&=(vis[i]==mark);
      
      if(ok)
	ans = min(ans,cost);
      return;
    }
  int x = t[v[i]];
  for(int j=1;j<=x;j++)
    {
      t[v[i]] = j;
      find_cost(v,i+1);
    }
}

int main()
{
  cin>>n;
  for(int i=1;i<=n;i++)
    cin>>c[i];
  for(int i=1;i<=n;i++)
    cin>>t[i];
  for(int i=1;i<n;i++)
    {
      int u, v;
      cin>>u>>v;
      G[u].push_back(v);
      G[v].push_back(u);
    }
  for(int mask=1;mask<(1<<n);mask++)
    {
      vector<int> v;
      for(int i=0;i<n;i++)
	if(mask&(1<<i))
	  {
	    if(t[i+1]==0) break;
	    else
	      v.push_back(i+1);
	  }
      if(v.size()!=__builtin_popcount(mask))
	continue;
      find_cost(v);
      // cost = min(cost , find_costs(v));
    }
  cout << ans << endl;
  return 0;
}
