/*********************ALLAH HO AKBAR***********************/
/************HAZRAT MUHAMMAD (Peace be upon him)***********/
#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <sstream>
#include <numeric>
#include <cstdio>
#include <bitset>
using namespace std;
int const N=1e4+5;
int dsum[N];
int prefix_sum[12][N];
int div_sum(int n){
    int ans=0;
    for (int i = 1; i < n; ++i)
        if(n%i==0)
            ans+=i;
    return ans;
}
void solve(){
    int n;
    cin>>n;
    set<int> s;
    for (int i = 0; i < 100; ++i)
        dsum[i]=min(11,div_sum(i));
    for (int i = 2; i <=10000; ++i)
        s.insert(i);
    while(s.size()){
        vector<int> r;
        int x=*s.begin();
        for(int i:s)
            if(i%x==0)
                r.push_back(i);
        for(int i:r){
            s.erase(i);
            if(i>=100)
                dsum[i]=11;
        }
        dsum[x]=1;
    }
    for (int i = 1; i <=10000; ++i)
        prefix_sum[dsum[i]][i]=1;
    for (int v = 1; v < 12; ++v)
        for (int i = 1; i <=10000; ++i)
            prefix_sum[v][i]+=prefix_sum[v][i-1];
    // for (int v = 1; v < 15; ++v){
    //     for (int i = 1; i <=20; ++i)
    //         cout<<prefix_sum[v][i]<<' ';
    //     cout<<endl;
    // }
    while(n--){
        int l,r,v;
        cin>>l>>r>>v;
        int ans=0;
        for (int level = v+1; level < 12; ++level)
            ans+=prefix_sum[level][r]-prefix_sum[level][l-1];
        cout<<ans<<endl;
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    int t=1;
    // cin>>t;
    while(t--)
        solve();
    return 0;
}