#include<iostream>
#include<cmath>
#include<vector>
using namespace std;
#define pb push_back
int q;
const int N = 1e5+43;
int dp[N];
int vis[N];
vector<int>tree[3*N];
int upper(int x,vector<int>arr)
{
   int l = -1 ,r= arr.size();
  while(r-l>=1)
  {
    int mid = l+(r-l)/2;
    if(arr[mid]<=x)
      l=mid+1;
    else
      r=mid;
  }
  return max(r,0);
}
void find_sum()
{

  for(int i = 2 ;i<N;i++)
  {
    if(!vis[i])
    {

      for(int j = i*2;j<N;j+=i)
      {
        vis[j]=1;
        long long T= 1 ;
        int cnt= 0 ;
        int k  = j;
        while(k%i==0)
        {
          k/=i;
          cnt++;
        }
        T=(long long)(pow(i,cnt+1)-1)/(i-1);

        dp[j] = (long long)dp[j]*T;
   
      }
    }
    else
      dp[i]-=i;
  
  }
}

int check(int node,int l1,int r1 , int l2,int r2,int num)
{

  // cntt++;
  if(l1==l2 and r1==r2)
  {
    auto m = upper(num,tree[node]);
    return tree[node].size() - m;
  }

  int mid = l1+((r1-l1)/2);

  if(mid<l2)
    return check(node*2+2,mid+1,r1,l2,r2,num);

  else if(mid>=r2)
    return check(node*2+1,l1,mid,l2,r2,num);

  else
    return check(node*2+2,mid+1,r1,mid+1,r2,num) + check(node*2+1,l1,mid,l2,mid,num);


}
vector<int> built(int index, int l,int r)
{
  if(l==r)
  {
    tree[index]={dp[r]};
    return tree[index];
  }
  int mid = l+(r-l)/2;

  vector<int>arr;

  vector<int>A = built(index*2+1,l,mid) , B = built(index*2+2,mid+1,r);

  int po = 0,po2 =0;

  while(1)
  {
    if(po<A.size() and (po2<B.size()))
    {
      if(A[po]<B[po2])
      {
        arr.pb(A[po]);
        po++;
      }
      else
        arr.pb(B[po2++]);
    }
    else if(po2<B.size())
    {
      arr.pb(B[po2++]);
    }
    else if(po<A.size())
    {
      arr.pb(A[po++]);
    }
    else
      break;
  }
  tree[index]=arr;
   return arr;
}
int main()
{
  // cout<<upper(0,3,,{1,2,4});
  fill(dp,dp+N,1);
  int n;

  scanf("%d",&q);

  find_sum();


  built(0,1,N-1);


  while(q--)
  {
    int l,r,x;
scanf("%d %d %d",&l,&r,&x);
printf("%d\n", check(0,1,N-1,l,r,x));
  
  }

  return 0;
}