#ifndef COINS_H_INCLUDED

#include <vector>
#include <bits/stdc++.h>

int weigh(const std::vector<int> &a, const std::vector<int> &b);

std::pair < int, int > go_down_and_hope_for_the_best ( int st, int dr );

int perm[( 1 << 20)];
std::pair<int, int> count_heavy ( int k ) {
    if ( k == 1 ) {
        if ( weigh ( {0}, {1} ) == 1 )
            return { 1, 0 };
        return { 1, 1 };
    }

    for ( int i = 0; i < ( 1 << k ); i++ )
        perm[i] = i;

///    srand( time ( 0 ) );
///    std::random_shuffle ( perm, perm + ( 1 << k ) );

    return go_down_and_hope_for_the_best ( 0, ( 1 << k ) - 1 );
}

std::vector < int > f ( int st, int dr ) {
    std::vector < int > v ( dr - st + 1 );
    for ( int i = st; i <= dr; i++ )
        v[i - st] = perm[i];
    return v;
}

int get_heavy ( int st, int dr ) {
    if ( st == dr )
        return st;
    else {
        int mij = ( st + dr ) / 2, rez = weigh ( f ( st, mij ), f ( mij + 1, dr ) );
        if ( rez >= 0 )
            return get_heavy ( st, mij );
        else
            return get_heavy ( mij + 1, dr );
    }
}

int get_light ( int st, int dr ) {
    if ( st == dr )
        return st;
    else {
        int mij = ( st + dr ) / 2, rez = weigh ( f ( st, mij ), f ( mij + 1, dr ) );
        if ( rez <= 0 )
            return get_light ( st, mij );
        else
            return get_light ( mij + 1, dr );
    }
}

std::pair < int, int > go_down_and_hope_for_the_best ( int st, int dr ) {
    if ( st + 1 == dr ) {
        int rez = weigh ( { st }, { dr } );
        if ( rez == 0 )
            return { 0, 0 };
        else if ( rez == 1 )
            return { 1, perm[st] };
        else return { 1, perm[dr] };
    }
    std::vector < int > a, b;
    int mij = ( st + dr ) / 2;
    a = f ( st, mij );
    b = f ( mij + 1, dr );
    sort ( a.begin (), a.end () );
    sort ( b.begin (), b.end () );
    int rez = weigh ( a, b );
    if ( rez == 0 ) {
        std::pair < int, int > x = go_down_and_hope_for_the_best ( st, mij );
        return { 2 * x.first, x.second };
    } else if ( rez == 1 ) {
        int elem, elem2, cnt = 0;
        do {
            cnt++;
            elem = get_heavy ( st, mij );
            elem2 = get_light ( mij + 1, dr );
            a.erase ( lower_bound ( a.begin (), a.end (), elem  ) );
            b.erase ( lower_bound ( b.begin (), b.end (), elem2 ) );
        } while ( weigh ( a, b ) == 1 );
        std::pair < int, int > x = go_down_and_hope_for_the_best ( mij + 1, dr );
        return { cnt + 2 * x.first, elem };
    } else {
        int elem, elem2, cnt = 0;
        do {
            cnt++;
            elem = get_heavy ( mij + 1, dr );
            elem2 = get_light ( st, mij );
            b.erase ( lower_bound ( b.begin (), b.end (), elem  ) );
            a.erase ( lower_bound ( a.begin (), a.end (), elem2 ) );
        } while ( weigh ( a, b ) == -1 );
        std::pair < int, int > x = go_down_and_hope_for_the_best ( st, mij );
        return { cnt + 2 * x.first, elem };
    }
}

#define COINS_H_INCUDED
#endif // COINS_H_INCLUDED