#include <iostream>
#include <vector>
using namespace std;
const int nmax = 2e3;
const int oo = 1e9;

vector < int > g[nmax + 1];
int c[nmax + 1];
int t[nmax + 1];


int dp[nmax + 1];
int a[nmax + 1];

int main() {
    ios_base::sync_with_stdio ( false );
    cin.tie ( 0 );
    cout.tie ( 0 );

    int n, x, y;
    cin >> n;
    /// the graph is a chain
    for ( int i = 1; i <= n; i++ )
        cin >> c[i];

    for ( int i = 1; i <= n; i++ )
        cin >> t[i];

    for ( int i = 1; i < n; i++ ) {
        cin >> x >> y;
        g[x].push_back ( y );
        g[y].push_back ( x );
    }
    int i = 1;
    while ( i <= n && g[i].size () == 2 )
        i++;

    a[1] = i;
    a[2] = g[i][0];
    for ( int i = 3; i <= n; i++ )
        a[i] = g[a[i - 1]][0] + g[a[i - 1]][1] - a[i - 2];

    for ( int i = 1; i <= n; i++ )
        dp[i] = oo;

    dp[0] = 0;
    for ( int i = 1; i <= n; i++ )
        for ( int j = 1; j <= t[a[i]] && i >= j && i + j - 1 <= n; j++ )
            if ( dp[i + j - 1] > dp[i - j] + c[j] )
                dp[i + j - 1] = dp[i - j] + c[j];

    if ( dp[n] == oo )
        cout << -1;
    else
        cout << dp[n];

    return 0;
}
