#include <bits/stdc++.h>
#define ll long long
#define pii pair <int, int>
#define x first
#define y second
#pragma GCC optimize("Ofast")

using namespace std;

int q, sum[100005], ind[100005], ans[100005], val[100005];
pii aux[100005];
vector<int> pos[100005];

struct Query {
    int l, r;
    int x;
    int id;

    bool operator < (const Query &b) {
        return x < b.x;
    }
};

Query queries[100005];

int cnt;

void norm() {
    for (int i = 1; i <= 100000; i++) {
        aux[i] = {sum[i], i};
    }
    sort(aux + 1, aux + 100000 + 1);

    cnt = 1;
    ind[aux[1].second] = 1;
    for (int i = 2; i <= 100000; i++) {
        if (aux[i].first != aux[i - 1].first)
            cnt++;

        ind[aux[i].second] = cnt;
    }
    for (int i = 1; i <= 100000; i++)
        val[ind[i]] = sum[i];
}

int aint[4 * 100005];

void update(int nod, int tl, int tr, int pos) {
    if (tl == tr) {
        aint[nod] = 1;
        return;
    }

    int mid = (tl + tr) / 2;
    if (pos <= mid)
        update(2 * nod, tl, mid, pos);
    else
        update(2 * nod + 1, mid + 1, tr, pos);
    aint[nod] = aint[2 * nod] + aint[2 * nod + 1];
}

int query(int nod, int tl, int tr, int p, int q) {
    if (p > q)
        return 0;
    else if (p <= tl && tr <= q)
        return aint[nod];

    int mid = (tl + tr) / 2;
    return query(2 * nod, tl, mid, p, min(mid, q)) + query(2 * nod + 1, mid + 1, tr, max(p, mid + 1), q);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    for (int i = 1; i * i <= 100000; i++) {
        for (int j = 2 * i; j <= 100000; j += i) {
            sum[j] += i;
        }
    }
    norm();

    for (int i = 1; i <= 100000; i++)
        pos[ind[i]].push_back(i);

    cin >> q;
    for (int i = 1; i <= q; i++) {
        int l, r, x;
        cin >> l >> r >> x;
        queries[i] = {l, r, x, i};
    }
    sort(queries + 1, queries + q + 1);

    int j = q;
    for (int i = cnt; i >= 1; i--) {
        while (j >= 1 && queries[j].x >= val[i])
            ans[queries[j].id] = query(1, 1, 100000, queries[j].l, queries[j].r), j--;

        for (auto& it : pos[i])
            update(1, 1, 100000, it);
    }

    for (int i = 1; i <= q; i++)
        cout << ans[i] << "\n";

    return 0;
}
