#include <iostream>
using namespace std;
const int nmax=1e5,vmax=10;
long long aib[nmax+1][vmax+1],cr[nmax+1],maxx=0;
int lsb(int x) {
    return  x&(-x);
}
void update(int x,int y) {
    for(; x<=nmax; x+=lsb(x))
        aib[x][y]++;
}
int queryPref(int r,int v) {
    int S=0,s,rq;
    for(int i=0; i<=v; i++) {
        rq=r;
        s=0;
        for(; rq>0; rq-=lsb(rq))
            s+=aib[rq][i];
        S+=s;
    }
    return S;
}
int query(int l,int r,int v) {
    if(l==1)
        return queryPref(r,v);
    return queryPref(r,v)-queryPref(l-1,v);
}
void ciur() {
    for(int i=2; i*i<=nmax; i++) {
        for(int j=i*i; j<=nmax; j+=i) {
            cr[j]+=i;
            if(i*i!=j)
                cr[j]+=j/i;
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ciur();
    int q,l,r,v,c;
    cin>>q;
    if(q<=1000) {
        //subtask 1
        for(int i=1; i<=q; i++) {
            cin>>l>>r>>v;
            v-=1;
            c=0;
            for(int j=l; j<=r; j++) {
                if(cr[j]>v)
                    c++;
            }
            cout<<c<<'\n';
        }
    } else {
        if(q<=1e5) {
            for(int i=2; i<=nmax; i++)
                if(cr[i]<=10)
                    update(i,cr[i]);
            for(int i=1; i<=q; i++) {
                cin>>l>>r>>v;
                v-=1;
                cout<<(r-l+1)-1<<'\n';
            }
        }
    }
    return 0;
}
