#include <iostream>
#include <vector>
#include <map>
#define MAX 100002
using namespace std;
int q,l,r,v,a,b,c,d;
bool ciur[MAX];
vector<int> prime;
map<int, int> div; /// div[i] = suma divizorilor lui i
/// bucati de 2000
int div1[] = {1, 1};
int div2[] = {1, 1};
int div3[] = {2, 1,4};
int div4[] = {3, 1,4,9};
int div5[] = {3, 1,4,9};
int div6[] = {5, 1,4,6,9,25};
int div7[] = {6, 1,4,6,8,9,25};
int div8[] = {8, 1,4,6,8,9,10,25,49};
int div9[] = {9, 1,4,6,8,9,10,15,25,49};
int div10[] = {10, 1,4,6,8,9,10,14,15,25,49};

int nrdiv(int x){
    if(div.count(x) == 1){
        return div[x];
    }
    /// fac cu ciur dupa
    int ans = 0;
    //cout << x << " = ";
    for(int i = 1; i < x; i++){
        if(x%i == 0){
            //cout << i << " + ";
            ans += i;
        }
    }
    //cout << "\n";
    div[x] = ans;
    return ans;
}

int lgpow(int n, int a){
    if(a == 0){
        return 1;
    }else{
        if(a%2 == 0){
            int val = lgpow(n, a/2);
            return val*val;
        }else{
            return n*lgpow(n, a-1);
        }
    }
}

int sdiv(int x){
    int ans = 1;
    int ind = 0;
    int cx = x;
    //cout << x << " = ";
    while(x > 1 && ind < prime.size()){
        if(x%prime[ind] == 0){
            int d = 0;
            while(x%prime[ind] == 0){
                x /= prime[ind];
                d++;
            }
            ans *= (lgpow(prime[ind], d+a)+b)/(lgpow(prime[ind], d+c)+d);
            //cout << prime[ind] << "^" << d << " * ";
            //cout << (lgpow(prime[ind], d+1)-1.0)/(lgpow(prime[ind], d-1)) << " * ";
        }
        ind++;
    }
    //cout << "\n";
    //cout << "ans = " << ans << "\n";
    return ans-cx;
}

int cteprim(int x){
    /// 1 1 1 1 1 0 0 0 0
    ///
    /// x >= p
    int st = 0, dr = prime.size()-1;
    int ans = 0;
    while(st <= dr){
        int mid = (st+dr)/2;
        if(x >= prime[mid]){
            ans = mid;
            st = mid+1;
        }else{
            dr = mid-1;
        }
    }
    return ans;
}

int cteprim(int st, int dr){
    if(st <= dr)
        return cteprim(dr)-cteprim(st-1);
    else
        return 0;
}

int brut(int l, int r, int v){
    int cnt = 0;
    for(int i = l; i <= r; i++){
        if(nrdiv(i) > v){
            cnt++;
        }
    }
    return cnt;
}

int getint(int pos, int v){
    if(v == 1){
        return div1[pos];
    }else if(v == 2){
        return div2[pos];
    }else if(v == 3){
        return div3[pos];
    }else if(v == 4){
        return div4[pos];
    }else if(v == 5){
        return div5[pos];
    }else if(v == 6){
        return div6[pos];
    }else if(v == 7){
        return div7[pos];
    }else if(v == 8){
        return div8[pos];
    }else if(v == 9){
        return div9[pos];
    }else if(v == 10){
        return div10[pos];
    }
}

int setint(int pos, int v, int val){
    if(v == 1){
        div1[pos] = val;
    }else if(v == 2){
        div2[pos] = val;
    }else if(v == 3){
        div3[pos] = val;
    }else if(v == 4){
        div4[pos] = val;
    }else if(v == 5){
        div5[pos] = val;
    }else if(v == 6){
        div6[pos] = val;
    }else if(v == 7){
        div7[pos] = val;
    }else if(v == 8){
        div8[pos] = val;
    }else if(v == 9){
        div9[pos] = val;
    }else if(v == 10){
        div10[pos] = val;
    }
}

int getint(int st, int dr, int v){
    return getint(dr, v)-getint(st-1, v);
}

int primul(int l, int r){
    int ans = -1;
    /// prima bucata care intra in [l, r]
    /// 0 0 0 0 0 1 1 1 1
    ///           ^
    /// capat bucata stanga >= l
    int st = 1, dr = 50;
    while(st <= dr){
        int mid = (st+dr)/2;
        int capat = (mid-1)*2000+1;
        if(capat >= l){
            ans = mid;
            dr = mid-1;
        }else{
            st = mid+1;
        }
    }
    return ans;
}

int ultimul(int l, int r){
    int ans = -1;
    int st = 1, dr = 50;
    /// ultima bucata care in [l, r]
    /// 1 1 1 1 1 0 0 0 0
    ///         ^
    /// capat drept <= r
    while(st <= dr){
        int mid = (st+dr)/2;
        int capat = mid*2000;
        if(capat <= r){
            ans = mid;
            st = mid+1;
        }else{
            dr = mid-1;
        }
    }
    return ans;
}

int query(int l, int r, int v){
    /// sdiv(x) > v
    /// daca x >= v
    ///   si x nu e prim
    /// v <= 10
    if(v <= 10){
        /// ans = len - cate nr sunt prime in secvente - cate elemente spurcate sunt in [l, r]
        int len = r-l+1;
        int ans = len-cteprim(l, r);
        for(int i = 1; i <= getint(0, v); i++){
            int val = getint(i, v);
            if(l <= val && val <= r){
                ans--;
            }
        }
        return ans;
    }else{
        return brut(l, r, v);
    }
}

bool eprim(int x){
    int st = 0, dr = prime.size()-1;
    while(st <= dr){
        int mid = (st+dr)/2;
        if(prime[mid] == x){
            return true;
        }
        if(prime[mid] > x){
            dr = mid-1;
        }
        if(prime[mid] < x){
            st = mid+1;
        }
    }
    return false;
}

int main()
{
    for(int i = 2; i < MAX; i++){
        if(ciur[i] == 0){
            prime.push_back(i);
            for(int j = i+i; j < MAX; j += i){
                ciur[j] = 1;
            }
        }
    }
    /*for(int k = 0; k < 10; k++){
        for(int i = 1; i < 49; i++){
            setint(i, k, getint(i, k)+getint(i-1, k) );
            //if(k == 1)
            //    cout << getint(i, k) << "\n";
        }
    }*/
    /*for(int k = 1; k <= 10; k++){
        cout << "int div" << k << "[] = {";
        for(int i = 1; i <= 1000; i++){
            if(nrdiv(i) <= k && !eprim(i)){
                cout << i << ",";
            }
        }
        cout << "}\n";
    }*/
    cin >> q;
    while(q--){
        cin >> l >> r >> v;
        int tmp = query(l, r, v);
        cout << tmp << "\n";
    }
    return 0;
}
/**
1
100000
345 12314 4

**/
