#include <iostream>
#include <tuple>
#include <vector>

#define all(x) (x).begin(),(x).end() 

using namespace std;

using ll = long long;
#define sz(x) (int)(x).size()

using pii = pair<int,int>;
using tii = tuple<int,int,int>;
using tiii = tuple<int,int,int,int>;

const int nmax = 1e5 + 5, vmax = 304920 + 5;

int sum[nmax];

#define lsb(x) (x & -x)
namespace AIB {
	int tree[nmax];
	int len = nmax - 1;
	void upd(int a, int b) {
		a++;
		while(a	<= len)
			tree[a] += b, a += lsb(a);
		return;
	}
	int query(int a) {
		a++;
		int sum = 0;
		while(a > 0)
			sum += tree[a], a -= lsb(a);
		return sum;
	}
};

int rez[nmax];

int freq[nmax];
tii ps[nmax * 2];

signed main() {
	cin.tie(0) -> sync_with_stdio(0);
	for(int i = 1; i < nmax; i++) {
		for(int j = i * 2; j < nmax; j += i)
			sum[j] += i;
	}
	
	int q;
	cin >> q;
	vector<tiii> qs(q);
	int mn = nmax, mx = -1;
	for(int i = 0, l, r, v; i < q; i++) {
		cin >> l >> r >> v;
		l--;
		freq[l]++;
		freq[r]++;
		qs[i] = tiii{l, r, v, i + 1};
	}
	for(int i = 1; i < nmax; i++)
		freq[i] += freq[i - 1];
	for(int i = nmax - 1; i > 0; i--)
		freq[i] = freq[i - 1];
	freq[0] = 0;
	for(auto [l, r, v, i] : qs)
		ps[freq[l]++] = tii{v, l, -i},
		ps[freq[r]++] = tii{v, r, i};
	int b = 0;
	for(int pt = 0; pt < 2 * q; pt++) {
		auto [v, lim, i] = ps[pt];
		int sm = (i < 0? -1 : 1);
		i = abs(i) - 1;
		while(b < lim)
			// cerr << "+ " << sum[b + 1] << '\n',
			AIB::upd(sum[++b], 1);
		// cerr << lim << ' ' << v << '\n';
		rez[i] += sm * (b - AIB::query(v));
	}
	
	for(int i = 0; i < q; i++) 
		cout << rez[i] << '\n';
}
