#include <bits/stdc++.h>

using namespace std;

int mymin(int a, int b)
{
    return (a<b?a:b);
}

int mymax(int a, int b)
{
    return(a>b?a:b);
}

const int NMAX = 2005;

int timp[NMAX];
int cost[NMAX];
int n;

int dp[NMAX][NMAX];

vector<int> g[NMAX];

vector<int> lant;

void dfs(int nod, int dad)
{
    lant.push_back(nod);
    for(auto it:g[nod])
        if(it!=dad)
            dfs(it,nod);
}
int pref[NMAX][NMAX];
int suf[NMAX];


const int INF = 2e9 + 1;

void solve()
{
    cin>>n;
    for(int i=1;i<=n;i++)
        cin>>cost[i];
    for(int i=1;i<=n;i++)
        cin>>timp[i];
    for(int i=1;i<n;i++)
    {
        int u,v;
        cin>>u>>v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int root;
    for(int i=1;i<=n;i++)
        if(g[i].size()==1)
            root=i;
    lant.push_back(0);
    dfs(root,0);
    dp[0][0]=0;
    for(int i=1;i<=n+1;i++)
        dp[0][i]=-1;
    for(int i=1;i<=n;i++)
    {
        dp[i][0]=-1;
        pref[i][0]=-1;
        for(int j=1;j<=n;j++)
        {
            dp[i][j]=-1;
            if(j<n)
                dp[i][j]=dp[i-1][j+1];

            if(timp[lant[i]]>=j)
            {
                if(j>=i)
                {
                    dp[i][j]=cost[j];
                }
                else {
                    if(pref[i-j][j]!=-1)
                    {
                        if(dp[i][j]==-1)
                            dp[i][j]=cost[j]+pref[i-j][j];
                        else dp[i][j]=mymin(dp[i][j],cost[j]+pref[i-j][j]);
                    }
                }
            }

            pref[i][j]=pref[i][j-1];
            if(dp[i][j]!=-1)
            {
                if(pref[i][j]!=-1)
                    pref[i][j]=mymin(pref[i][j],dp[i][j]);
                else pref[i][j]=dp[i][j];
            }
        }
    }

    int ans = INT_MAX;
    for(int i=1;i<=n;i++)
        if(dp[n][i]!=-1)
            ans=mymin(ans,dp[n][i]);
    if(ans==INT_MAX)
        cout<<-1<<'\n';
    else cout<<ans<<'\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}