#include "coins.h"
#include <bits/stdc++.h>

using namespace std;

const int NMAX = (1 << 20) + 5;

int n;
int a[NMAX];

int seq(int l1, int r1, int l2, int r2) {
    vector<int> a(r1 - l1), b(r2 - l2);
    for (int i = 0; i < a.size(); i++)
        a[i] = l1 + i, b[i] = l2 + i;
    return weigh(a, b);
}

bool what_to_search() {
    int mid = n / 2;
    int midl = n / 4;
    int midr = n / 2 + midl;
    int s1 = seq(0, mid, mid, n);
    if (s1 < 0) {
        int hr = seq(mid, midr, midr, n) > 0 ? 0 : 1;
        if (seq(0, midl, hr == 0 ? mid : midr, hr == 0 ? midr : n) == 0)
            return 1;
    } else {
        int hl = seq(0, midl, midl, mid) > 0 ? 0 : 1;
        if (seq(mid, midr, hl == 0 ? 0 : midl, hl == 0 ? midl : mid) == 0)
            return 1;
    }
    return 0;
}

pair<int, int> count_heavy(int k) {
    n = 1 << k;
    if (k <= 5) {
        bool add = 0;
        for (int i = 0; i < n - 1; i++) {
            int w = weigh({i}, {i + 1});
            a[i + 1] = a[i] - w;
            if (a[i + 1] == -1)
                add = 1;
        }
        int ans1 = 0, ans2 = 0;
        for (int i = 0; i < n; i++) {
            a[i] += add;
            if (a[i]) {
                ans1++;
                ans2 = i;
            }
        }
        return make_pair(ans1, ans2);
    }
    int l = 0;
    int r = n;
    bool light = what_to_search();
    while (l < r) {
        int mid = (l + r) / 2;
        if (l == r - 1)
            break;
        int s = seq(l, mid, mid, r) * (light ? -1 : 1);
        if (s > 0)
            r = mid;
        else
            l = mid;
    }
    if (!light)
        return make_pair(1, r - 1);
    return make_pair(n - 1, r % n);
}
