#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e5+5;
const int SQRTN = 500;

struct Query {
    int l, r, v;
};

int n, m;
int b[SQRTN][NMAX];
Query q[NMAX];
int sum_div[NMAX];
int bsz, bucket[NMAX];

void read() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> m;
    for (int i = 1; i <= m; i++) {
        cin >> q[i].l >> q[i].r >> q[i].v;
        n = max(n, q[i].r);
    }
}

void precalc() {
    int mx = 0;
    for (int i = 1; i < NMAX / 2; i++) {
        for (int j = i * 2; j < NMAX; j += i) {
            sum_div[j] += i;
            mx = max(mx, sum_div[j]);
        }
    }
    bsz = sqrt(NMAX);
    for (int i = 1; i < NMAX; i++)
        bucket[i] = ((i - 1) / bsz + 1);
    int cnt = 0;
    for (int i = 1; i < NMAX; i++)
        b[bucket[i]][min(sum_div[i], NMAX - 1)]++;
    for (int i = NMAX - 2; i > 0; i--)
        for (int j = 1; j < SQRTN; j++)
            b[j][i] += b[j][i + 1];
}

int solve(const Query q) {
    int lb = bucket[q.l] + 1;
    int rb = bucket[q.r] - 1;
    int ans = 0;
    for (int i = lb; i <= rb; i++)
        ans += b[i][q.v];
    for (int i = q.l; bucket[i] == bucket[q.l] && i <= q.r; i++)
        ans += sum_div[i] > q.v;
    for (int i = q.r; bucket[i] == bucket[q.r] && bucket[q.l] != bucket[q.r]; i--)
        ans += sum_div[i] > q.v;
    return ans;
}

int main() {
    read();
    precalc();
    for (int i = 1; i <= m; i++)
        cout << solve(q[i]) << '\n';
    return 0;
}
