#include <bits/stdc++.h>

using namespace std;

#define ll long long
const int INF=1e9,SQ=317,LOG=20;
const ll LINF=1e18;
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long,long long>
#define mid ((l+r)/2)
#define sz(a) (int(a.size()))
#define all(a) a.begin(),a.end()
#define endl "\n"
#define PRINT(x) cerr<<#x<<"="<<x<<endl;
#define pb push_back
#define PRINTvec(niz) {cerr<<#niz<<"="; for(int _i:niz) cerr<<_i<<" "; cerr<<endl;}

mt19937 rng;

int Random(int a,int b){
    return uniform_int_distribution<int>(a,b)(rng);
}

int mxR=1e5+1;

vector<int> spf(mxR,INF);
vector<bool> prime(mxR,true);
vector<vector<int>> pref(mxR,vector<int>(11,0));
vector<vector<bool>> relative_prime(mxR,vector<bool>(11,true));

void Spf(){
    for(int i=2;i<mxR;i++){
        if(prime[i]){
            spf[i]=i;
            for(int j=2*i;j<mxR;j+=i){
                prime[j]=false;
                spf[j]=min(spf[j],i);
            }
        }
    }
}

struct Query{
    int L,R,V;
};

void Solve(){
    int Q; cin>>Q;
    vector<Query> qs(Q);
    bool subtask1=false;
    for(int i=0;i<Q;i++){
        cin>>qs[i].L>>qs[i].R>>qs[i].V;
        subtask1|=qs[i].V>10;
    }
    if(subtask1){
        for(int i=0;i<Q;i++){
            int L=qs[i].L;
            int R=qs[i].R;
            int V=qs[i].V;
            int res=0;
            for(int x=L;x<=R;x++){
                set<int> divs;
                int sum=0;
                for(int d=1;d*d<=x;d++){
                    if(x%d==0){
                        if(x/d!=x){
                            if(!divs.count(x/d)){
                                sum+=x/d;
                                divs.insert(x/d);
                            }
                        }
                        if(d!=x){
                            if(!divs.count(d)){
                                sum+=d;
                                divs.insert(d);
                            }
                        }
                    }
                    if(sum>V) break;
                }
                if(sum>V) res++;
            }
            cout<<res<<endl;
        }
    }
    else{
        Spf();
        for(int V=1;V<=10;V++){
            for(int X=1;X<mxR;X++){
                if(X==1) relative_prime[X][V]=false;
                else if(prime[X]){
                    relative_prime[X][V]=false;
                }
                else if(X>49) continue;
                else{
                    set<int> divs;
                    for(int d=1;d<=V;d++){
                        if(X%d==0){
                            if(X/d!=X) divs.insert(X/d);
                            if(d!=X) divs.insert(d);
                        }
                    }
                    int sum=accumulate(all(divs),0);
                    if(sum==1) continue;
                    if(sum<=V){
                        int sum=0;
                        for(int d=1;d*d<=X;d++){
                            if(X%d==0){
                                if(X/d!=X){
                                    divs.insert(X/d);
                                }
                                if(d!=X){
                                    divs.insert(d);
                                }
                            }
                            if(sum>V) break;
                        }
                        if(sum<=V) relative_prime[X][V]=false;
                    }
                }
            }
        }
        for(int V=1;V<=10;V++){
            for(int i=1;i<mxR;i++){
                pref[i][V]=pref[i-1][V]+relative_prime[i][V];
            }
        }
        for(int i=0;i<Q;i++){
            cout<<pref[qs[i].R][qs[i].V]-pref[qs[i].L-1][qs[i].V]<<endl;
        }
    }
}

int main(){
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);
    int t=1;
    //cin>>t;
    while(t--){
        Solve();
    }
}
