#include <bits/stdc++.h>
#define int long long
#define X first
#define Y second
#define mp make_pair

using namespace std;
using pii = pair <int, int>;

constexpr int maxn = 2e3 + 10;
constexpr int inf = 1e17 + 10;

vector <int> graph [maxn];

int n, c [maxn], t [maxn];
int dp [maxn][maxn * 2];

int dst [maxn];

int calc [maxn * 2][maxn];

inline void updtree (int i, int v, int p) {
    //if (v == 7) cout << "grgegr " << i  << ' ' << dst[v] << '\n';
    calc[i][v] = dp[v][i - dst[v]];
    int ss = 0;
    for (int j : graph[v]) if (j != p && dst[j] < i) ss += calc[i][j];
    if (dst[v] + 1 == i) ss = inf;
    calc[i][v] = min (calc[i][v], ss);
    //cout << calc[i][v] << '\n';
}

inline int gettree (int v, int i) {
    return calc[i][v];
}

inline void dfs (int v, int p = -1, int D = 0) {
    dst[v] = D;
    for (int i : graph[v]) if (i != p) dfs (i, v, D + 1);
    for (int i = 0; i <= 2 * n + 1; ++i) dp[v][i] = inf;
    for (int i = 1; i <= t[v]; ++i) {
        int result = 0;
        for (int j : graph[v]) if (j != p) result += gettree (j, dst[j] + i);
        //cout << result << '\n';
        int delta = 0;
        for (int j : graph[v]) if (j != p) {
            int S = gettree (j, dst[j] + i);
            delta = min (delta, dp[j][i + 1] - S - c[i]);
        }
        dp[v][i] = min (dp[v][i], result + c[i] + delta);
    }
    for (int i = t[v] + 1; i <= n; ++i) {
        int result = 0;
        for (int j : graph[v]) if (j != p) result += gettree (j, dst[j] + i);
        int delta = inf;
        for (int j : graph[v]) if (j != p) {
            int S = gettree (j, dst[j] + i);
            delta = min (delta, dp[j][i + 1] - S);
        }
        dp[v][i] = min (dp[v][i], result + delta);
    }
    for (int i = n - 1; i > 0; --i) dp[v][i] = min (dp[v][i], dp[v][i + 1]);
    for (int i = 1; i <= n; ++i) updtree (i + D, v, p);
}

inline void solve () {
    int u, v;
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> t[i];
    for (int i = 0; i < n - 1; ++i) {
        cin >> u >> v, --u, --v;
        graph[u].push_back (v);
        graph[v].push_back (u);
    }
    //dfs (6, 3, 2);
    //cout << dp[6][1] << ' ' << dp[6][2] << '\n';
    dfs (0);
    cout << (dp[0][1] == inf ? -1LL : dp[0][1]) << '\n';
}

signed main () {
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve ();
    return 0;
}


/*

5
1 111 111 111 111
4 4 4 4 4
1 2
2 3
3 4
4 5


*/
