#include <bits/stdc++.h>
//#define int long long
#define X first
#define Y second
#define mp make_pair

using namespace std;
using pii = pair <int, int>;

constexpr int maxn = 2e3 + 10;
//constexpr int inf = 1e17 + 10;

struct fenwick {
    int n;
    vector <int> f;
    fenwick (int _n) {
        n = _n;
        f.assign (n, 0);
    }
    void inc (int i, int delta) {
        for (; i < n; i |= (i + 1)) f[i] += delta;
    }
    int get (int i) {
        int result = 0;
        for (; i >= 0; i &= (i + 1), --i) result += f[i];
        return result;
    }
    int sum (int l, int r) {
        return get (r) - get (l - 1);
    }
};

int dp [111111];
vector <pair <pii, int>> check [111111];
vector <int> add [111111];
int res [111111];

inline void solve () {
    for (int i = 1; i <= 100000; ++i) {
        if (dp[i] <= 100000) add[dp[i]].push_back (i);
        for (int j = i + i; j <= 100000; j += i) dp[j] += i;
    }
    int q, l, r, v;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> l >> r >> v;
        check[v].push_back (mp (mp (l, r), i));
    }
    fenwick fw (100001);
    for (int i = 0; i <= 100000; ++i) {
            for (int j : add[i]) fw.inc (j, 1);
            for (pair <pii, int> j : check[i]) {
            res[j.Y] = j.X.Y - j.X.X + 1 - fw.sum (j.X.X, j.X.Y);
        }
    }
    for (int i = 0; i < q; ++i) cout << res[i] << '\n';
}

signed main () {
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve ();
    return 0;
}


/*

5
1 111 111 111 111
4 4 4 4 4
1 2
2 3
3 4
4 5


*/
