#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int weigh(const vector<int> &a, const vector<int> &b);

pair <int, int> count_heavy(int k) {
    int ind;
    int blocked = 0;
    for (int e = k - 1; e >= 0; e --) {
        vector <int> a, b;
        for (int i = 0; i < (1 << e); i ++) {
            a.push_back(blocked + i);
            b.push_back(blocked + (1 << e) + i);
        }
        int w = weigh(a, b);
        if (w == -1)
            blocked += (1 << e);
    }
    vector <pair <vector <int>, int>> heavy;
    int total = 1;
    heavy.push_back({{ind}, 1});
    int checked = 1;
    while (true) {
        int l = checked, r = (1 << k) - 1;
        while (l < r) {
            int mid = l + (r - l + 1) / 2;
            vector <int> a, b;
            for (int i = checked; i <= mid; i ++)
                if (i != ind) b.push_back(i);
            a.push_back(ind);
            for (auto [vec, idx] : heavy)
                for (auto val : vec)
                    a.push_back(val);
            //
            int w = weigh(a, b);
            if (w == -1)
                r = mid - 1;
            else
                l = mid;
        }
        if (l == (1 << k) - 1) {
            //
            break;
        }
        heavy.push_back({{}, total});
        total *= 2;
        for (int i = checked; i <= l; i ++)
            if (i != ind)
                heavy[heavy.size()].first.push_back(i);
    }
    return {total, ind};
}