#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

const int N = 2e3 + 128;
const ll INF = 1e18;
int t[N], c[N];
vector <int> g[N];

ll ans = INF;

int n;

bitset < N > used;

bool check(vector<int> &a) {
    used.reset();

    for (int i = 1; i <= n; i++) {
        int d = a[i - 1];
        if (!d) continue;
        queue < pair<int, int> > q;
        used[i] = true;
        q.push({i, 1});
        while (!q.empty()) {
            auto [v, dist] = q.front(); q.pop();
            for (auto to : g[v])
                if (dist+1<=d) {
                    used[to] = true;
                    q.push({to, dist+1});
                }
        }
    }

    for (int i = 1; i <= n; i++)
        if (!used[i])
            return false;

    return true;
}

void rec(vector<int> cur, ll cost) {
    int i = cur.size();

    if (i == n) {
        if (ans < cost || !check(cur)) return;
        ans = min(ans, cost);
        return;
    }

    for (int v = 0; v <= t[i+1]; v++) {
        cur.push_back(v);
        rec(cur, cost+c[v]);
        cur.pop_back();
    }
}

ll dp[N][N];
ll greatest_try[N];

void solve() {
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> t[i];
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    if (n <= 8) {
        rec({}, 0);

        if (ans == 1e18) ans = -1;

        cout << ans << '\n';
        return;
    }

    vector <int> arr;
    vector < char > was(n+1, false);
    for (int i = 1; i <= n; i++)
        if (g[i].size() == 1) {
            arr.push_back(i);
            was[i] = true;
            break;
        }

    while ( (int) arr.size() != n) {
        for (auto to : g[arr.back()])
            if (!was[to]) {
                was[to] = true;
                arr.push_back(to);
                break;
            }
    }

    for (int i = 0; i < N; i++)
        for (int x = 0; x < N; x++)
            dp[i][x] = INF;

    for (int i = 1; i <= n; i++)
        greatest_try[i] = INF;

    for (int i = 1; i <= n; i++) {
        // placing on me from above

        for (int j = 1; j < i; j++) {
            int dist = i - j + 1;
            if (dist <= n)
                dp[i][0] = min(dp[i][0], dp[j][dist]);
        }

        // update from me

        for (int x = 1; x <= t[i]; x++) {
            // most left
            int left_case = max(0, i - x + 1);
            dp[i][x] = min(dp[i][x], c[x]+greatest_try[left_case]);
        }

        // update greatest res
        for (int x = 0; x <= t[i]; x++)
            greatest_try[i] = min(greatest_try[i], dp[i][x]);
    }

    if (greatest_try[n] == INF)
        greatest_try[n] = -1;

    cout << greatest_try[n] << '\n';
}

main() {
//    boost;
    solve();
    return 0;
}
