#include <bits/stdc++.h>

#pragma GCC Optimize("Ofast")
#pragma GCC Optimize("unroll-loops")

#define watch(x) cout << (#x) << " : " << x << '\n'

using namespace std;

const int MAXN = 1e5 + 5;

vector <int> cnt(MAXN, 0);

void init() {
    cnt[0] = cnt[1] = 0;
    for (int i = 2; i < MAXN; i++) {
        cnt[i]++;
        for (int j = 2 * i; j < MAXN; j += i)
            cnt[j] += i;
    }
}

vector < int > q[MAXN];

unordered_map <int, int> res[MAXN];

vector < vector<int> > saved;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
template <class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    init();

    int t;
    cin >> t;

    for (int i = 0; i < t; i++) {
        int l, r, v;
        cin >> l >> r >> v;
        saved.push_back({l, r, v});
        if (l) q[l-1].push_back(v);
        q[r].push_back(v);
    }

    ordered_multiset<int> st;

    for (int i = 0; i < MAXN; i++) {
        st.insert(cnt[i]);

        for (auto v : q[i])
            res[i][v] = (i+1) - st.order_of_key(v+1);
    }

    for (auto c : saved) {
        int l = c[0], r = c[1], v = c[2];

        cout << res[r][v] - res[l-1][v] << '\n';
    }

    return 0;
}

