#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b;
vector<ll> G[2000];
ll remap[2000];

void dfs(ll x, ll p, ll c) {
    remap[x] = c;
    // cout << '\t' << x << ' ' << c << '\n';
    for (int i : G[x]) {
        if (i != p) {
            dfs(i, x, c + 1);
        }
    }
}

void solve() {
    cin >> n;
    vector<ll> t1(n);
    vector<ll> c(n);
    vector<ll> t(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> t1[i];
    }
    for (int i = 0; i < n - 1; i++) {
        cin >> x >> y;
        x--;
        y--;
        G[x].push_back(y);
        G[y].push_back(x);
    }
    for (int i = 0; i < n; i++) {
        if (G[i].size() == 1) {
            dfs(i, -1, 0);
            break;
        }
    }
    for (int i = 0; i < n; i++) {
        t[remap[i]] = t1[i];
    }
    vector<ll> dp(n + 1, INF);
    dp[0] = 0;
    for (ll i = 1; i <= n; i++) {
        ll mn = INF;
        for (int j = i; j < n; j++) {
            mn = min(mn, dp[j]);
        }
        for (int j = 0; j < t[i - 1]; j++) {
            mn = min(mn, dp[max(0LL, i - j - 1)]);
            dp[min(n, i + j)] = min(dp[min(n, i + j)], mn + c[j]);
        }
    }
    cout << dp[n] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}