#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;
ll sieve[200000];
ll pr[200000];

void solve() {
    cin >> x >> y >> k;
    ll ans = y - x + 1;
    for (int i = x; i <= y; i++) {
        if (sieve[i]) {
            ll sm = 1;
            for (int j = 2; j <= sqrt(i); j++) {
                if (j * j == i) {
                    sm += j;
                }
                else if (i % j == 0) {
                    sm += j;
                    sm += i / j;
                }
            }
            if (i == 1) {
                sm--;
            }
            // cout << i << ' ' << sm << '\n';
            if (sm <= k) {
                ans--;
            }
        }
    }
    ans -= pr[y] - pr[x - 1];
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    sieve[0] = 1;
    sieve[1] = 1;
    for (int i = 2; i <= 100000; i++) {
        if (sieve[i]) {
            continue;
        }
        for (int j = i * 2; j <= 100000; j += i) {
            sieve[j] = 1;
        }
    }
    pr[0] = 1 - sieve[0];
    for (int i = 1; i <= 100000; i++) {
        pr[i] = pr[i - 1] + 1 - sieve[i];
    }
    // for (int i = 0; i <= 10; i++) {
    //     cout << pr[i] << ' ';
    // }
    // cout << '\n';
    cin >> q;
    while (q--) {
        solve();
    }
}