#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

constexpr ll INF = 1000000000000000000LL;
constexpr ll sz = 100000;

ll n, m, q, k, x, y, a, b, c;

struct node {
    node* right = nullptr;
    node* left = nullptr;
    ll val = 0;
};

struct ordered {

    node *head = new node;

    void upd(node *nod, ll l, ll r, ll tl, ll tr, ll idx, ll val) {
        // cout << l << ' ' << r << endl;
        if (nod == nullptr) {
            cout << l << ' ' << r << '\n';
            nod = new node;
        }
        if (nod->left == nullptr) {
            nod->left = new node;
        }
        if (nod->right == nullptr) {
            nod->right = new node;
        }
        // cout << nod << ' ' << l << ' ' << r << endl;
        if (l != r) {
            ll mid = (r + l) / 2;
            if (idx <= mid) {
                upd(nod->left, l, mid, tl, tr, idx, val);
            }
            else {
                upd(nod->right, mid + 1, r, tl, tr, idx, val);
            }
        }
        if (l == r) {
            nod->val += val;
        }
        else {
            nod->val = nod->left->val + nod->right->val;
        }
        // cout << l << ' ' << r << endl;
    }

    ll query(node *nod, ll l, ll r, ll tl, ll tr) {
        // cout << '\t' << '\t' << nod << ' ' << l << ' ' << r << ' ' << tl << ' ' << tr << '\n';
        if (nod == nullptr) {
            return 0;
        }
        if (tl <= l && r <= tr) {
            return nod->val;
        }
        if (r < l) {
            return 0;
        }
        if (r < tl || tr < l) {
            return 0;
        }
        ll mid = (r + l) / 2;
        return query(nod->left, l, mid, tl, tr) + query(nod->right, mid + 1, r, tl, tr);
    }
};

ll sieve[200000];
ll num[200000];
ordered *tre[400000];

void upd_x(ll x, ll l, ll r, ll idx, ll val) {
    // cout << x << ' ' << l << ' ' << r << endl;
    if (tre[x] == nullptr) {
        tre[x] = new ordered;
    }
    if (l != r) {
        ll mid = (r + l) / 2;
        if (idx <= mid) {
            upd_x(x * 2 + 1, l, mid, idx, val);
        }
        else {
            upd_x(x * 2 + 2, mid + 1, r, idx, val);
        }
    }
    tre[x]->upd(tre[x]->head, 0, sz, l, r, val, 1);
    // cout << x << ' ' << l << ' ' << r << endl;
}

ll query_x(ll x, ll l, ll r, ll tl, ll tr, ll l1, ll r1) {
    // cout << x << ' ' << l << ' ' << r << ' ' << tl << ' ' << tr << endl;
    if (tl <= l && r <= tr) {
        // cout << '\t' << x << ' ' << l << ' ' << r << '\n';
        return tre[x]->query(tre[x]->head, 0, sz, l1, r1);
    }
    if (r < l) {
        return 0;
    }
    if (r < tl || tr < l) {
        return 0;
    }
    ll mid = (r + l) / 2;
    return query_x(x * 2 + 1, l, mid, tl, tr, l1, r1) + query_x(x * 2 + 2, mid + 1, r, tl, tr, l1, r1);
}

void solve() {
    cin >> x >> y >> k;
    cout << query_x(0, 0, sz, x, y, 0, k - 1) << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    sieve[0] = 1;
    sieve[1] = 1;
    for (int i = 0; i < 400000; i++) {
        tre[i] = nullptr;
    }
    for (int i = 2; i <= sz; i++) {
        if (sieve[i]) {
            continue;
        }
        num[i]++;
        for (int j = i * 2; j <= sz; j += i) {
            sieve[j] = 1;
            num[j] += i;
        }
    }
    // cout << "DEBUG" << endl;
    for (int i = 1; i <= sz; i++) {
        upd_x(0, 0, sz, i, num[i]);
    }
    // cout << "DEBUG" << endl;
    // cout << query_x(0, 0, sz, 1, 5, 0, 5) << endl;
    // for (int i = 0; i <= 2 * sz; i++) {
    //     for (int j = 0; j <= 2 * sz; j++) {
    //         cout << mp[{i, j}] << ' ';
    //     }
    //     cout << '\n';
    // }
    cin >> q;
    while (q--) {
        solve();
    }
}