//
//  coins.cpp
//  25.11 IATI 1st day
//
//  Created by Kseniia on 25.11.2022.
//

#include "coins.h"

#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

#define endl '\n'

using namespace std;
typedef int ll;

ll ask(ll l, ll r){
    ll mid = (l + r) >> 1;
    
    vector<ll>a, b;
    
    for(int i = l; i <= mid; i++)
        a.push_back(i);
    for(int i = mid + 1; i <= r; i++)
        b.push_back(i);
    
    return weigh(a, b);
}

ll heavy = 0;

ll solve(ll l, ll r){
    ll mid = (l + r) >> 1;
    
    ll cnt = ask(l, r);
    
    if(cnt == 0){
        if(l + 1 == r){
            if(l == heavy || r == heavy)
                return 2;
            
            if(weigh({l}, {heavy}) == 0)
                return 2;
            return 0;
        }
        return 2 * solve(l, mid);
    }
    if(l + 1 == r)
        return 1;
    

    return solve(l, mid) + solve(mid + 1, r);
}

pair<int, int> count_heavy(int k){
    ll l = 0, r = (1 << k) - 1;
    
    if(k <= 5){
        ll ans = 0;
        ll gl = 0;
        
        for(int i = 0; i < r; i++){
            ll cnt = weigh({i}, {i + 1});
            gl++;
            
            if(cnt == 0)
                continue;
            
            if(cnt == 1){
                ans += i + 1;
                
                for(int j = i + 1; j <= r; j++){
                    gl++;
                    if(weigh({i}, {j}) == 0)
                        ans++;
                }
                
                if(gl > 40)
                    ans = 9 / 0;
                
                return {ans, i};
            }
            else{
                ans++;
                for(int j = i + 2; j <= r; j++){
                    gl++;
                    if(weigh({i + 1}, {j}) == 0)
                        ans++;
                }
                if(gl > 40)
                    ans = 9 / 0;
                
                return {ans, i + 1};
            }
        }
        if(gl > 40)
            ans = 9 / 0;
        return {0, 0};
    }
    
    while(l < r){
        ll mid = (l + r) >> 1;
        
        ll cnt = ask(l, r);
        
        if(cnt == 0){
            r = mid;
            continue;
        }
        
        if(cnt == -1){
            l = mid + 1;
        }
        else
            r = mid;
    }
    
    heavy = l;
    
    return {solve(0, (1 << k) - 1), l};
}
