#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

#define endl '\n'

using namespace std;
typedef int ll;


ll n;
ll c[200007], t[20007];
vector<ll>d[200007];

vector<ll>order;

void dfs(ll v, ll par){
    order.push_back(v);
    
    for(auto i: d[v])
        if(i != par)
            
            dfs(i, v);
}

ll solve(ll l, ll r){
    if(l == r){
        if(t[order[l]] == 0)
            return 1e9;
        
        return c[1];
    }
    ll ans = 1e18;
    
    for(int i = l; i <= r; i++){
        ll v = order[i];
        
        for(int j = 2; j <= t[v]; j++){
            ll cnt = c[j];
            if(i - j >= l)
                cnt += solve(l, i - j);
            if(i + j <= r){
                cnt += solve(i + j, r);
            }
                        
            ans = min(ans, cnt);
        }
    }
    return ans;
}

int main(){
    cin >> n;
    
    for(int i = 1; i <= n; i++)
        cin >> c[i];
    
    for(int i = 1; i <= n; i++)
        cin >> t[i];
    
    for(int i = 0; i < n - 1; i++){
        ll a, b;
        cin >> a >> b;
        
        d[a].push_back(b);
        d[b].push_back(a);
    }
    
    order.push_back(-1);
    for(int i = 1; i <= n; i++){
        if(d[i].size() == 1){
            dfs(i, -1);
            
            break;
        }
    }
    
    cout << solve(1, n) << endl;
    
    return 0;
}
