#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

#define endl '\n'

using namespace std;
typedef long long  ll;


ll n;
ll c[200007], t[20007];
vector<ll>d[200007];

vector<ll>order;

void dfs(ll v, ll par){
    order.push_back(v);
    
    for(auto i: d[v])
        if(i != par)
            
            dfs(i, v);
}

map<pair<ll, ll>, ll> mp;

/*
       _________
 o o o o o I o o o
 d[i][j]
 
 */



int main(){
    cin >> n;
    
    for(int i = 1; i <= n; i++)
        cin >> c[i];
    
    for(int i = 1; i <= n; i++)
        cin >> t[i];
    
    for(int i = 0; i < n - 1; i++){
        ll a, b;
        cin >> a >> b;
        
        d[a].push_back(b);
        d[b].push_back(a);
    }
    
    order.push_back(-1);
    for(int i = 1; i <= n; i++){
        if(d[i].size() < 2){
            dfs(i, -1);
            
            break;
        }
    }
    
    vector<vector<ll>>pref(n + 1, vector<ll>(n + 1)), suf(n + 1, vector<ll>(n + 1));
    
    for(int j = 1; j <= n; j++){
        if(j > t[order[1]])
            pref[1][j] = 1e18;
        else
            pref[1][j] = c[j];
    }
    
    
    for(int i = 2; i <= n; i++){
        for(int j = 1; j <= t[order[i]]; j++){
            ll l = i - j;
            if(l < 1){
                pref[i][j] = c[j];
                continue;
            }
            
            ll mn = 1e18;
            
            for(int j2 = 1; j2 <= t[order[l]]; j2++){
                mn = min(mn, pref[l][j2]);
            }
                    
            pref[i][j] = c[j] + mn;
        }
    }
    
    
    for(int j = 1; j <= n; j++){
        if(j > t[order[n]])
            suf[n][j] = 1e18;
        else
            suf[n][j] = c[j];
    }
    
    for(int i = n - 1; i >= 1; i--){
        for(int j = 1; j <= t[order[i]]; j++){
            ll r = i + j;
            if(r > n){
                suf[i][j] = c[j];
                continue;
            }
            
            ll mn = 1e18;
            
            for(int j2 = 1; j2 <= t[order[r]]; j2++){
                mn = min(mn, suf[r][j2]);
            }
            
            suf[i][j] = c[j] + mn;
        }
    }
    
    ll ans = 1e18;
    
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= t[order[i]]; j++){
            ll l = i - j, r = i + j;
            
            ll cnt = c[j];
            if(l >= 1){
                ll mn = 1e9;
                
                for(int j2 = 1; j2 <= t[order[l]]; j2++)
                    mn = min(mn, pref[l][j2]);
                cnt += mn;
            }
            if(r <= n){
                ll mn = 1e9;
                
                for(int j2 = 1; j2 <= t[order[r]]; j2++)
                    mn = min(mn, suf[r][j2]);
                cnt += mn;
            }
            
            ans = min(ans, cnt);
        }
    }
    
    
    
    cout << ans << endl;
    
    return 0;
}
/*
 
 4
 1 2 3 4
 0 3 2 1
 1 2
 2 3
 3 4
 
 */
