#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

#define endl '\n'

using namespace std;
typedef long long  ll;

ll n;
ll c[200007], t[20007];
vector<ll>d[200007];

vector<ll>order;

void dfs(int v, int par){
    order.push_back(v);
    
    for(auto i: d[v])
        if(i != par)
            
            dfs(i, v);
}


/*
       _________
 o o o o o I o o o
 d[i][j]
 
 */

ll dp[507][507]; // dp[l][r]


ll vec[2007], used[2007];

void dfs2(ll v, ll dist, ll mx){
    if(dist > mx)
        return;
    used[v] = 1;
    if(dist == mx)
        return;
    
    for(auto i: d[v])
        if(!used[i])
            dfs2(i, dist + 1, mx);
}

ll res = 1e18;

void put(ll pos, ll val){
    vec[pos] = val;
    
    if(pos == n){
        for(int i = 1; i <= n; i++)
            used[i] = 0;
        
        ll ans = 0;
        
        for(int i = 1; i <= n; i++){
            if(vec[i] == 0)
                continue;
            ans += c[vec[i]];
            
            dfs2(i, 0, vec[i] - 1);
        }
        
        bool ok = false;
        
        for(int i = 1; i <= n; i++)
            if(!used[i] || vec[i] > t[i])
                ok = true;
        
        if(!ok){
          
            res = min(res, ans);
        }
    }
    
    if(pos != n)
        for(int i = 0; i <= t[pos + 1] + 2; i++)
            put(pos + 1, i);
    
    
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    cin >> n;
    
    for(int i = 1; i <= n; i++)
        cin >> c[i];
    
    for(int i = 1; i <= n; i++)
        cin >> t[i];
    
    for(int i = 0; i < n - 1; i++){
        ll a, b;
        cin >> a >> b;
        
        d[a].push_back(b);
        d[b].push_back(a);
    }
    
    for(int i = 0; i <= t[1] + 2; i++)
        put(1, i);
    
    if(res >= 1e18)
        res = -1 / 0;
    
    cout << res << endl;
    
    return 0;
}
/*
 
 4
 1 2 3 4
 0 3 2 1
 1 2
 2 3
 3 4
 
 */
/*
 2
 4 3
 1 1
 1 2
 
 */
