#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

#define endl '\n'

using namespace std;
typedef int ll;

struct one{
    ll pos, ind, num, v;
};

bool cmp(one p1, one p2){
    return p1.pos < p2.pos;
}

ll t[7000007];

void add(ll pos, ll val){
    pos++;
    
    for(int i = pos; i < 7000007; i += (i & -i))
        t[i] += val;
}

ll get(ll pos){
    pos++;
    
    ll res = 0;
    
    for(int i = pos; i > 0; i -= (i & -i))
        res += t[i];
    
    return res;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    ll q;
    cin >> q;
    
    vector<one>a;
    for(int i = 0; i < q; i++){
        ll l, r, v;
        cin >> l >> r >> v;
        
        a.push_back({l - 1, i, -1, v});
        a.push_back({r, i, 1, v});
    }
    
    sort(a.begin(), a.end(), cmp);
    
    ll last = 1;
    
    vector<ll>ans(q);
    
    for(auto i: a){
        for(int j = last; j <= i.pos; j++){
            ll cnt = 0;
            
            for(int k = 1; k * k <= j; k++){
                if(j % k == 0){
                    cnt += k;
                                        
                    if((j / k) != j && (j / k) * (j / k) > j){
                        cnt += j / k;
                    }
                }
            }
            add(cnt, 1);
        }
        
        last = i.pos + 1;
        
        ll cnt = get(7000000) - get(i.v);
        
        ans[i.ind] += cnt * i.num;
    }
    
    for(int i = 0; i < q; i++)
        cout << ans[i] << endl;
    
    
    return 0;
}
