#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

#define endl '\n'

using namespace std;
typedef int ll;

struct one{
    ll l, r, v;
};
/*
bool cmp(one p1, one p2){
    return p1.pos < p2.pos;
}

ll t[70000007];

void update(ll v, ll l, ll r, ll pos, ll val){
    if(r < pos || pos < l)
        return;
    
    if(l == r){
        t[v] += val;
        return;
    }
    ll mid = (l + r) >> 1;
    
    update(2 * v + 1, l, mid, pos, val);
    update(2 * v + 2, mid + 1, r, pos, val);
    
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}

ll get(ll v, ll l, ll r, ll ql, ll qr){
    if(r < ql || qr < l)
        return 0;
    
    if(ql <= l && r <= qr)
        return t[v];
    
    ll mid = (l + r )>> 1;
    
    return get(2 * v + 1, l, mid, ql, qr) + get(2 * v + 2, mid + 1, r, ql, qr);
}

*/

ll div(ll i){
    ll cnt = 0;
    
    for(int j = 1; j * j <= i; j++){
        if(i % j == 0){
            cnt += j;
            
            if(i / j != i && (i / j) > sqrt(i))
                cnt += i / j;
        }
    }
    
    return cnt;
}

ll pref[7000000][12];

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    ll q;
    cin >> q;
    
    ll mx = 0;
    
    vector<one>a;
    
    for(int i = 0; i < q; i++){
        ll l, r, v;
        cin >> l >> r >> v;
        
        a.push_back({l, r, v});
        mx = max(mx, r);
    }
    
    for(int i = 1; i <= mx; i++){
        ll cnt = div(i);
                
        for(int j = 1; j <= 10; j++){
            pref[i][j] = pref[i - 1][j];
            if(cnt > j)
                pref[i][j]++;
        }
    }
        
    for(auto i: a){
        ll cnt = pref[i.r][i.v] - pref[i.l - 1][i.v];
        cout << cnt << endl;
    }
    
    return 0;
}
