#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include "coins.h"
using namespace std;



bool cmp(int a, int b) {
    int val = weigh({a}, {b});
    if (val >= 0) {
        return true;
    } else
        return false;
}


pair<int, int> count_heavy(int K) {
    vector<int> coins;

    for (int i = 0; i < (1 << K); i++)
        coins.push_back(i);

    sort(coins.begin(), coins.end(), cmp);

    int f = coins[0];
    int l = 0;
    int r = coins.size() - 1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        int val = weigh({f}, {coins[m]});
        if (val >= 0) {
            l = m;
        } else
            r = m;
    }
    if (weigh({coins[l]}, {coins[r]}) <= 0) {
        return {r + 1, coins.size() - r - 1};
    } else
        return {r, coins.size() - r};
}
