#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

#pragma O4

#define int long long
#define maxN 100010
#define endl "\n"
int sum(int x) {
    if(x == 1)
        return 0;
    int ans = 1;
    for (int i = 2; i * i <= x; i++) {
        if (i * i == x) {
            ans += i;
            continue;
        }
        if (x % i == 0) {
            ans += x / i + i;
        }
    }
    return ans;
}

signed main() {
    vector<vector<int>> VAns(12, vector<int>(maxN + 1, 0));
    for (int i = 1; i < maxN; i++) {
        int f = sum(i);
        for (int j = 0; j < 12; j++) {
            if (f < j) {
                VAns[j][i + 1] = VAns[j][i];
            } else
                VAns[j][i + 1] = VAns[j][i] + 1;
        }
    }
    cout<<1/0<<endl;
    int q;
    cin >> q;
    while (q--) {
        int l, r, v;
        cin >> l >> r >> v;
        cout << VAns[v][r+1] - VAns[v][l+1] << endl;
    }
}
//0 1 1 3 1 6 1 7 4 8 1   16 1 10 9 15 1 21 1 22    11 14 1 36 6 16 13 28 1 42 6