#include <bits/stdc++.h>
#pragma "Ofast"
using namespace std;

#define INF 1e8

int n;
long long cost = INF;
vector<vector<int>> a;
vector<int> u;
vector<int> c;
vector<int> t;

void dfs(int x, int k, int mk) {
    if (mk == 0) return;
    u[x] = 1;
    if (k != mk) for (auto to : a[x]) dfs(to, k+1, mk);
}

long long check(vector<int> v) {
    u.resize(n);
    for (int i = 0; i < n; i++) u[i] = 0;
    for (int i = 0; i < n; i++) {
        dfs(i,1,v[i]);
    }
    long long cost = 0;
    for (int i = 0; i < n; i++) {
        if (u[i] == 0) return -1;
        cost +=c[v[i]];
    }
    return cost;
}

void go(vector<int> v) {
    if (v.size() == n) {
        long long x = check(v);
        if (x!=-1) cost = min(cost,x);
        return;
    }
    for (int i = 0; i <= t[v.size()]; i++) {
        v.push_back(i);
        go(v);
        v.erase(v.end()-1);
    }
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    c.resize(n+1);
    t.resize(n);
    a.resize(n);
    c[0] = 0;
    for (int i = 1; i <= n; i++) cin >> c[i];
    for (int i = 0; i < n; i++) cin >> t[i];
    for (int i = 0; i < n-1; i++) {
        int v1, v2;
        cin >> v1 >> v2;
        a[v1-1].push_back(v2-1);
        a[v2-1].push_back(v1-1);
    }
    go({});
    if (cost == INF) cost = -1;
    cout << cost;
}
