#include <bits/stdc++.h>
#pragma "Ofast"
using namespace std;

#define DIM 100001

int prim[DIM];
vector<int> t[4*DIM];
vector<int> p;

void sieve(int n) {
    for (int i = 2; i <= n; i++) {
        if (prim[i]==0) {
            for (int j = 2; i*j<=n; j++) prim[i*j] = 1;
            p.push_back(i);
        }
    }
}

vector<int> d;

void divsum(int n) {
    d.resize(n);
    for (int i = 2; i <= n; i++) d[i] = 1;
    for (int i = 2; i <= n; i++) {
        for (int j = 2; i*j <= n; j++) d[i*j]+=i;
    }
}

vector<int> merg(vector<int> a, vector<int> b) {
    int ia = 0, ib = 0;
    vector<int> c;
    while(ia<a.size() && ib<b.size()) {
        if (a[ia] < b[ib]) {
            c.push_back(a[ia]);
            ia++;
        }
        else {
            c.push_back(b[ib]);
            ib++;
        }
    }
    while (ia < a.size()) {
        c.push_back(a[ia]);
        ia++;
    }
    while (ib < b.size()) {
        c.push_back(b[ib]);
        ib++;
    }
    return c;
}

vector<int> mergsort(vector<int> v, int x) {
    if (v.size() == 1) {
        t[x] = v;
        return v;
    }
    int m = v.size()/2;
    vector<int> a, b;
    for (int i = 0; i < m; i++) a.push_back(v[i]);
    for (int i = m; i < v.size(); i++) b.push_back(v[i]);
    vector<int> res = merg(mergsort(a, 2*x+1),mergsort(b, 2*x+2));
    t[x] = res;
    return res;
}

int greaterX(int v, int x) {
    auto it = upper_bound(t[v].begin(),t[v].end(), x);
    return t[v].size() - (it-t[v].begin());
}

int findGrX(int v, int l, int r, int L, int R, int x) { //L, R - query
    if (r<L||R<l) {
        return 0;
    }
    if (L<=l&&r<=R) {
        //cout << l << " " << r<< endl << v << " " << greaterX(t[v],x) << endl;
        //for (auto i : t[v]) cout << i << " ";
        //cout << endl;
        return greaterX(v,x);
    }
    int m = (l+r+1)>>1;
    int a = findGrX(2*v+1,l,m-1,L,R,x);
    int b = findGrX(2*v+2,m,r,L,R,x);
    //cout << l << " " << r<< endl<< v << " " << a << "+"<<b<<endl;
    //for (auto i : t[v]) cout << i << " ";
    //cout << endl;
    return a+b;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    sieve(DIM-1);
    divsum(DIM-1);
    //for (int i = 0; i < 25; i++) cout << d[i] << " ";
    //cout << endl << endl;
    mergsort(d, 0);
    /*for (int i = 0; i < 4*DIM; i++) {
            cout << i << " : ";
        for (auto j : t[i]) cout << j << " ";
        cout << endl;
    }*/
    int q;
    cin >> q;
    while(q--) {
        int l, r, x;
        cin >> l >> r >> x;
        cout << findGrX(0,0,d.size(),l,r,x)<< '\n';
    }
}
