#include <bits/stdc++.h>
#define _USE_MATH_DEFINES
#define MULTITEST !true
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define inf (1e9)
#define INF (1e18)
#define all(a) a.begin(), a.end()
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pii;
typedef vector<ll> vi;
typedef vector<bool> vb;
typedef vector<pii> vp;
int primes[10000];
int divisorSums[100100];
void sieve() {
  ll mx = 1e5 + 100;
  vb used(mx, true);
  used[0] = used[1] = false;
  for (ll i = 2; i <= mx; i++)
    if (used[i], 1ll * i * 1ll * i <= mx)
      for (ll j = i * i; j <= mx; j += i)
        used[j] = false;
  int ind = 0;
  for (int i = 0; i <= mx; i++)
    if (used[i])
      primes[ind++] = i;
}
vector<pair<int, int>> factorization(int a) {
  vector<pair<int, int>> ans;
  int ind = 0;
  while (a != 1) {
    if ((a % primes[ind]) == 0) {
      ans.push_back({primes[ind], 0});
      while ((a % primes[ind]) == 0) {
        a /= primes[ind];
        ans.back().second++;
      }
      return ans;
    }
    ind++;
  }
  return ans;
}
ll binpow(int a, int n) {
  ll ans = 1;
  while (n) {
    if (n & 1) ans *= a;
    a *= a;
    n >>= 1;
  }
  return ans;
}
ll sumOfDivisors(int a) {
  vector<pair<int, int>> ans = factorization(a);
  ll res = ll(divisorSums[a / binpow(ans[0].first, ans[0].second)]) * ll((binpow(ans[0].first, ans[0].second + 1) - 1)) / ll(ans[0].first - 1);
  if (res > ll(2e5 + 1000)) res = ll(2e5 + 1000);
  return res;
}
void calculateDivisorsSums() {
  int mx = 1e5 + 10;
  divisorSums[1] = 1;
  for (int i = 2; i < mx; i++)
    divisorSums[i] = sumOfDivisors(i);
  for (int i = 1; i < mx; i++)
    divisorSums[i] -= i;
}
void solve() {
  int q;
  cin >> q;
  vector<pair<pair<int, int>, int>> queries(q);
  int maxV = -inf;
  for (int i = 0; i < q; i++) cin >> queries[i].first.first >> queries[i].first.second >> queries[i].second, maxV = max(maxV, queries[i].second);
  if (maxV > 13 || q < 10000) {
    for (int _ = 0; _ < q; _++) {
      int l = queries[_].first.first, r = queries[_].first.second, v = queries[_].second;
      int amount = 0;
      for (int i = l; i <= r; i++)
        if (divisorSums[i] > v)
          amount++;
      cout << amount << "\n";
    }
  } else {
    int ans[15][100010];
    for (int i = 0; i <= 14; i++)
      for (int j = 0; j < 100010; j++)
        ans[i][j] = 0;
    for (int i = 1; i <= 14; i++) {
      for (int j = 1; j < 100010; j++) {
        ans[i][j] = ans[i][j - 1] + (divisorSums[j] > i);
      }
    }
    for (int _ = 0; _ < q; _++) {
      int l = queries[_].first.first, r = queries[_].first.second, v = queries[_].second;
      if (v == 0) {
        cout << (r - l + 1) << "\n";
        continue;
      }
      if (l == 0) l++;
      int amount = ans[v][r] - (((l - 1) == 0) ? 0 : ans[v][l - 1]);
      cout << amount << "\n";
    }
  }
}
int main() {
  speed
  sieve();
  calculateDivisorsSums();
  int t = 1;
  if (MULTITEST) cin >> t;
  while (t--) {
    solve();
  }
}