#include <bits/stdc++.h>
#define _USE_MATH_DEFINES
#define MULTITEST !true
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define inf (1e9)
#define INF (1e18)
#define all(a) a.begin(), a.end()
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pii;
typedef vector<ll> vi;
typedef vector<bool> vb;
typedef vector<pii> vp;
int primes[10000];
vi divisorSums(100100);
void sieve() {
  ll mx = 1e5 + 100;
  vb used(mx, true);
  used[0] = used[1] = false;
  for (ll i = 2; i <= mx; i++)
    if (used[i], 1ll * i * 1ll * i <= mx)
      for (ll j = i * i; j <= mx; j += i)
        used[j] = false;
  int ind = 0;
  for (int i = 0; i <= mx; i++)
    if (used[i])
      primes[ind++] = i;
}
vector<pair<int, int>> factorization(int a) {
  vector<pair<int, int>> ans;
  int ind = 0;
  while (a != 1) {
    if ((a % primes[ind]) == 0) {
      ans.push_back({primes[ind], 0});
      while ((a % primes[ind]) == 0) {
        a /= primes[ind];
        ans.back().second++;
      }
      return ans;
    }
    ind++;
  }
  return ans;
}
ll binpow(ll a, ll n) {
  ll ans = 1;
  while (n) {
    if (n & 1) ans *= a;
    a *= a;
    n >>= 1;
  }
  return ans;
}
ll sumOfDivisors(int a) {
  vector<pair<int, int>> ans = factorization(a);
  ll res = ll(divisorSums[a / binpow(ans[0].first, ans[0].second)]) * ll((binpow(ans[0].first, ans[0].second + 1) - 1)) / ll(ans[0].first - 1);
  if (res > ll(2e5 + 1000)) res = ll(2e5 + 1000);
  return res;
}
void calculateDivisorsSums() {
  int mx = 1e5 + 10;
  divisorSums[1] = 1;
  for (int i = 2; i < mx; i++)
    divisorSums[i] = sumOfDivisors(i);
  for (int i = 1; i < mx; i++)
    divisorSums[i] -= i;
}




class SegmentTree { 
  int sz;
  vector<vi> t;

  void build(int v, int vl, int vr, vi& a) {
    if (vl == vr) {
        t[v].push_back(a[vl]);
        return;
    }
    int vm = vl + (vr - vl) / 2;
    build(2 * v + 1, vl, vm, a);
    build(2 * v + 2, vm + 1, vr, a);
    merge(t[2 * v + 1].begin(), t[2 * v + 1].end(), t[2 * v + 2].begin(), t[2 * v + 2].end(), back_inserter(t[v]));
  }

  int query(int v, int vl, int vr, int l, int r, int k) {
    if (r < vl || vr < l) return 0;
    if (l <= vl && vr <= r) return t[v].end() - upper_bound(t[v].begin(), t[v].end(), k);
    int vm = vl + (vr - vl) / 2;
    int ansL = query(2 * v + 1, vl, vm, l, r, k);
    int ansR = query(2 * v + 2, vm + 1, vr, l, r, k);
    return ansL + ansR;
  }

public:
  SegmentTree(vi& a) {
    sz = a.size();
    t.resize(5 * sz);
    build(0, 0, sz - 1, a);
  }

  int query(int l, int r, int k) {
    return query(0, 0, sz - 1, l, r, k);
  }
};





void solve() {
  SegmentTree st(divisorSums);
  int q;
  cin >> q;
  while (q--) {
    int l, r, k;
    cin >> l >> r >> k;
    cout << st.query(l, r, k) << "\n";
  } 
}
int main() {
  speed
  sieve();
  calculateDivisorsSums();
  int t = 1;
  if (MULTITEST) cin >> t;
  while (t--) {
    solve();
  }
}